import os
import string
import shutil
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Dictionnaire de l'environnement
#     2. Dictionnaire des arguments generaux
#     3. Dictionnaire des variables de configuration
#     4. Code de retour de l'execution de HOMARD
#
def aster_homard_7 (environnement,dict_arguments,variables_conf,code_retour_exec) :
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien",
                      2 : "Probleme de copie de fichier." }

#
#  print blabla,environnement,dict_arguments,variables_conf,code_retour_exec
  codret = 0
  ModeHOMA = variables_conf["ModeHOMA"]
#
# 2. Dans le cas d'une adaptation, menage des fichiers devenus inutiles
#
  if ModeHOMA == 1 or ModeHOMA == 3 :
#
    Liste = os.listdir(os.getcwd())
    for fic in Liste :
      suffixe = fic[-3:]
      if ( suffixe == "hom" ) or ( suffixe == "MED" ) :
        if ( fic != variables_conf["HOMaiN___fic"] ) and \
           ( fic != variables_conf["HOMaiNP1_fic"] ) and \
           ( fic != variables_conf["CCMaiNP1_fic"] ) :
          if os.path.islink (fic) :
            os.unlink (fic)
          else :
            os.chmod  (fic,0755)
            os.remove (fic)
#          print "Destruction de",fic
#
# 3. Archivage des fichiers
# 3.1. Concatenation dans le fichier de message
#      . de la liste standard    si le niveau d'information est 2
#                             ou si il y a eu un probleme a l'execution
#      . des fichiers de bilan
#      Remarque : je ne sais pas mieux faire que de tout lire et d'imprimer ensuite ...
#
  nivinf = dict_arguments["nivinf"]
  nbiter = string.atoi(variables_conf["NumeIter"])
  nbiterp1 = nbiter + 1
#
  if nivinf == 2 or code_retour_exec != 0 :
    ecrire_ListeStd = 1
    Liste = [variables_conf["ListeStd"]]
  else :
    ecrire_ListeStd = 0
    Liste = [ ]
  saux = variables_conf["PPBasFic"]+"."+variables_conf["NumeIter"]
  if nbiter == 0 :
    Liste.append(saux+".bilan")
  Liste.append(saux+".indic")
  Liste.append(variables_conf["PPBasFic"]+".%d"%nbiterp1+".bilan")
#  print Liste
#
  for fic in Liste :
    if os.path.isfile (fic) :
      fichier = open (fic,'r')
      tout = fichier.read()
      fichier.close()
      print tout
#
# 3.2. Affichage de smesures de temps de calcul, si le fichier complet n'a pas dej t crit
#
  if not ecrire_ListeStd :
    Message="\n.......................................................................\n"
    fic = variables_conf["ListeStd"]
    if os.path.isfile (fic) :
      fichier = open (fic,'r')
      tout = fichier.readlines()
      fichier.close()
      for ligne in tout :
        chaines = string.split(ligne)
        jaux = len(chaines)
        if jaux >= 8 :
          if chaines[1] == 'Temps' or chaines[1] == 'Soit' :
            Message = Message + ligne
    Message = Message + ":.....................................................................:\n"
    print Message
#
# 3.3. Archivage du fichier de configuration
#      Remarque : il faut copier et non pas renommer car on en a encore besoin
#
  if dict_arguments["PERSO"] == "oui" :
    fic_conf = environnement["fic_conf"]
    if ModeHOMA == 1 :
      saux = ".%d"%nbiterp1
    else :
      saux = ".info"
    codret_partiel = [0]
    try :
      fic = fic_conf+"."+variables_conf["NumeIter"]+saux
      shutil.copyfile(fic_conf,fic)
    except os.error,codret_partiel :
      print "Probleme pour copier le fichier",fic_conf,"dans",fic
      print "Code d'erreur de copyfile : ",codret_partiel[0], ":",codret_partiel[1]
      codret = 2
#
# 4. La fin
#
  if codret != 0 :
    print blabla, messages_erreur[codret]
#
  return codret
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  E1={ "fic_donn" : "DONN", "fic_conf" : "HOMARD.Configuration" }
  A1={'PERSO': "non", 'nivinf': 2 }
  V1={'NumeIter': '3', 'PPBasFic': 'INFO', 'ModeHOMA': 2, 'ListeStd': 'aster_homard_7.py' }
  L1_refe=0
  L1_calc=aster_homard_7 (E1,A1,V1,0)
  verif ("Test sur L1",L1_refe,L1_calc)
#
  E2={ "fic_donn" : "DONN", "fic_conf" : "HOMARD.Configuration" }
  A2={'PERSO': "oui", 'nivinf': 1 }
  V2={'NumeIter': '3', 'PPBasFic': 'INFO', 'ModeHOMA': 2, 'ListeStd': 'gabuzome' }
  L2_refe=0
  L2_calc=aster_homard_7 (E2,A2,V2,8)
  verif ("Test sur L2",L2_refe,L2_calc)
