import os
import tempfile
#
#
########################## Debut de la fonction ##################################
#
# supprime un rpertoire apres avoir fait le menage interne
#  code de retour : 0 : Tout va bien
#                   1 : Ce n'est pas un rpertoire
#                   2 : Impossible d'y aller
#                   3 : Impossible de faire la liste des fichiers
#                   4 : Impossible de supprimer un lien sur un fichier ou un rpertoire
#                   5 : Impossible de changer les droits sur un fichier
#                   6 : Impossible de dtruire un fichier
#                  10 : Impossible de dtruire un rpertoire
#
def tue_rep (nomrep) :
#  print "\nArguments a l'entree de",__name__,":",nomrep
#
# 1. C'est un rpertoire
#
  if os.path.isdir(nomrep) :
#
    erreur = 0
#
# 1.1. Menage des fichiers contenus dans le rpertoire
#
    err=[0]
    try :
      os.chmod  (nomrep,0755)
    except os.error,err :
      print "Probleme au chmod, erreur numro ", err[0], ":", err[1]
      erreur = 1
#
    Liste = [ ]
    if not erreur :
      err=[0]
      try :
        Liste = os.listdir(nomrep)
      except os.error,err :
        print "Probleme au listdir, erreur numro ", err[0], ":", err[1]
        erreur = 3
#    
    for nomfic in Liste :
      fic_total = os.path.join(nomrep,nomfic)
#
      if os.path.islink (fic_total) :
#        print "... passage par le os.path.islink pour ",nomfic," : ",fic_total
        err=[0]
        try :
          os.unlink (fic_total)
        except os.error,err :
          print "Probleme au unlink, erreur numro ", err[0], ":", err[1]
          erreur = 4
          break
#
      elif os.path.isdir(fic_total) :
#        print "... passage par le os.path.isdir pour ",nomfic," : ",fic_total
        erreur = tue_rep(fic_total)
        if erreur :
          break
#
      else :
#        print "... passage par le else pour ",nomfic," : ",fic_total
        err=[0]
        try :
          os.chmod  (fic_total,0755)
        except os.error,err :
          print "Probleme au chmod, erreur numro ", err[0], ":", err[1]
          erreur = 5
          break
        err=[0]
        try :
          os.remove (fic_total)
        except os.error,err :
          print "Probleme au remove, erreur numro ", err[0], ":", err[1]
          erreur = 6
          break
#
# 1.2. Menage du rpertoire lui-meme
#
    if not erreur :
      err=[0]
      try :
        os.rmdir (nomrep)
      except os.error,err :
        print "Probleme au rmdir, erreur numro ", err[0], ":", err[1]
        erreur = 10
#
# 2. Ce n'est pas un rpertoire ?
#
  else :
#
    print nomrep,"n'est pas un rpertoire."
    erreur = 1
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
# cree un repertoire de travail
#   Argument obligatoire :
#     1. Dictionnaire de l'environnement  enrichir
#
#     On y mettra le nom du repertoire de travail cree
#
#  code de retour : 0 : tout va bien
#                   1 : probleme
#
def cree_rep_trav (environnement) :
#  print "Arguments a l'entree de",__name__,":",environnement
#
# 1. Creation du repertoire
#
  rep_trav = tempfile.mktemp()
#  print "Creation du repertoire",rep_trav
  os.mkdir (rep_trav)
#
  environnement ["rep_trav"] = rep_trav
#
  codret = 0
#
  environnement ["code_de_retour"] = codret
  return environnement
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
#   On veut  fic_arrivee --> fic_depart
#   c'est a dire la commande UNIX : ln -s $fic_depart $fic_arrivee
#
#   Arguments obligatoire :
#     1. Fichier depart du lien : c'est le "vrai" fichier
#     2. Fichier arrivee du lien : c'est le lien
#   Arguments optionnel :
#     3. D pour detruire le fichier de depart. Par defaut, on n'y touche pas
#
#
def lien (fic_depart="d",fic_arrivee="d",destruction="non") :
#  print "Arguments a l'entree de",__name__,":",fic_depart,fic_arrivee,destruction
#
#  code de retour :
  messages_erreur = { 0 : "Tout va bien",
                      1 : "Suppression de lien impossible.",
                      2 : "Destruction de fichier impossible.",
                      3 : "Impossible de creer le lien symbolique." }
#
  codret = 0
#
  while codret == 0 :
#
    codret_partiel = [0]
#
# 1. Destruction du fichier d'arrivee
#
# 1.1. C'est un lien
#
    if os.path.islink(fic_arrivee) :
      try :
        os.unlink(fic_arrivee)
      except os.error,codret_partiel :
        print "Probleme a la suppression du lien sur le fichier d'arrivee",fic_arrivee
        print "Code d'erreur de unlink : ",codret_partiel[0], ":",codret_partiel[1]
        codret = 1
        break
#
# 1.2. C'est un vrai fichier
#
    if os.path.isfile(fic_arrivee) :
      try :
        os.remove(fic_arrivee)
      except os.error,codret_partiel :
        print "Probleme a la destruction du fichier d'arrivee",fic_arrivee
        print "Code d'erreur de remove : ",codret_partiel[0], ":",codret_partiel[1]
        codret = 2
        break
#
# 2. Destruction eventuelle du fichier de depart
#
    if destruction != "non" :
      if os.path.isfile(fic_depart) :
        try :
          os.remove(fic_depart)
        except os.error,codret_partiel :
          print "Probleme a la destruction du fichier de depart",fic_depart
          print "Code d'erreur de remove : ",codret_partiel[0], ":",codret_partiel[1]
          codret = 2
          break
#
# 3. On peut faire le lien
#
    try :
      os.symlink(fic_depart,fic_arrivee)
    except os.error,codret_partiel :
      print "Probleme au lien entre",fic_depart,"et",fic_arrivee
      print "Code d'erreur de symlink : ",codret_partiel[0], ":",codret_partiel[1]
      codret = 3
      break
#
    break
#
# 4. La fin
#
  if codret != 0 :
    print messages_erreur[codret]
#
  return codret
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Nom de la commande a executer
#
#   Au retour on a 0 ou 1 selon que cela a marche ou non
#
def exec_commande (arguments):
#  print "Arguments a l'entree de",__name__,":",arguments
#
# 1. Execution
#
  commande = arguments[0:]
  codret = os.system (commande)
#
# 3. La fin
#
  if codret != 0 :
    print "\nDans le repertoire :",os.getcwd()
#gn    print "Contenu du repertoire :",os.listdir(os.getcwd())
    print "Erreur a l'execution de :",commande
    print "Code de retour :",codret
##    print os.strerror(codret)
    codret = 1
#
  return codret
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Texte a afficher
#     2. Resultat de reference
#     3. Resultat a comparer
#
def verif (texte,reference,calcul):
###  print "Reference :",reference
###  print "Calcul    :",calcul,"\n"
  if reference == calcul :
    print texte," : OK\n"
  else :
    type_objet = type(calcul)
#    print type_objet
    D = { }
    if type_objet == type(D) :
      for cle in reference.keys():
        if not calcul.has_key(cle):
          print cle, "est present dans la rfrence, mais pas dans le calcul."
        else : 
          if reference[cle] != calcul[cle] :
            print "Pour ",cle," : Reference = ",reference[cle]
            print "Pour ",cle," : Calcul    = ",calcul[cle]
      for cle in calcul.keys():
	if not reference.has_key(cle):
          print cle, "est present dans le calcul, mais pas dans la rfrence."
    else : 
      print "Reference :",reference
      print "Calcul    :",calcul,"\n"
    print texte," : ECHEC\n"
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  import tempfile
  nomtemp = "/tagada/tsoin/tsoin"
  print tue_rep(nomtemp)
#
  nomtemp = tempfile.mktemp()
  print "Creation du repertoire",nomtemp
  os.mkdir(nomtemp)
  print tue_rep(nomtemp)
  print "Destruction du repertoire",nomtemp
#
  print lien ("/tmp/toto","/tmp/tutu")
#
  print lien ("/tmp/toto","/tmp/tutu","oui")
#
  L1="ls -ltr $HOME"
  L1_refe=0
  L1_calc=exec_commande(L1)
  verif ("Test sur exec_commande avec "+L1,L1_refe,L1_calc)
#
  D3={ }
  D3_refe={'code_de_retour': 0, 'rep_trav': '/tmp' }
  D3_calc=cree_rep_trav(D3)
  verif ("Test sur cree_rep_trav" ,D3_refe,D3_calc)
#
