/*           CONFIGURATION MANAGEMENT OF EDF VERSION                  */
/* MODIF ERFCAM UTILITAI  DATE 23/09/2002   AUTEUR MCOURTOI M.COURTOIS */
/* ================================================================== */
/* COPYRIGHT (C) 1991 - 2001  EDF R&D              WWW.CODE-ASTER.ORG */
/*                                                                    */
/* THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR      */
/* MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS     */
/* PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE */
/* LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                    */
/* THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,    */
/* BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF     */
/* MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU   */
/* GENERAL PUBLIC LICENSE FOR MORE DETAILS.                           */
/*                                                                    */
/* YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE  */
/* ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,    */
/*    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.     */
/* ================================================================== */

#include <math.h>
#if defined CRAY
   double ERFCAM(double *x)
#elif defined SOLARIS || IRIX || P_LINUX || TRU64 || SOLARIS64 
   double erfcam_(double *x)
#elif defined HPUX 
   double erfcam(double *x)
#elif defined PPRO_NT
   double __stdcall ERFCAM(double *x)
#endif
{
#if defined CRAY || SOLARIS || HPUX || IRIX || P_LINUX || TRU64 || SOLARIS64 
  double y;
  y = erfc(*x);
  return(y);
#elif defined PPRO_NT
  extern double __stdcall ERFCFO(double *z);
  double y;
  y = ERFCFO(x);
  return(y);
#endif
}
