      SUBROUTINE AMUMPC(ACTION,KXMPS,VECAS,SOLU,VCINE)
      IMPLICIT NONE
!           CONFIGURATION MANAGEMENT OF EDF VERSION                  
!& MODIF AMUMPC MUMPS  DATE 01/04/2005   AUTEUR VABHHTS J.PELLET 
! ================================================================== 
! COPYRIGHT (C) 1991 - 2005  EDF R&D              WWW.CODE-ASTER.ORG 
!                                                                    
! THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR      
! MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS     
! PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE 
! LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                    
! THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,    
! BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF     
! MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU   
! GENERAL PUBLIC LICENSE FOR MORE DETAILS.                           
!                                                                    
! YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE  
! ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,    
!    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.     
! ================================================================== 
C--------------------------------------------------------------
C CETTE ROUTINE EST UN CLONE DE AMUMPR POUR LES MATRICES COMPLEXES
C
C IN : ACTION :
C     /'PRERES'  : POUR DEMANDER LA FACTORISATION
C     /'RESOUD'  : POUR DEMANDER LA DESCENTE/REMONTEE
C     /'DETR_MAT': POUR DEMANDER LA DESTRUCTION DE L'INSTANCE MUMPS
C                  ASSOCIEE A UNE MATRICE
C
C IN : KXMPS (I)   : INDICE DE L'INSTANCE MUMPS DANS DMPS
C IN : VECAS (K19) : NOM DU SECOND MEMBRE
C            (SI ACTION=RESOUD)
C IN : SOLU  (K19) : NOM DE LA SOLUTION
C            (SI ACTION=RESOUD)
C IN : VCINE (K19) : NOM DU CHAM_NO DE CHARGEMENT CINEMATIQUE
C            (SI ACTION=RESOUD)
C
C
C---------------------------------------------------------------
      CHARACTER*(*) ACTION
      CHARACTER*19  VECAS,SOLU,VCINE,NOSOLV,NOMAT
C================================================================
      INCLUDE 'mpif.h'
      INCLUDE 'dmumps_struc.h'
      INCLUDE 'zmumps_struc.h'
C================================================================
C --- DECLARATIONS NORMALISEES JEVEUX ----------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32, JEXNUM
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C================================================================
      INTEGER NMXINS
      PARAMETER (NMXINS=5)
      TYPE (DMUMPS_STRUC) , TARGET  :: DMPS(NMXINS)
      TYPE (ZMUMPS_STRUC) , TARGET  :: ZMPS(NMXINS)
      TYPE (ZMUMPS_STRUC) , POINTER :: XMPSK
      INTEGER*4 IERR
      INTEGER ISYM,N,NZ,NZ2,JSLVI,JSLVK,JSLVR,ISYMV,ISYMM
      INTEGER I,K,JCOL,ILIG,KTERM,JVECAS,JSOLU,IERD
      INTEGER NLONG, JADIA, NADIA, JHCOL,NHCOL,JVALE,IBID
      INTEGER IDVALC,LMAT,IRET,ITERM,NVALE,JVALE2,IFMUMP
      INTEGER NIV,IFM,KXMPS
      CHARACTER*1 ROUCS(NMXINS),ROUC
      CHARACTER*4 KBID,ETAMS(NMXINS),IMPR,ETAM,TYPM,KCODE
      CHARACTER*14 NU,NONUS(NMXINS),NONU
      CHARACTER*19 MATAS,NOMATS(NMXINS)
      CHARACTER*19 NOSOLS(NMXINS)
      REAL*8 EPSMAX,RBID
      COMPLEX*16 CBID
      LOGICAL LMNSY,LQUALI
      COMMON /SMUMPS/ DMPS,ZMPS,NONUS,NOMATS,NOSOLS,ETAMS,ROUCS
C=================================================================
      CALL JEMARQ()

      CALL ASSERT(KXMPS.GT.0)
      CALL ASSERT(KXMPS.LE.NMXINS)
      NOMAT=NOMATS(KXMPS)
      NOSOLV=NOSOLS(KXMPS)
      NONU=NONUS(KXMPS)
      ETAM=ETAMS(KXMPS)
      XMPSK=>ZMPS(KXMPS)


C     -- IMPR : PARAMETRE POUR IMPRIMER LA MATRICE OU LE SECOND MEMBRE
C               SUR L'UNITE IFMUMP (POUR RESOLUTION EXTERNE)
      IMPR='OUI'
      IMPR='NON'
      IFMUMP=17

      CALL INFNIV(IFM,NIV)


C     0. L'UTILISATEUR VEUT-IL UNE ESTIMATION DE LA QUALITE DE LA SOLUTION ? => LQUALI
C     --------------------------------------------------------------------------------
      CALL JEVEUO(NOSOLV//'.SLVR','L',JSLVR)
      EPSMAX=ZR(JSLVR-1+2)
      LQUALI=(EPSMAX.GT.0.D0)


C     1. PRERES :
      IF (ACTION.EQ.'PRERES') THEN
C     ------------------------------------------------
         XMPSK%COMM = MPI_COMM_WORLD

C        1.2 CALCUL DE ISYM  (XMPSK%SYM):
C        ISYM = 0 => NON-SYMETRIQUE
C        ISYM = 1 => SYMETRIQUE DEFINIE POSITIVE
C        ISYM = 2 => SYMETRIQUE  GENERAL

C        ISYMM DEDUIT DE LA MATRICE :
         CALL JELIRA(NOMAT//'.VALE','DOCU',IBID,TYPM)
         IF (TYPM.EQ.'MR') THEN
            ISYMM=0
         ELSE IF (TYPM.EQ.'MS') THEN
            ISYMM=2
         ELSE
            CALL ASSERT(.FALSE.)
         END IF

C        PRISE EN COMPTE DE LA VOLONTE DE L'UTILISATEUR
C        => ISYMV
         CALL JEVEUO(NOSOLV//'.SLVK','L',JSLVK)
         IF (ZK24(JSLVK-1+3).EQ.'NONSYM') THEN
            ISYMV=0
         ELSE IF (ZK24(JSLVK-1+3).EQ.'SYMDEF') THEN
            ISYMV=1
         ELSE IF (ZK24(JSLVK-1+3).EQ.'SYMGEN') THEN
            ISYMV=2
         ELSE IF (ZK24(JSLVK-1+3).EQ.'AUTO') THEN
            ISYMV=-1
         ELSE
            CALL ASSERT(.FALSE.)
         END IF

         IF (ISYMV.EQ.-1) THEN
            ISYM=ISYMM
         ELSE IF (ISYMV.EQ.0) THEN
            ISYM=ISYMV
         ELSE
            IF (ISYMM.EQ.0) THEN
              CALL UTMESS('F','TYPE_RESOL INTERDIT:'//ZK24(JSLVK-1+3)
     &            //' POUR UNE MATRICE NON-SYMETRIQUE')
            ELSE
              ISYM=ISYMV
            END IF
         END IF


         XMPSK%SYM = ISYM
         XMPSK%PAR = 1
         XMPSK%JOB = -1
         CALL ZMUMPS(XMPSK)
         CALL ASSERT(XMPSK%MYID.EQ.0)


C        CHOIX ICNTL :
C        --------------
C        ICNTL(1,2,3) : UNITES LOGIQUES POUR LES MESSAGES
         XMPSK%ICNTL(1) = IFM
         XMPSK%ICNTL(2) = 0
         XMPSK%ICNTL(3) = 0

C        ICNTL(4) : NIVEAU DES MESSAGES (DEFAUT=1):
         XMPSK%ICNTL(4) = 1
         IF (NIV.GT.1) THEN
            XMPSK%ICNTL(4) = 2
            XMPSK%ICNTL(3) = IFM
         END IF
C        ICNTL(5) : FORMAT MATRICE   0 -> ASSEMBLEE
         XMPSK%ICNTL(5) = 0

C        ICNTL(14) % DE MEMOIRE SUPPL. POUR PIVOTAGE (DEFAUT:15 A 20)
         CALL JEVEUO(NOSOLV//'.SLVI','L',JSLVI)
         XMPSK%ICNTL(14) = ZI(JSLVI-1+2)


C        1.3 ALLOCATION ET REMPLISSAGE DE %IRN ET %ICN ET %A:
C        -------------------------------------------------------
         IF ( XMPSK%MYID.EQ.0) THEN
            CALL JEVEUO(NONU//'.SMOS.ADIA','L',JADIA)
            CALL JELIRA(NONU//'.SMOS.ADIA','LONMAX',NADIA,KBID)
            CALL JEVEUO(NONU//'.SMOS.HCOL','L',JHCOL)
            CALL JELIRA(NONU//'.SMOS.HCOL','LONMAX',NHCOL,KBID)
            N=NADIA
            NZ=ZI(JADIA-1+N)
            CALL ASSERT(NZ.LE.NHCOL)
            XMPSK%N=N

            NZ2=NZ
            IF (XMPSK%SYM.EQ.0) NZ2=2*NZ-N
            XMPSK%NZ=NZ2

            ALLOCATE( XMPSK%IRN ( NZ2 ) )
            ALLOCATE( XMPSK%JCN ( NZ2 ) )

            CALL JELIRA(NOMAT//'.VALE','NMAXOC',NVALE,KBID)
            IF (NVALE.EQ.1) THEN
               LMNSY=.FALSE.
            ELSE IF (NVALE.EQ.2) THEN
               LMNSY=.TRUE.
            ELSE
               CALL ASSERT(.FALSE.)
            END IF

            CALL JEVEUO(JEXNUM(NOMAT//'.VALE',1),'L',JVALE)
            CALL JELIRA(JEXNUM(NOMAT//'.VALE',1),'LONMAX',
     &                NLONG,KBID)
            CALL ASSERT(NLONG.EQ.NZ)
            IF (LMNSY) THEN
               CALL JEVEUO(JEXNUM(NOMAT//'.VALE',2),'L',JVALE2)
               CALL JELIRA(JEXNUM(NOMAT//'.VALE',2),'LONMAX',
     &                NLONG,KBID)
               CALL ASSERT(NLONG.EQ.NZ)
            END IF
            ALLOCATE(XMPSK%A(NZ2))

            JCOL=1
            ITERM=0
            DO KTERM = 1, NZ
               IF (ZI(JADIA-1+JCOL).LT.KTERM) JCOL=JCOL+1
               ILIG=ZI(JHCOL-1+KTERM)

               IF (XMPSK%SYM.GT.0) THEN
                 ITERM=ITERM+1
                 XMPSK%IRN(ITERM)=ILIG
                 XMPSK%JCN(ITERM)=JCOL
                 XMPSK%A(ITERM)=ZC(JVALE-1+KTERM)
               ELSE
                 IF (ILIG.NE.JCOL) THEN
                   ITERM=ITERM+1
                   XMPSK%IRN(ITERM)=ILIG
                   XMPSK%JCN(ITERM)=JCOL
                   IF (LMNSY) THEN
                      XMPSK%A(ITERM)=ZC(JVALE-1+KTERM)
                      XMPSK%A(ITERM)=ZC(JVALE2-1+KTERM)
                   ELSE
                      XMPSK%A(ITERM)=ZC(JVALE-1+KTERM)
                   END IF
                   ITERM=ITERM+1
                   XMPSK%IRN(ITERM)=JCOL
                   XMPSK%JCN(ITERM)=ILIG
                   IF (LMNSY) THEN
                      XMPSK%A(ITERM)=ZC(JVALE-1+KTERM)
                      XMPSK%A(ITERM)=ZC(JVALE2-1+KTERM)
                   ELSE
                      XMPSK%A(ITERM)=ZC(JVALE-1+KTERM)
                   END IF
                 ELSE
                   ITERM=ITERM+1
                   XMPSK%IRN(ITERM)=ILIG
                   XMPSK%JCN(ITERM)=ILIG
                   XMPSK%A(ITERM)=ZC(JVALE-1+KTERM)
                 END IF
               END IF
            END DO
            CALL ASSERT(ITERM.EQ.NZ2)
            CALL ASSERT(ILIG.EQ.N)
            CALL ASSERT(JCOL.EQ.N)
            CALL JELIBE(NONU//'.SMOS.ADIA')
            CALL JELIBE(NONU//'.SMOS.HCOL')
            CALL JELIBE(JEXNUM(NOMAT//'.VALE',1))
            IF (LMNSY) CALL JELIBE(JEXNUM(NOMAT//'.VALE',2))

C           IMPRESSION DE LA MATRICE (SI DEMANDEE) :
C           ----------------------------------------------
            IF (IMPR.EQ.'OUI') THEN
              WRITE(IFMUMP,*) XMPSK%SYM,'   : SYM'
              WRITE(IFMUMP,*) XMPSK%N,'   : N'
              WRITE(IFMUMP,*) XMPSK%NZ,'   : NZ'
              DO K=1,NZ2
                WRITE(IFMUMP,*) XMPSK%IRN(K),
     &               XMPSK%JCN(K),XMPSK%A(K)
              END DO
              WRITE(IFMUMP,*) 'MUMPS FIN A'
            END IF
          END IF

C         1.4  FACTORISATION SYMBOLIQUE :
C         -----------------------------
          XMPSK%JOB = 1
          CALL ZMUMPS(XMPSK)
          IF(XMPSK%MYID.EQ.0) CALL ASSERT(XMPSK%INFOG(1).EQ.0)


C        1.5  FACTORISATION NUMERIQUE :
C        -----------------------------
         XMPSK%JOB = 2
         CALL ZMUMPS(XMPSK)
         IF (NIV.GT.1) THEN
           WRITE(IFM,*)'MUMPS FACT ESPACE OCC. (MOCTET)=',
     &                  XMPSK%INFOG(19)
           WRITE(IFM,*)'MUMPS FACT NB OPERATIONS=',
     &                  XMPSK%RINFOG(2)+  XMPSK%RINFOG(3)
         END IF
         IF(XMPSK%MYID.EQ.0) THEN
            IF (XMPSK%INFOG(1).EQ.0) THEN
C              -- C'EST OK
            ELSE IF (XMPSK%INFOG(1).EQ.-9) THEN
               CALL UTMESS('F','AMUMPS','DIFFICULTE POUR FACTORISER :'
     &                 //'AUGMENTER LA VALEUR DE SOLVEUR/PCENT_PIVOT.')
            ELSE
               CALL CODENT(XMPSK%INFOG(1),'D',KCODE)
               CALL UTMESS('F','AMUMPS','PB FACTORISATION :'
     &                 //' INFOG(1)=',KCODE)
            END IF

            IF (.NOT.LQUALI) THEN
               DEALLOCATE(XMPSK%A)
               DEALLOCATE(XMPSK%IRN)
               DEALLOCATE(XMPSK%JCN)
            END IF

         END IF
      END IF


C  2- RESOUD :
      IF (ACTION.EQ.'RESOUD') THEN
C     --------------------------------
C        SOLUTION HAS BEEN ASSEMBLED ON THE HOST
         IF ( XMPSK%MYID .EQ. 0 ) THEN

C           -- QUELQUES VERIFICATIONS :
            CALL ASSERT(ETAM.EQ.'FNUM')
            CALL DISMOI('F','NOM_NUME_DDL',NOMAT,
     &           'MATR_ASSE',IBID,NU,IERD)
            CALL ASSERT(NU.EQ.NONU)

            N=XMPSK%N
            ALLOCATE(XMPSK%RHS(N))

            CALL JEVEUO(VECAS//'.VALE','L',JVECAS)
            CALL JELIRA(VECAS//'.VALE','LONMAX',NLONG,KBID)
            CALL ASSERT(N.EQ.NLONG)

C           -- PRISE EN COMPTE DU CONDITIONNEMENT DES LAGRANGES :
            CALL MTDSCR(NOMAT)
            CALL JEVEUO(NOMAT//'.&INT','L',LMAT)
            CALL MCCONL(LMAT,0,'C',ZC(JVECAS),1)

C           -- PRISE EN COMPTE DES CHARGES CINEMATIQUES :
            CALL JEEXIN(VCINE//'.VALE',IRET)
            IF ( VCINE.NE.' '.AND.IRET.NE.0)THEN
               CALL JEVEUO(VCINE//'.VALE','L',IDVALC)
               CALL JELIRA(VCINE//'.VALE','TYPE',IBID,ROUC)
               CALL ASSERT(ROUC.EQ.'C')
               CALL CSMBGG(LMAT,RBID,RBID,ZC(JVECAS),ZC(IDVALC),'C')
            END IF



C           -- RECOPIE DE VECAS DANS %RHS:
            DO K=1,N
               XMPSK%RHS(K)=ZC(JVECAS-1+K)
            END DO
            CALL JELIBE(VECAS//'.VALE')

C           IMPRESSION DU SECOND MEMBRE (SI DEMANDE) :
C           ----------------------------------------------
            IF (IMPR.EQ.'OUI') THEN
              DO K=1,N
                WRITE(IFMUMP,*) XMPSK%RHS(K)
              END DO
              WRITE(IFMUMP,*) 'MUMPS FIN RHS'
            END IF
         END IF

C   ICNTL(10)  POUR DEMANDER D'EVENTUELLES ITERATIONS DE RAFFINEMENT :
         XMPSK%ICNTL(10) = 0

C   ICNTL(11)  POUR OBTENIR DES INFOS SUR LA QUALITE DE LA SOLUTION:
C   IL FAUT METTRE ICNTL(11)=0 POUR AVOIR DE MEILLEURES "PERFS"
         XMPSK%ICNTL(11) = 0
         IF (LQUALI)  XMPSK%ICNTL(11) = 1

         XMPSK%JOB = 3
         CALL ZMUMPS(XMPSK)
         IF (NIV.GT.1) THEN
           WRITE(IFM,*)'MUMPS RESOL NORME INF. MATRICE =',
     &                  XMPSK%RINFOG(4)
           WRITE(IFM,*)'MUMPS RESOL NORME SOLUTION =',
     &                  XMPSK%RINFOG(5)
           WRITE(IFM,*)'MUMPS RESOL NORME RESIDU =',
     &                  XMPSK%RINFOG(6)
           WRITE(IFM,*)'MUMPS RESOL ERREUR SOLUTION 1 =',
     &                  XMPSK%RINFOG(7)
           WRITE(IFM,*)'MUMPS RESOL ERREUR SOLUTION 2 =',
     &                  XMPSK%RINFOG(8)
           WRITE(IFM,*)'MUMPS RESOL ERREUR SOLUTION (RELA) =',
     &                  XMPSK%RINFOG(9)
           WRITE(IFM,*)'MUMPS RESOL CONDITIONNEMENT 1 =',
     &                  XMPSK%RINFOG(10)
           WRITE(IFM,*)'MUMPS RESOL CONDITIONNEMENT 2 =',
     &                  XMPSK%RINFOG(11)
           WRITE(IFM,*)'MUMPS RESOL NB ITER REFINEMENT=',
     &                  XMPSK%INFOG(15)
           WRITE(IFM,*)'MUMPS RESOL NB PIVOT DELAYED=',
     &                  XMPSK%INFOG(13)
           WRITE(IFM,*)'MUMPS RESOL NB PIVOT NEGATIFS=',
     &                  XMPSK%INFOG(12)
         END IF


C        -- CONTROLE DE L'ERREUR SUR LA SOLUTION :
         IF (LQUALI) THEN
            IF (XMPSK%RINFOG(9).GT.EPSMAX) CALL UTMESS('F',
     &        'AMUMPS', 'SOLUTION DU SYSTEME LINEAIRE TROP IMPRECISE.')
         END IF

C        -- RECOPIE DE %RHS DANS SOLU (PROCESSOR 0)
         IF ( XMPSK%MYID .EQ. 0 ) THEN
            CALL ASSERT(XMPSK%INFOG(1).EQ.0)
            CALL JEVEUO(SOLU//'.VALE','E',JSOLU)
            CALL JELIRA(SOLU//'.VALE','LONMAX',NLONG,KBID)
            CALL ASSERT(N.EQ.NLONG)
            DO K=1,N
               ZC(JSOLU-1+K)=XMPSK%RHS(K)
            END DO
            CALL MCCONL(LMAT,0,'C',ZC(JSOLU),1)
            CALL JELIBE(SOLU//'.VALE')
            DEALLOCATE( XMPSK%RHS)
         END IF
      END IF


C  3- DETR_MAT :
      IF (ACTION.EQ.'DETR_MAT') THEN
C     --------------------------------
         IF (NOMATS(KXMPS).NE.' ') THEN
            CALL JEVEUO(NOSOLS(KXMPS)//'.SLVR','L',JSLVR)
            EPSMAX=ZR(JSLVR-1+2)
            LQUALI=(EPSMAX.GT.0.D0)
            IF (LQUALI) THEN
               DEALLOCATE(XMPSK%A)
               DEALLOCATE(XMPSK%IRN)
               DEALLOCATE(XMPSK%JCN)
            END IF

            ETAMS(KXMPS)=' '
            NONUS(KXMPS)=' '
            NOMATS(KXMPS)=' '
            NOSOLS(KXMPS)=' '
            ROUCS(KXMPS)=' '

C           DESTROY THE INSTANCE (DEALLOCATE INTERNAL DATA STRUCTURES)
            XMPSK%JOB = -2
            CALL ZMUMPS(XMPSK)
         END IF
      END IF

      CALL JEDEMA()

      END
