      SUBROUTINE CALBET(NOMA,POSMA,DEPPLU,XI,YI,LAMBDA,NEWGEO,DEFICO)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/08/2002   AUTEUR ADBHHPM P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
      IMPLICIT NONE
      INTEGER POSMA
      REAL*8 LAMBDA,XI,YI
      CHARACTER*8 NOMA
      CHARACTER*24  DEPPLU,NEWGEO,DEFICO
C.......................................................................

C BUT: CALCUL DE MULTIPLUCATEUR DE CONTACT D'UN PC

C ENTREES  ---> NOMA   : MAILLAGE
C          ---> POSMA  : INDICE DE LA MAILLE DANS CONTAMA
C          ---> XI,YI  : COORDONNES BARYCENTRIQUE DU PC
C          ---> DEPPLU : NOUVEAU DEPLACEMENT

C SORTIES  <--- LAMBDA : MULTIPLICATEUR DE CONTACT

C ...............................................................
C   DECLARATION JEVEUX
C.......................................................................

      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C.......................................................................
C FIN DECLARATION JEVEUX
C.......................................................................

      INTEGER JNOCO,JMACO,JNOMA,JPONO,NUMA,IATYMA,JCOOR
      INTEGER NUTYP,ITYP,NNO,JDEC,INO,NO(9),POSNNO(9),J
      INTEGER JCNSV2
      REAL*8 FF(9)
      REAL*8 MRCON(9)
      CHARACTER*8 ALIAS
      CHARACTER*19 CNS1,CNS2
      CHARACTER*24 CONTMA,CONTNO,NOMACO,PNOMA
C----------------------------------------------------------------------

      CALL JEMARQ()

C --- TYPE DE LA MAILLE MAITRE DE NUMERO ABSOLU NUMA
C     SEG2=2  SEG3=4  TRIA3=7 TRIA6=9  QUAD4=12  QUAD8=14  QUAD9=16

      CONTNO = DEFICO(1:16)//'.NOEUCO'
      NOMACO = DEFICO(1:16)//'.NOMACO'
      PNOMA  = DEFICO(1:16)//'.PNOMACO'
      CONTMA = DEFICO(1:16)//'.MAILCO'
C
      CALL JEVEUO(CONTNO,'L',JNOCO)
      CALL JEVEUO(NOMACO,'L',JNOMA)
      CALL JEVEUO(PNOMA,'L',JPONO)
      CALL JEVEUO(CONTMA,'L',JMACO)
      NUMA = ZI(JMACO+POSMA-1)
      CALL JEVEUO(NOMA//'.TYPMAIL','L',IATYMA)
      ITYP = IATYMA - 1 + NUMA
      NUTYP = ZI(ITYP)
      IF (NUTYP.EQ.2) THEN
        ALIAS(1:3) = 'SG2'
        NNO = 2
      ELSE IF (NUTYP.EQ.4) THEN
        ALIAS(1:3) = 'SG3'
        NNO = 3
      ELSE IF (NUTYP.EQ.7) THEN
        ALIAS(1:3) = 'TR3'
        NNO = 3
      ELSE IF (NUTYP.EQ.9) THEN
        ALIAS(1:3) = 'TR6'
        NNO = 6
      ELSE IF (NUTYP.EQ.12) THEN
        ALIAS(1:3) = 'QU4'
        NNO = 4
      ELSE IF (NUTYP.EQ.14) THEN
        ALIAS(1:3) = 'QU8'
        NNO = 8
      ELSE IF (NUTYP.EQ.16) THEN
        ALIAS(1:3) = 'QU9'
        NNO = 9
      END IF

C   RECUPERATION DE LA GEOMETRIE DES NOEUDS

      CALL JEVEUO(NEWGEO(1:19)//'.VALE','L',JCOOR)
      JDEC = ZI(JPONO+POSMA-1)
      DO 10 INO = 1,NNO
        POSNNO(INO+1) = ZI(JNOMA+JDEC+INO-1)
        NO(INO) = ZI(JNOCO+POSNNO(INO+1)-1)
   10 CONTINUE
C
      CNS1='&&CALBET.CNS1'
      CNS2='&&CALBET.CNS2'
      CALL CNOCNS(DEPPLU,'V',CNS1)
C
      CALL CNSRED(CNS1,NNO,NO,1,'LAGS_C','V',CNS2)
      CALL JEVEUO(CNS2//'.CNSV','L',JCNSV2)
C
      DO 20,INO = 1,NNO
        MRCON(INO) = ZR(JCNSV2-1+NO(INO))
   20 CONTINUE

C---- GEOMETRIE DU PT DE CONTACT  ---------------

      CALL CALFFX(ALIAS,XI,YI,FF)
      LAMBDA = 0.D00
      DO 30 J = 1,NNO
        LAMBDA = FF(J)*MRCON(J) + LAMBDA
   30 CONTINUE
   40 CONTINUE
      CALL DETRSD('CHAM_NO_S',CNS1)
      CALL DETRSD('CHAM_NO_S',CNS2)
      CALL JEDEMA()
      END
