      SUBROUTINE CALFFT(NP1,NP4,NBM,N,DTEXT,FEXT,REFEXT,IMFEXT,
     &                  OMEGAF,AA,BB )
C
C----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/05/96   AUTEUR KXBADNG T.FRIOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C----------------------------------------------------------------------
C DESCRIPTION : CALCULE LES COEFFICIENTS DE FOURIER ASSOCIES A 
C -----------   L'EXCITATION TEMPORELLE FEXT(T), AA ET BB, AINSI QUE    
C               PULSATIONS DE FOURIER OMEGAF
C
C ******************   DECLARATION DES VARIABLES   *********************
C
      IMPLICIT NONE
C
C ARGUMENTS
C ---------
      INTEGER NP1,NP4,NBM,N
      REAL*8 DTEXT
      REAL*8 REFEXT(*), IMFEXT(*)
      REAL*8 FEXT(NP4,*), OMEGAF(*), AA(NP4,*), BB(NP4,*)
C
C VARIABLES LOCALES
C -----------------
C
      INTEGER I,J
      INTEGER N2M1
      REAL*8 R8DEPI,DF
C
C ******************   DEBUT DU CODE EXECUTABLE   **********************
C
      N2M1 = (N/2) - 1
      CALL INITMA(NP4,NP1,AA)
      CALL INITMA(NP4,NP1,BB)
      CALL INITVE(NP4,OMEGAF)
      CALL INITVE(NP4,REFEXT)
      CALL INITVE(NP4,IMFEXT)
C
      DF = 1.0D0 / (DBLE(N)*DTEXT)
C
      DO 1 J=1,NBM
        DO 2 I=1,N
          REFEXT(I) = FEXT(I,J)
          IMFEXT(I) = 0.0D0
 2      CONTINUE
        CALL DFFT00(0, N, REFEXT, IMFEXT)
        DO 5 I=1,N2M1
          AA(I,J) = 2.0D0 * REFEXT(I+1)
          BB(I,J) = -2.0D0 * IMFEXT(I+1)
 5      CONTINUE
 1    CONTINUE
C
      DO 6 I=1,N
      OMEGAF(I) =  R8DEPI() * DF * DBLE(I)
 6    CONTINUE
C
      END
