      SUBROUTINE CFTHM (DEFICO,RESOCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/10/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      CHARACTER*24 DEFICO
      CHARACTER*24 RESOCO
C
C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : NMCOFR
C ----------------------------------------------------------------------
C
C   AFFECTATION DU TABLEAU COEFMU QUI SERVIRA DANS LES ROUTINES DE
C CONTACT DANS LE CAS DE CONDITION UNILATERALE SUR LA PRESSION OU 
C LA TEMPERATURE POUR DES ELEMENTS THM, LE MULTIPLICATEUR MU OBTENU
C LES ROUTINES DE CONTACT DOIT ETRE MULTIPLIE PAR -1 POUR ETRE COHERENT
C AVEC LA MULTIPLICATION PAR -1 DE L'EQUATION HYDRAULIQUE ET DE 
C L'EQUATION THERMIQUE DU PB COUPLE
C
C IN  DEFICO : SD DE DEFINITION DU CONTACT (ISSUE D'AFFE_CHAR_MECA)
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      ZAPPAR
      PARAMETER    (ZAPPAR=3)
      CHARACTER*24 APPARI,NOZOCO,COEFMU,CHAMCO
      INTEGER      JAPPAR,JZOCO,JCMU,JCHAM
      INTEGER      NESCL,IESCL,POSNO,IZONE
C
C ----------------------------------------------------------------------
C
      NOZOCO = DEFICO(1:16)//'.NOZOCO'
      APPARI = RESOCO(1:14)//'.APPARI'
      COEFMU = RESOCO(1:14)//'.COEFMU'
      CHAMCO = DEFICO(1:16)//'.CHAMCO'

      CALL JEVEUO (NOZOCO,'L',JZOCO)
      CALL JEVEUO (APPARI,'L',JAPPAR)
      CALL JEVEUO (COEFMU,'E',JCMU)
      CALL JEVEUO (CHAMCO,'L',JCHAM)

      NESCL = ZI(JAPPAR)
      DO 20 IESCL = 1,NESCL
        POSNO = ZI(JAPPAR+ZAPPAR*(IESCL-1)+1)
        IZONE = ZI(JZOCO+POSNO-1)
        ZR(JCMU+IESCL-1) = 1.D0
        IF ((ZI(JCHAM+IZONE-1).EQ.-2).OR.(ZI(JCHAM+IZONE-1).EQ.-3).OR.
     &      (ZI(JCHAM+IZONE-1).EQ.-4).OR.(ZI(JCHAM+IZONE-1).EQ.-5)) THEN
          ZR(JCMU+IESCL-1) = -1.D0
        END IF
 20   CONTINUE

 99   CONTINUE

      END
