      SUBROUTINE CHSTNL (CHAINE, MODELE, NUMEDD, MATE,   CARELE,
     &                    COMPLU, DEPMOI, DEPDEL, VERESI,
     &                    LISCHA, INSTAP, INSTAM, COMPOR, CARCRI,
     &                    VECELE, VECASS, VECCHA, VITES, ACCEL)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 06/04/2004   AUTEUR DURAND C.DURAND 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C TOLE CRP_21
      IMPLICIT NONE
      CHARACTER*(*) MATE
      CHARACTER*8  CHAINE
      CHARACTER*19 LISCHA
      CHARACTER*24 MODELE, NUMEDD, CARELE, COMPOR, CARCRI,
     &             DEPMOI, DEPDEL, VERESI, COMPLU,
     &             VECCHA, VITES, ACCEL
      REAL*8       INSTAP,INSTAM,PARTPS(3)
C ----------------------------------------------------------------------
C     CALCUL DE LA CHARGE STATIQUE PRECISEE PAR LA CHAINE DE CARACTERES
C 'CHAINE'
C
C IN  INSTAM : INSTANT MOINS
C IN  COMPOR : COMPORTEMENT
C IN  CARCRI : CRITERES DE CONVERGENCE (THETA)
C
C OUT VECCHA : CHAM_NO DES CHARGES
C ----------------------------------------------------------------------
C
      INTEGER        I
      INTEGER TYPESE
      CHARACTER*1   TYPRES
      CHARACTER*4   TYPCAL
      CHARACTER*8 NOPASE
      CHARACTER*8   CHAREF(6)
      CHARACTER*19  LIGRMO
      CHARACTER*24  VECELE, VECASS, FOMULT
      CHARACTER*24  CHARGE, INFCHA, TEMPLU
      CHARACTER*24  VAPRIN
      CHARACTER*24 STYPSE
      REAL*8         R8AUX
C
      DATA CHAREF / 'NON_SUIV', 'SUIVEUSE', 'THERMIQU', 'DIRICHLE',
     &              'FORCELAP', 'FORCEINT' /
      DATA TYPCAL   / 'MECA' /
      DATA TYPESE / 0 /
      DATA STYPSE / ' ' /
C ----------------------------------------------------------------------
C
      LIGRMO = MODELE(1:8)//'.MODELE'
      CHARGE = LISCHA // '.LCHA'
      FOMULT = LISCHA // '.FCHA'
      INFCHA = LISCHA // '.INFC'
      PARTPS(2) = 0.D0
      PARTPS(3) = 0.D0
      TYPRES = 'R'
      DO 1 I = 1 , 6
        IF ( CHAINE .EQ. CHAREF(I) )  GOTO 2
1     CONTINUE
      CALL UTMESS('F','CHSTNL','CHARGE NON TRAITEE: '//CHAINE )
C
2     CONTINUE
      GO TO (10, 20, 30, 40, 50, 60),I
C
 10   CONTINUE
C
      PARTPS(1) = INSTAP
      CALL NMVCEX('TEMP',COMPLU,TEMPLU)
      CALL VECHME ( TYPCAL, MODELE, CHARGE, INFCHA, PARTPS,
     >              CARELE, MATE, TEMPLU, LIGRMO,
     >              VAPRIN, NOPASE, TYPESE, STYPSE,
     >              VECELE )
C*** LES NOMS DE CHAMPS DERIVENT DE: '&&VECHME'
      CALL ASASVE (VECELE,NUMEDD,TYPRES,VECASS)
      CALL ASCOVA('D',VECASS,FOMULT,'INST',INSTAP,TYPRES,VECCHA)
      GOTO 9999
C
20    CONTINUE
      CALL VECGME (MODELE, CARELE, MATE,    CHARGE, INFCHA,
     &             INSTAP, DEPMOI, DEPDEL, VECELE, INSTAM,
     &             COMPOR, CARCRI, ' ',    VITES,  ACCEL)
C*** LES NOMS DE CHAMPS DERIVENT DE: '&&VECGME'
      CALL ASASVE (VECELE,NUMEDD,TYPRES,VECASS)
      CALL ASCOVA('D',VECASS,FOMULT,'INST',INSTAP,TYPRES,VECCHA)
      GOTO 9999
C
30    CONTINUE

      CALL VECTME (MODELE,CARELE,MATE,COMPLU,VECELE)

C*** LES NOMS DE CHAMPS DERIVENT DE: '&&VECTME'
      CALL ASASVE (VECELE,NUMEDD,TYPRES,VECCHA)
      GOTO 9999
C
40    CONTINUE
      CALL VEDIME ( MODELE,CHARGE,INFCHA,INSTAP,TYPRES,
     >              TYPESE, NOPASE, VECELE)
C*** LES NOMS DE CHAMPS DERIVENT DE: '&&VEDIME'
      CALL ASASVE (VECELE,NUMEDD,TYPRES,VECASS)
      CALL ASCOVA('D',VECASS,FOMULT,'INST',INSTAP,TYPRES,VECCHA)
      GOTO 9999
C
50    CONTINUE
      CALL VELAME (MODELE,CHARGE,INFCHA,DEPMOI,VECELE)
C*** LES NOMS DE CHAMPS DERIVENT DE: '&&VELAME'
      CALL ASASVE (VECELE,NUMEDD,TYPRES,VECASS)
      CALL ASCOVA('D',VECASS,FOMULT,'INST',INSTAP,TYPRES,VECCHA)
      GOTO 9999
C
60    CONTINUE
      VECCHA = '&&CHSTNL'
      R8AUX = 1.D0
      CALL ASSVEC ('V',VECCHA,1,VERESI,R8AUX,NUMEDD,'  ','ZERO',1)
C
 9999 CONTINUE
      END
