      SUBROUTINE DELAGL(NUMEDE, SOLVDE, PROELE, RESASS, MONTEE)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 11/02/2003   AUTEUR PBADEL P.BADEL 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C RESPONSABLE PBADEL P.BADEL

      IMPLICIT NONE
      CHARACTER*8   PROELE
      CHARACTER*19  SOLVDE
      CHARACTER*24  NUMEDE, RESASS, MONTEE

C ----------------------------------------------------------------------
C  REACTUALISATION DE VARDEP :  EVOLUTION GLOBALE (LISSAGE)
C ----------------------------------------------------------------------
C IN  NUMEDE  NUME_DDL
C IN  SOLVDE  SOLVEUR
C IN  PROELE  MATRICES ELEMENTAIRES DU PROJECTEUR
C IN  RESASS  RESIDU ASSEMBLE
C OUT MONTEE  DIRECTION DE MONTEE
C ----------------------------------------------------------------------

      INTEGER      IRET
      CHARACTER*24 PROMAT(2)


C    INITIALISATION
      PROMAT(1) = '&&DELAGL.PRDEAS'
      PROMAT(2) = '&&DELAGL.PRDEPR'


C    ASSEMBLAGE ET FACTORISATION DU PROJECTEUR
      CALL ASMATR(1,PROELE,' ',NUMEDE,SOLVDE,' ','ZERO','V',1,PROMAT(1))
      CALL PRERES(SOLVDE, 'V', IRET, PROMAT(2), PROMAT(1))
      IF (IRET.NE.0) CALL UTMESS('F','DELALO',
     &  'MODELE NON LOCAL : PROJECTEUR SINGULIER')


C    LISSAGE DU CHAMP PAR RESOLUTION LINEAIRE
      CALL RESOUD(PROMAT(1), PROMAT(2), RESASS, SOLVDE, ' ', 'V',
     &            MONTEE, MONTEE)

      END
