      SUBROUTINE EDROPC (NDIM, RLAG, CHAMP, LAGR)
     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/07/2003   AUTEUR ADBHHVV V.CANO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2003  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ADBHHVV V.CANO

      IMPLICIT NONE
      INTEGER  NDIM
      REAL*8   RLAG,CHAMP(0:NDIM),LAGR(0: NDIM)

C ********************************************************
C *       INTEGRATION DE LA LOI DE ROUSSELIER NON LOCAL  *
C *        CALCUL DES COEFFICIENTS C1 C2 C3 C4 ET RPM    *
C ********************************************************

C IN  NDIM  : DIMENSION DE L'ESPACE
C IN  RLAG  : PARAMETRE DE PENALISATION DU LAGRANGIEN AUGMENTE
C IN  CHAMP : CHAMPS AUX NOEUDS
C             P0 = B0*P ET 
C             P-GRADIENT = B-GRADIENT*P - P VECTEUR DU CHAMPS AUX NOEUDS
C IN LAGR    : MULTIPLICATEURS DE LAGRANGE : MU-0 ET MU-GRADIENT
      
      INTEGER ITEMAX, JPROLP, JVALEP, NBVALP
      REAL*8  YOUNG,NU,MU,K,SIGY
      REAL*8  SIG1,D,F0,FCR,ACCE
      REAL*8  FONC,EQETR,PM,RPM,PENTEM,PENTE,PREC
      REAL*8  C1,C2,C3,C4(3),LB,LC
      COMMON /EDROU/ YOUNG,NU,MU,K,SIGY,
     &               SIG1,D,F0,FCR,ACCE,
     &               FONC,EQETR,PM,RPM,PENTEM,PENTE,PREC,
     &               C1,C2,C3,C4,LB,LC,
     &               ITEMAX, JPROLP, JVALEP, NBVALP

      INTEGER I
      
      C1 = RLAG*PENTEM
      C2 = LAGR(0) + RLAG*PENTEM*CHAMP(0)
      C3 = PENTEM*(LC**2)*(1.D0+RLAG)
      C4(3)=0.D0
      DO 15 I=1,NDIM
       C4(I) = RLAG*(LC**2)*PENTEM*CHAMP(I)+LAGR(I)
 15   CONTINUE
      RPM=RPM+C1*PM-C2
           
      END
