         SUBROUTINE  EPSTHM(NDDL,NNO,NNOS,DIMDEF,NDIM,NPG,IPOIDS,IVF,
     &               IDFDE,GEOM,DEPLA,NMEC,MECANI,PRESS1,PRESS2,
     &               TEMPE,NP1,NP2,AXI,NVOMAX,NNOMAX,NSOMAX,NBVOS,
     &               VOISIN,P2P1,EPSM)

       IMPLICIT NONE
       INTEGER      NVOMAX,NNOMAX,NSOMAX,CODRET
       INTEGER      VOISIN(NVOMAX,NNOMAX)
       INTEGER      NBVOS(NSOMAX)
       INTEGER      NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,DIMDEF
       INTEGER      NDDL,NMEC,NP1,NP2,NDIM
       INTEGER      MECANI(5),PRESS1(7),PRESS2(7),TEMPE(5)
       REAL*8       GEOM(NDIM,NNO),EPSM(6,NPG),DEPLA(NDDL,NNO)
       REAL*8       DFDI(NNO,3)
       LOGICAL      P2P1,AXI
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 04/01/2005   AUTEUR CIBHHPD L.SALMONA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C TOLE  CRP_21

C.......................................................................
C
C     BUT:  CALCUL  DES DEFORMATIONS MECANIQUES AU POINT DE GAUSS 
C           EN MECANIQUE DES MILIEUX POREUX AVEC COUPLAGE THM 
C.......................................................................
C IN  NDDL    : NOMBRE DE DEGRES DE LIBERTES PAR NOEUD DE L'ELEMENT
C IN  NNO     : NOMBRE DE NOEUDS DE L'ELEMENT
C IN  NNOS    : NOMBRE DE NOEUDS SOMMET DE L'ELEMENT
C IN  DIMDEF  : DIMENSION DU TABLEAU DES DEFORMATIONS GENERALISEES 
C               AU POINT DE GAUSS
C IN  NDIM    : DIMENSION DU PROBLEME
C IN  NPG     : NOMBRE DE POINTS DE GAUSS
C IN  IPOIDS  : ADRESSE DANS ZR DU TABLEAU POIDS(IPG)
C IN  IVF     : ADRESSE DANS ZR DU TABLEAU FF(INO,IPG)
C IN  IDFDE   : ADRESSE DANS ZR DU TABLEAU DFF(IDIM,INO,IPG)
C IN  GEOM    : COORDONEES DES NOEUDS
C IN  DEPLA   : VALEURS DES DEPLACEMENTS AUX NOEUDS
C IN  NMEC    : VARIABLE CARACTERISANT LE MILIEU
C IN  MECANI  : VARIABLE CARACTERISANT LE MILIEU
C IN  PRESS1  : VARIABLE CARACTERISANT LE MILIEU
C IN  PRESS2  : VARIABLE CARACTERISANT LE MILIEU
C IN  TEMPE   : VARIABLE CARACTERISANT LE MILIEU
C IN  NP1     : VAUT 1 SI LA MODELISATION CONTIENT UNE PRESSION 
C               COMME VARIABLE
C IN  NP2     : VAUT 1 SI LA MODELISATION CONTIENT UNE DEUXIEME
C               PRESSION COMME VARIABLE
C IN  AXI     : VRAI SI ELEMENT APPELANT AXI
C IN VOISIN
C  POUR UN SOMMET J DE 1 A NNOS : 
C         VOISIN(1:NDIM,J) =  LES NDIM NOEUDS MILIEUX VOSIN DU SOMMMET
C
C
C  POUR UN MILIEU J DE 1 A NNOS +1 A NNO: 
C         VOISIN(1:2,J) =  LES 2 NOEUDS DU SEGMENT DONT IL EST LE MILIEU
C
C IN  P2P1   : VRAI SI ELEMENT APPELANT P2P1
C
C OUT EPSM  : DEFORMATIONS AUX POINTS DE GAUSS SUR L ELEMENT COURANT
C......................................................................
C


      INTEGER KPG,I,N,J
      REAL*8   POIDS,B(DIMDEF,NDDL*NNO)

      DO 10 KPG=1,NPG
C        CALCUL DE LA MATRICE B AU POINT DE GAUSS
C
         CALL CABTHM(NDDL,NNO,NNOS,
     >               DIMDEF,NDIM,NPG,KPG,IPOIDS,IVF,IDFDE,DFDI,GEOM,
     &               POIDS,B,NMEC,MECANI(1),MECANI(2),PRESS1(1),
     &               PRESS1(3),PRESS2(1),PRESS2(3),TEMPE(1),TEMPE(2),
     &               NP1,NP2,AXI,NVOMAX,NNOMAX,NSOMAX,NBVOS,VOISIN,P2P1)

C
C  CALCUL DES DEFORMATIONS 
C
            DO 108 I=1,6
                EPSM(I,KPG)=0.D0
                DO 109 N=1,NNO
                   DO 110 J=1,NDDL
                      EPSM(I,KPG)=EPSM(I,KPG)
     &                  +B(I+NDIM,(N-1)*NDDL+J)*DEPLA(J,N)
 110               CONTINUE
 109            CONTINUE
 108        CONTINUE
 10   CONTINUE
            END
