      SUBROUTINE FETGGT(NBSD,MATAS,VSDF,VDDL,LRIGID,NBI,NOMGGT,DIMGI,
     &                  NOMGI,STOGI,LSTOGI,MAMOY,INFOFE,IREX,IFM)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 24/01/2005   AUTEUR BOITEAU O.BOITEAU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C-----------------------------------------------------------------------
C    - FONCTION REALISEE:  CALCUL DES MATRICES GI ET (GI)T * GI
C
C      IN  MATAS: K19  : NOM DE LA MATRICE DE RIGIDITE GLOBALE 
C      IN   VSDF: VIN  : VECTEUR MATR_ASSE.FETF INDIQUANT SI 
C                         SD FLOTTANT
C      IN   NBSD: IN   : NOMBRE DE SOUS-DOMAINES
C      IN   VDDL: VIN  : VECTEUR DES NBRES DE DDLS DES SOUS-DOMAINES
C     OUT LRIGID: LO  : LOGICAL INDIQUANT LA PRESENCE D'AU MOINS UN
C         SOUS-DOMAINES FLOTTANT
C      IN    NBI: IN   : NOMBRE DE NOEUDS D'INTERFACE
C      IN NOMGGT: CH24: NOMS DE OBJ. JEVEUX CONTENANT GIT*GI
C     OUT DIMGI:  IN : TAILLE DE GIT*GI
C      IN NOMGI: CH24: NOMS DE OBJ. JEVEUX CONTENANT GI (EVENTUELLEMENT)
C      IN STOGI: CH24: PARAMETRE DE STOCKAGE DE GI
C     OUT LSTOGI: LO : TRUE, GI STOCKE, FALSE, RECALCULE
C      IN MAMOY: IN : CRITERE DE STOCKAGE DE GI SI STOGI='CAL'
C     IN IREX  : IN    : ADRESSE DU VECTEUR AUXILAIRE EVITANT DES APPELS
C                        JEVEUX. 
C   -------------------------------------------------------------------
C     ASTER INFORMATIONS:
C       01/06/04 (OB): CREATION.
C----------------------------------------------------------------------
C RESPONSABLE BOITEAU O.BOITEAU
C CORPS DU PROGRAMME
      IMPLICIT NONE

C DECLARATION PARAMETRES D'APPELS
      INTEGER      NBSD,VSDF(NBSD),VDDL(NBSD),NBI,DIMGI,MAMOY,IREX,IFM
      CHARACTER*19 MATAS
      CHARACTER*24 NOMGGT,NOMGI,STOGI,INFOFE
      LOGICAL      LRIGID,LSTOGI
      
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      
C DECLARATION VARIABLES LOCALES
      INTEGER      IDD,NBMC,NGI,NGITGI,IDECA3,IMC,
     &             IFETR,NBDDL,K,OPT,IDECAJ,IMC1,JMC,GII,GIJ,IDECAO,
     &             I,J,NBSDF,JGITGI,JDD,IDD1,NBDDLJ,NBMCJ,ICOMPT,
     &             NBSDFJ,IFETRJ,JGI,NBMC1,IDECAI
      REAL*8       DDOT,RAUX
      CHARACTER*24 NOMSDR
      CHARACTER*32 JEXNUM
      
C CORPS DU PROGRAMME
      CALL JEMARQ()
        
C INITS.
      NOMSDR=MATAS//'.FETR'
      LRIGID=.FALSE.
      LSTOGI=.FALSE.
      DIMGI=0
      JGITGI=-1
      
C BOUCLE SUR LES SOUS-DOMAINES POUR CALCULER L'ORDRE DE DE GIT*GI 
      DO 10 IDD=1,NBSD
        NBMC=VSDF(IDD)
        IF (NBMC.NE.-1) DIMGI=DIMGI+NBMC
   10 CONTINUE            
      IF (DIMGI.EQ.0) THEN
C MONITORING
        IF (INFOFE(1:1).EQ.'T')
     &    WRITE(IFM,*)'<FETI/FETGGT> PAS DE MODE DE CORPS RIGIDE'
        GOTO 999
      ELSE
        LRIGID=.TRUE.
        RAUX=DIMGI*NBI  
C DETREMINATION DU STOCKAGE DE GI OU PAS
        IF (STOGI(1:3).EQ.'OUI') THEN
          LSTOGI=.TRUE.
        ELSE IF (STOGI(1:3).EQ.'NON') THEN
          LSTOGI=.FALSE.
        ELSE IF (STOGI(1:3).EQ.'CAL') THEN
          IF (RAUX.LT.MAMOY) THEN
            LSTOGI=.TRUE.
          ELSE
            LSTOGI=.FALSE.        
          ENDIF
        ELSE
          CALL UTMESS('F','FETGGT','VALEUR DE STOGI INCOHERENTE !')     
        ENDIF     
C MONITORING
        IF (INFOFE(1:1).EQ.'T') THEN
          WRITE(IFM,*)'<FETI/FETGGT> NBRE TOTAL DE CORPS RIGIDES',DIMGI
          IF (LSTOGI)
     &      WRITE(IFM,*)'              STOCKAGE GI',LSTOGI,RAUX,MAMOY
        ENDIF      
      ENDIF

C VECTEURS AUXILIAIRES CONTENANT GI ET GIT*GI (STOCKAGE PAR COLONNE
C AVEC SEULEMENT LA PARTIE TRIANGULAIRE INFERIEURE POUR GIT*GI)
      NGITGI=DIMGI*(DIMGI+1)/2
      CALL WKVECT(NOMGGT,'V V R',NGITGI,JGITGI)
      IF (LSTOGI) THEN
        NGI=NBI*DIMGI      
        CALL WKVECT(NOMGI,'V V R',NGI,JGI)      
      ELSE
        CALL WKVECT('&&FETI.GGT.V1','V V R',NBI,GII)
        CALL WKVECT('&&FETI.GGT.V2','V V R',NBI,GIJ)      
      ENDIF
      OPT=1
      NBSDF=0        

      IF (LSTOGI) THEN
C -------------------------------------------------------------------- 
C CONSTITUTION DE (GI)T*GI EN CONSTRUISANT GI
C --------------------------------------------------------------------
C DECALAGE DU VECTEUR OUTPUT DE FETREX (GI)
        IDECAO=JGI
        DO 30 IDD=1,NBSD

          NBDDL=VDDL(IDD)
          NBMC=VSDF(IDD)
                        
          IF (NBMC.NE.-1) THEN
            NBMC1=NBMC-1
            NBSDF=NBSDF+1
            CALL JEVEUO(JEXNUM(NOMSDR,NBSDF),'L',IFETR)          
            IDECAI=IFETR    
            DO 20 IMC=0,NBMC1         
              CALL FETREX(OPT,IDD,NBDDL,ZR(IDECAI),NBI,ZR(IDECAO),IREX)
              IDECAI=IDECAI+NBDDL
              IDECAO=IDECAO+NBI
   20       CONTINUE      
          ENDIF
   30   CONTINUE

C MONITORING
        IF (INFOFE(1:1).EQ.'T')
     &    WRITE(IFM,*)'<FETI/FETGGT> CONSTRUCTION GI'
        IF (INFOFE(4:4).EQ.'T') THEN
          IDECAO=JGI      
          DO 32 J=1,DIMGI
            DO 31 I=1,NBI
              WRITE(IFM,*)'G(I,J)',I,J,ZR(IDECAO)
              IDECAO=IDECAO+1       
   31       CONTINUE
   32     CONTINUE
        ENDIF

C IL ME SEMBLE QU'IL N'Y A PAS DE ROUTINE BLAS EFFECTUANT GT*G AVEC
C G MATRICE RECTANGLE ET LE RESULTAT STOCKE DANS UNE MATRICE TRIANG
C GULAIRE        
        IDECAO=JGITGI
        DO 43 J=1,DIMGI
          IDECAJ=(J-1)*NBI+JGI
          DO 42 I=J,DIMGI           
            IDECAI=(I-1)*NBI+JGI
            ZR(IDECAO)=DDOT(NBI,ZR(IDECAI),1,ZR(IDECAJ),1)
            IDECAO=IDECAO+1
   42     CONTINUE
   43   CONTINUE
     
      ELSE         
C -------------------------------------------------------------------- 
C CONSTITUTION DE (GI)T*GI SANS CONSTRUIRE GI
C --------------------------------------------------------------------
C ----  BOUCLE SUR LES SOUS-DOMAINES

C NOMBRE DE SOUS-DOMAINES FLOTTANTS      
        ICOMPT=-1
        DO 100 IDD=1,NBSD
      
          NBDDL=VDDL(IDD)
          NBMC=VSDF(IDD)
                        
          IF (NBMC.NE.-1) THEN
            NBSDF=NBSDF+1
            IDD1=IDD+1
            CALL JEVEUO(JEXNUM(NOMSDR,NBSDF),'L',IFETR)
            NBSDFJ=NBSDF+1
            DO 90 IMC=1,NBMC
              CALL FETREX(OPT,IDD,NBDDL,ZR(IFETR+(IMC-1)*NBDDL),NBI,
     &                  ZR(GII),IREX)
              ICOMPT=ICOMPT+1     
              ZR(JGITGI+ICOMPT)=DDOT(NBI,ZR(GII),1,ZR(GII),1)
              IMC1=IMC+1
              DO 60 JMC=IMC1,NBMC
                ICOMPT=ICOMPT+1       
                CALL FETREX(OPT,IDD,NBDDL,ZR(IFETR+(JMC-1)*NBDDL),NBI,
     &                    ZR(GIJ),IREX)
                ZR(JGITGI+ICOMPT)=DDOT(NBI,ZR(GII),1,ZR(GIJ),1)
   60         CONTINUE

C ----  BOUCLE SUR LES SOUS-DOMAINES JDD > IDD
              NBSDFJ=NBSDF    
              DO 80 JDD=IDD1,NBSD
                NBDDLJ=VDDL(JDD)
                NBMCJ=VSDF(JDD)
                IF (NBMCJ.NE.-1) THEN
C SOUS-DOMAINE FLOTTANT
                  NBSDFJ=NBSDFJ+1
C COMPOSANTES DES MODES DE CORPS RIGIDES
                  CALL JEVEUO(JEXNUM(NOMSDR,NBSDFJ),'L',IFETRJ)
C ----  BOUCLE SUR LES MODES DE CORPS RIGIDES DE JDD
                  DO 70 JMC=1,NBMCJ         
                    ICOMPT=ICOMPT+1           
                   CALL FETREX(OPT,JDD,NBDDLJ,ZR(IFETRJ+(JMC-1)*NBDDLJ),
     &                NBI,ZR(GIJ),IREX)
                    ZR(JGITGI+ICOMPT)=DDOT(NBI,ZR(GII),1,ZR(GIJ),1)
   70             CONTINUE
                  CALL JELIBE(JEXNUM(NOMSDR,NBSDFJ))
                ENDIF         
   80         CONTINUE                       
   90       CONTINUE
            CALL JELIBE(JEXNUM(NOMSDR,NBSDF))      
          ENDIF
  100   CONTINUE
        CALL JEDETR('&&FETI.GGT.V1')
        CALL JEDETR('&&FETI.GGT.V2')  
      ENDIF

C MONITORING
      IF (INFOFE(1:1).EQ.'T')
     &  WRITE(IFM,*)'<FETI/FETGGT> CONSTRUCTION (GI)T*GI'
      IF (INFOFE(4:4).EQ.'T') THEN
        IDECAO=JGITGI      
        DO 151 J=1,DIMGI
          DO 150 I=J,DIMGI
            WRITE(IFM,*)'GTG(I,J)',I,J,ZR(IDECAO)
            IDECAO=IDECAO+1     
  150     CONTINUE
  151   CONTINUE
      ENDIF
  999 CONTINUE
  
      CALL JEDEMA()  
      END
