      SUBROUTINE INSEQU ( DEFR0 , EPSEQC , EQSTRC )
        IMPLICIT REAL*8 (A-H,O-Z)
C       -----------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 27/03/2002   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C       -----------------------------------------------------------
C   NADAI_B : BETON FISSURE
C             CALCUL APPROCHE DE EPSEQC ET EQSTRC A PARTIR DE DEFR0
C             DEFORMATION ET CONTRAINTE A L INSTANT DE LA
C             DECHARGE (INITIALISATION, APPELLE PAR INSPIF ET INSINF )
C       IN
C           DEFR0     : DEFORMATION UNIAXIALE
C       OUT
C           EPSC , EQSTR , EDC , DEFR0 , IPLA
C       -----------------------------------------------------------
      REAL*8  EPSEQC , EQSTRC , DEFR0
      COMMON /DBETO/ POU1(4),RB,ALPHA,EX,PXY,EMAX,EPST,FTC,FLIM,
     1       EPO, EPO1,POU2(6),ICC,IPOU1(9)
C-------------------------------------------------------------------
        NBIT=200
        PREC=1.D-8
        EPEQ0=ABS(DEFR0)
        EPEQ1=EPO1
        DO 10 I=1,NBIT
          EPEQ=EPEQ0+(EPEQ1-EPEQ0)/2.D0
          SEQ1=EX*(EPEQ-ABS(DEFR0))
          SEQ2=EX*EPEQ/(1.D0+(EX/RB-2.D0/EPO1)*EPEQ+(EPEQ/EPO1)**2)
          CONT=ABS((SEQ1-SEQ2)/SEQ1)
        IF(CONT.LT.PREC) GOTO 20
        IF(SEQ1.GT.SEQ2) THEN
        EPEQ1=EPEQ
        ELSE
          EPEQ0=EPEQ
        ENDIF
 10     CONTINUE
 20     CONTINUE
C
      IF(EPEQ.GT.EPO1) EPEQ=EPO1
      IF(SEQ2.GT.RB) SEQ2=RB
      EPSEQC=-1.D0*EPEQ
      EQSTRC=-1.D0*SEQ2
      DEFR0 = EPSEQC-EQSTRC/EX
C
      END
