      SUBROUTINE MCHMPS(NOMA,GEOM,POSNO,NEWGEO,DEFICO,POSMIN,T1MIN,
     &                 T2MIN,XIMIN,YIMIN)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/08/2002   AUTEUR ADBHHPM P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================

      IMPLICIT NONE

      INTEGER POSNO,POSMIN,IATYMA,ITYP,NUTYP,JCOOR,JPONO
      INTEGER NNO,JNOMA,I
      REAL*8 T1MIN(3),T2MIN(3),XIMIN,YIMIN,GEOM(3),XI,YI
      REAL*8 COOR(30)
      CHARACTER*8 NOMA,ALIAS
      CHARACTER*24 NEWGEO
      CHARACTER*24 DEFICO

C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : RECHME
C ----------------------------------------------------------------------

C RECHERCHE DE LA MAILLE LA PLUS PROCHE CONNAISSANT LE NOEUD LE PLUS
C PROCHE.

C ---->    NOMA   : NOM DU MAILLAGE
C ---->    GEOM   : LES COORDONNEES DU NOEUD ESCLAVE
C ---->    POSNO  : POSITION DU NOEUD MAITRE LE PLUS PROCHE
C ---->    NEWGEO : GEOMETRIE ACTUALISEE EN TENANT COMPTE DU CHAMP DE
C ---->    DEFICO : SD CONTACT

C <----    POSMIN : POSITION DE LA MAILLE MAITRE LA PLUS PROCHE
C <----    T1MIN  : PREMIER VECTEUR TANGENT
C <----    T2MIN  : DEUXIEME VECTEUR TANGENT
C <----    XIMIN,YIMIN: LES 2 COO BARY DU VISAVIS

C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------

      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------

      INTEGER JDEC,JDEC1
      INTEGER JNOCO,JMACO,JMANO,JPOMA,IFM,NIV
      INTEGER POSMA,IMA,NBMA,K
      INTEGER INO,POSNNO(10)
      INTEGER NUMA,NO(9)
      REAL*8 JEU,JEUMIN,R8GAEM,TAU1(3),TAU2(3)
      CHARACTER*24 CONTMA,CONTNO,MANOCO,PMANO,PNOMA,NOMACO

C ----------------------------------------------------------------------

      CALL JEMARQ()
      CALL INFNIV(IFM,NIV)

C --- ADRESSES DES STRUCTURES DE DONNEES


      CONTNO = DEFICO(1:16)//'.NOEUCO'
      CONTMA = DEFICO(1:16)//'.MAILCO'
      NOMACO = DEFICO(1:16)//'.NOMACO'
      MANOCO = DEFICO(1:16)//'.MANOCO'
      PMANO  = DEFICO(1:16)//'.PMANOCO'
      PNOMA  = DEFICO(1:16)//'.PNOMACO'
      PMANO  = DEFICO(1:16)//'.PMANOCO'
C
      CALL JEVEUO(CONTNO,'L',JNOCO)
      CALL JEVEUO(CONTMA,'L',JMACO)
      CALL JEVEUO(MANOCO,'L',JMANO)
      CALL JEVEUO(PMANO, 'L',JPOMA)
      CALL JEVEUO(PNOMA, 'L',JPONO)
      CALL JEVEUO(NOMACO,'L',JNOMA)

C ----------------------------------------------------------------------
C           BOUCLE SUR LES MAILLES CONTENANT LE NOEUD POSNO
C ----------------------------------------------------------------------


C --- BOUCLE SUR LES MAILLES CONTENANT LE NOEUD POSNO2

      NBMA = ZI(JPOMA+POSNO) - ZI(JPOMA+POSNO-1)
      JDEC = ZI(JPOMA+POSNO-1)
      JEUMIN = R8GAEM()
      CALL JEVEUO(NEWGEO(1:19)//'.VALE','L',JCOOR)
      CALL JEVEUO(NOMA//'.TYPMAIL','L',IATYMA)
      DO 64 I=1,30
         COOR(I)=0.D0
64    CONTINUE
      DO 50 IMA = 1,NBMA
        POSMA = ZI(JMANO+JDEC+IMA-1)
        NUMA  = ZI(JMACO+POSMA-1)
        ITYP = IATYMA - 1 + NUMA
        NUTYP = ZI(ITYP)
      IF (NUTYP.EQ.2) THEN
        ALIAS(1:3) = 'SG2'
        NNO = 2
      ELSE IF (NUTYP.EQ.4) THEN
        ALIAS(1:3) = 'SG3'
        NNO = 3
      ELSE IF (NUTYP.EQ.7) THEN
        ALIAS(1:3) = 'TR3'
        NNO = 3
      ELSE IF (NUTYP.EQ.9) THEN
        ALIAS(1:3) = 'TR6'
        NNO = 6
      ELSE IF (NUTYP.EQ.12) THEN
        ALIAS(1:3) = 'QU4'
        NNO = 4
      ELSE IF (NUTYP.EQ.14) THEN
        ALIAS(1:3) = 'QU8'
        NNO = 8
      ELSE IF (NUTYP.EQ.16) THEN
        ALIAS(1:3) = 'QU9'
        NNO = 9
      ELSE
       CALL UTMESS('F','MCHMP','STOP_1')
      END IF

C   RECUPERATION DE LA GEOMETRIE DES NOEUDS

        JDEC1 = ZI(JPONO+POSMA-1)
        DO 10 INO = 1,NNO
          POSNNO(INO+1) = ZI(JNOMA+JDEC1+INO-1)
          NO(INO) = ZI(JNOCO+POSNNO(INO+1)-1)
   10   CONTINUE

C --- COORDONNEES DES NOEUDS DE LA MAILLE MAITRE

        DO 20 I = 1,3
          COOR(I) = GEOM(I)
   20   CONTINUE
        DO 30 INO = 1,NNO
          COOR(3* (INO)+1) = ZR(JCOOR+3* (NO(INO)-1))
          COOR(3* (INO)+2) = ZR(JCOOR+3* (NO(INO)-1)+1)
          COOR(3* (INO)+3) = ZR(JCOOR+3* (NO(INO)-1)+2)
   30   CONTINUE

        CALL MPROJP(ALIAS,XI,YI,COOR,TAU1,TAU2,JEU)

C - CALCUL DE LA PROJECTION SUR LA MAILLE, ET DU JEU MINIMUM ET
C   AU MEME TEMPS LES CORRDONNEES DU PT VIS A VIS ET LES  DEUX
C   VECTEURS TANGENTS

C - SI JEU (AVANT CORRECTION) < JEU MINIMUM, STOCKER LES VALEURS

        IF (JEU.LT.JEUMIN) THEN
          POSMIN = POSMA
          JEUMIN = JEU
          DO 40 K = 1,3
            T1MIN(K) = TAU1(K)
            T2MIN(K) = TAU2(K)
   40     CONTINUE
          XIMIN = XI
          YIMIN = YI
        END IF

   50 CONTINUE


C ----------------------------------------------------------------------

      CALL JEDEMA()
      END
