      SUBROUTINE MISAZL(DEPPLU,DEFICO)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 29/11/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
      IMPLICIT NONE
      CHARACTER*24  DEPPLU,DEFICO
C.......................................................................
C ENTREES  ---> NOMA   : MAILLAGE
C          ---> POSMA  : INDICE DE LA MAILLE DANS CONTAMA
C          ---> XI,YI  : COORDONNES BARYCENTRIQUE DU PC
C          ---> DEPPLU : NOUVEAU DEPLACEMENT

C SORTIES  <--- LAMBDA : MULTIPLICATEUR DE CONTACT

C ...............................................................
C   DECLARATION JEVEUX
C.......................................................................

      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C.......................................................................
C FIN DECLARATION JEVEUX
C.......................................................................

      INTEGER      JNOCO,JNOESC,JDIM,NTNO
      INTEGER      INOE,POSNO,NUNOE,INO,IECPCO
      INTEGER      IBID,COMP,IER,JCNS1B,JCNS1D,JCNS1E,JTAB
      LOGICAL      LCUMUL(4)
      REAL*8       LCOEFR(4)
      CHARACTER*19 CNS1,CNS1B,CNS1C,CNS1D,CNS1E,PRNO,LICHS(4)
      CHARACTER*24 CONTNO,NDIMCO,NOESCL
C----------------------------------------------------------------------

      CALL JEMARQ()


C --- REMPLISSAGE DE NU ABS DES NOEUDS

      CONTNO = DEFICO(1:16)//'.NOEUCO'
      NDIMCO = DEFICO(1:16)//'.NDIMCO'
      NOESCL = DEFICO(1:16)//'.NOESCL'
      CALL JEEXIN(NOESCL,IECPCO)
      IF (IECPCO.EQ.0)  GOTO 110
C
      CALL JEVEUO(NDIMCO,'L',JDIM)
      CALL JEVEUO(CONTNO,'L',JNOCO)
      CALL JEVEUO(NOESCL,'E',JNOESC)
C
C
      NTNO = ZI(JDIM+4)
      COMP = 0
C
C --- TABLEAU TEMPORAIRE
C
      CALL WKVECT('&&MISAZL.NNO','V V I',3*NTNO,JTAB)
C

      DO 10 INOE = 1,NTNO
        POSNO = INOE
        IF (ZR(JNOESC+10*(POSNO-1)+1).NE.(-1.D0)) GOTO 10
        COMP=COMP+1
        NUNOE = ZI(JNOCO+POSNO-1)
        ZI(JTAB+COMP-1) = NUNOE
 10     CONTINUE
C
      CNS1 ='&&MISAZL.CNS1'
      CNS1B='&&MISAZL.CNS1B'
      CNS1C='&&MISAZL.CNS1C'
      CNS1D='&&MISAZL.CNS1D'
      CNS1E='&&MISAZL.CNS1E'

C     CNS1 : CHAMP AUX NOEUDS SIMPLE

      CALL CNOCNS(DEPPLU,'V',CNS1)
      CALL DISMOI('F','PROF_CHNO',DEPPLU,'CHAM_NO',IBID,PRNO,IER)
C
C     CNS1B :CNR LAGS_C
C
      CALL CNSRED(CNS1,COMP,ZI(JTAB),1,'LAGS_C','V',CNS1B)
      CALL CNSRED(CNS1,COMP,ZI(JTAB),1,'LAGS_F1','V',CNS1D)
      CALL CNSRED(CNS1,COMP,ZI(JTAB),1,'LAGS_F2','V',CNS1E)
      CALL JEVEUO(CNS1B//'.CNSV','E',JCNS1B)
      CALL JEVEUO(CNS1D//'.CNSV','E',JCNS1D)
      CALL JEVEUO(CNS1E//'.CNSV','E',JCNS1E)

C     MIAZ

      DO 11,INO = 1,COMP
        ZR(JCNS1B-1+ZI(JTAB+INO-1))=0.D0
        ZR(JCNS1D-1+ZI(JTAB+INO-1))=0.D0
        ZR(JCNS1E-1+ZI(JTAB+INO-1))=0.D0
 11   CONTINUE

      LICHS(1)=CNS1
      LICHS(2)=CNS1B
      LICHS(3)=CNS1D
      LICHS(4)=CNS1E
      LCOEFR(1)=1.D0
      LCOEFR(2)=1.D0
      LCOEFR(3)=1.D0
      LCOEFR(4)=1.D0
      LCUMUL(1)=.FALSE.
      LCUMUL(2)=.FALSE.
      LCUMUL(3)=.FALSE.
      LCUMUL(4)=.FALSE.
C     RESULTAT CNS1C : EST DE TYPE CHAMP AUX NOEUDS SIMPLE

      CALL CNSFUS(4,LICHS,LCUMUL,LCOEFR,'V',CNS1C)

C     CONSTRUCTION DE DEPPLU A PARTIR DE CNS (CNS1C)

      CALL CNSCNO(CNS1C,PRNO,'V',DEPPLU)

      CALL DETRSD('CHAM_NO_S',CNS1)
      CALL DETRSD('CHAM_NO_S',CNS1B)
      CALL DETRSD('CHAM_NO_S',CNS1C)
      CALL DETRSD('CHAM_NO_S',CNS1D)
      CALL DETRSD('CHAM_NO_S',CNS1E)
110    CONTINUE

      CALL JEDETR('&&MISAZL.NNO')
      CALL JEDEMA()
      END
