      SUBROUTINE NMASSE(ICODMA,
     &                  INST,TEMP,
     &                  E,NU,ALPHA,DEUXMU,TROISK)
    
      IMPLICIT NONE
      INTEGER  ICODMA
      REAL*8   INST,TEMP
      REAL*8   E,NU,ALPHA,DEUXMU,TROISK
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 15/06/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C ----------------------------------------------------------------------
C      VISCO_PLASTICITE FLUAGE SOUS IRRADIATION 
C      RECUPERATION DES PARAMETRES VARIABLES (TEMPS/TEMPERATURE)
C      CARACTERISTIQUES ELASTIQUES: YOUNG, POISSON, ALPHA
C
C IN  ICODMA  : ADRESSE DU MATERIAU CODE
C IN  INST    : INSTANT CONSIDERE
C IN  TEMP    : TEMPERATURE CONSIDEREE
C OUT E       : MODULE DE YOUNG A L'INSTANT TEMPS ET 
C               POUR LA TEMPERATURE TEMPE
C OUT NU      : COEFFICIENT DE POISSON A L'INSTANT TEMPS ET 
C               POUR LA TEMPERATURE TEMPE
C OUT ALPHA   : COEFFICIENT DE DILATATION A L'INSTANT TEMPS ET 
C               POUR LA TEMPERATURE TEMPE
C OUT DEUXMU  : COEFFICIENT DE LAME 1 A L'INSTANT TEMPS ET 
C               POUR LA TEMPERATURE TEMPE
C OUT TROISK  : COEFFICIENT DE LAME 2 A L'INSTANT TEMPS ET 
C               POUR LA TEMPERATURE TEMPE

      CHARACTER*8       NOMRES(3),NOMPAR(2)
      REAL*8            VALRES(3),VALPAR(2)
      CHARACTER*2       CODRET(3)

C THERMO-VARIABLES ET TEMPO-VARIABLES
      NOMPAR(1)='TEMP'
      NOMPAR(2)='INST'
C A L'INSTANT PRECEDENT ET POUR LA TEMPERATURE PRECEDENTE
      VALPAR(1)=TEMP
      VALPAR(2)=INST     
C CARACTERISTIQUES: MODULE D'YOUNG, COEFFICIENT DE POISSON    
      NOMRES(1)='E'
      NOMRES(2)='NU' 
   
      CALL RCVALA(ICODMA,' ','ELAS',2,NOMPAR,VALPAR,2,
     +              NOMRES,VALRES,CODRET, 'F ' )

C CARACTERISTIQUES: COEFFICIENT DE DILATATION THERMIQUE 
      NOMRES(3)='ALPHA'
      CALL RCVALA(ICODMA,' ','ELAS',2,NOMPAR,VALPAR,1,
     +              NOMRES(3),VALRES(3),CODRET(3), '  ' )
      IF ( CODRET(3) .NE. 'OK' ) VALRES(3) = 0.D0
      E     = VALRES(1)
      NU    = VALRES(2)
      ALPHA = VALRES(3)

      DEUXMU = E/(1.D0+NU)
      TROISK = E/(1.D0-2.D0*NU)


      END
