      SUBROUTINE NMVCVE(MATE,LISCHA)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 31/08/1999   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================

      IMPLICIT NONE

      CHARACTER*19 LISCHA
      CHARACTER*24 MATE


C ----------------------------------------------------------------------
C     VERIFICATION DE LA DEPENDANCE DES MATERIAUX EN TEMP/HYDR/SECH
C ----------------------------------------------------------------------
C  IN/JXIN MATE   SD MATERIAU
C  IN/JXIN LISCHA SD L_CHARGES
C ----------------------------------------------------------------------
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------

      CHARACTER*32       JEXNUM
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)

C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------


      INTEGER      NCHAR, ICHAR, IERD, IBID, JCHAR, JINF, IRET
      CHARACTER*8  REPK


      CALL JEVEUO(LISCHA // '.LCHA','L',JCHAR)
      CALL JEVEUO(LISCHA // '.INFC','L',JINF)
      NCHAR = ZI(JINF)


C --- ON REGARDE SI LE MATERIAU DEPEND DE LA TEMPERATURE

      CALL DISMOI('F','ELAS_F_TEMP',MATE,'CHAM_MATER',IBID,REPK,IERD)
      IF ( REPK .EQ. 'OUI' ) THEN
        DO 11,ICHAR = 1,NCHAR
          CALL DISMOI('F','EXI_TEMPER',ZK24(JCHAR-1+ICHAR)(1:8),
     &                'CHARGE',IBID,REPK,IERD)
          IF(REPK .NE. 'NON') GOTO 12
   11   CONTINUE
        CALL UTMESS('A','VARIABLES DE COMMANDE (NMVCVE)',
     &      'LE MATERIAU DEPEND DE LA TEMPERATURE MAIS '//
     &      'IL N''Y A PAS DE CHAMP DE TEMPERATURE.')
   12   CONTINUE

        CALL EXISD('CHAMP_GD',MATE(1:8)//'.TEMPE_REF',IRET)
        IF (IRET.EQ.0) CALL UTMESS('A','NMVCVE',
     &                'LE MATERIAU DEPEND DE LA TEMPERATURE'
     &              //' IL N''Y A PAS DE TEMPERATURE DE REFERENCE'
     &              //' ON PRENDRA DONC LA VALEUR 0')
      ENDIF


C --- ON REGARDE SI LE MATERIAU DEPEND DE L HYDRATATION

      CALL DISMOI('F','ELAS_F_HYDR',MATE,'CHAM_MATER',IBID,REPK,IERD)
      IF ( REPK .EQ. 'OUI' ) THEN
        DO 21,ICHAR = 1,NCHAR
          CALL DISMOI('F','EXI_HYDRAT',ZK24(JCHAR-1+ICHAR)(1:8),
     &                'CHARGE',IBID,REPK,IERD)
          IF(REPK .NE. 'NON') GOTO 22
   21   CONTINUE
        CALL UTMESS('A','VARIABLES DE COMMANDE (NMVCVE)',
     &      'LE MATERIAU DEPEND DE L''HYDRATATION MAIS '//
     &      'IL N''Y A PAS DE CHAMP D''HYDRATATION.')
   22   CONTINUE
      ENDIF


C --- ON REGARDE SI LE MATERIAU DEPEND DU SECHAGE

      CALL DISMOI('F','ELAS_F_SECH',MATE,'CHAM_MATER',IBID,REPK,IERD)
      IF ( REPK .EQ. 'OUI' ) THEN
        DO 31,ICHAR = 1,NCHAR
          CALL DISMOI('F','EXI_SECHAG',ZK24(JCHAR-1+ICHAR)(1:8),
     &                'CHARGE',IBID,REPK,IERD)
          IF(REPK .NE. 'NON') GOTO 32
   31   CONTINUE
        CALL UTMESS('A','VARIABLES DE COMMANDE (NMVCVE)',
     &      'LE MATERIAU DEPEND DU SECHAGE MAIS '//
     &      'IL N''Y A PAS DE CHAMP SECHAGE.')
   32   CONTINUE
      ENDIF

      END
