      SUBROUTINE NMVMPM(COMPOR,ICODMA,ITEMP,TEMP,E,XNU,LOI346)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 29/04/2004   AUTEUR JMBHH01 J.M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
      IMPLICIT NONE
      INTEGER ICODMA,ITEMP
      REAL*8 TEMP,LOI346(21)
      CHARACTER*16 COMPOR(*)
C
C    - FONCTION REALISEE: LECTURE DES COMPORTEMENTS VMIS_POUTRE
C      ECRO_LINE ET ECRO_FLEJOU ET ECRO_LINE_FO ET VMIS_POUTRE_FO
C
C    - ARGUMENTS IN:
C      ICODMA : ADRESSE MATERIAU CODE
C      ITEMP  : PRESENCE OU NON D'UN CHAMP DE TEMPERATURE
C      TEMPP  : VALEUR DE LA TEMPERATURE
C    - ARGUMENTS OUT:
C      E , XNU : COEFFICIENTS ELASTIQUES
C      LOI346  : TABLEAU DE CARACTERISTIQUES
C
C     VARIABLES NECESSAIRE AUX LOIS DE COMPORTEMENT
C
      REAL*8  XNP,XMPY,XMEY,XAY,XBY,XMPZ,XMEZ,XMPX,XAZ,XBZ,
     &  SU, SY , E , EP , PUISS, XNU
      INTEGER NUMLOI,NBPAR
      REAL*8       VALPAR,VALRES(10)
      CHARACTER*2  CODRET(10)
      CHARACTER*8  NOPAR,NOMRE2(4),NOMRE3(10),NOMRE4(2)
C
      DATA NOMRE2/'EP','SY','SU','PUISS'/
      DATA NOMRE3/'NP','MEY','MPY','CAY','CBY','MEZ','MPZ','CAZ','CBZ',
     &     'MPX'/
      DATA NOMRE4/'D_SIGM_EPSI','SY'/
      IF (ITEMP.EQ.0) THEN
         NBPAR  = 0
         NOPAR  = ' '
         VALPAR = 0.D0
      ELSE
         NBPAR  = 1
         NOPAR  = 'TEMP'
         VALPAR = TEMP
      ENDIF
C
C     SI C'EST DE L'ECROUISSAGE LINEAIRE
C
      IF ( COMPOR(1) .EQ. 'VMIS_POU_LINE' ) THEN
        NUMLOI = 1
        CALL RCVALA(ICODMA,' ','ECRO_LINE',NBPAR,NOPAR,VALPAR,2,
     &              NOMRE4,VALRES,CODRET,'FM')
        EP = VALRES(1)
        SY = VALRES(2)
      ELSE IF ( COMPOR(1) .EQ. 'VMIS_POU_FLEJOU' ) THEN
        NUMLOI = 2
        CALL RCVALA(ICODMA,' ','ECRO_FLEJOU',NBPAR,NOPAR,VALPAR,4,
     &              NOMRE2,VALRES,CODRET,'FM')
        EP    = VALRES(1)
        SY    = VALRES(2)
        SU    = VALRES(3)
        PUISS = VALRES(4)
        IF (SY .GE. SU) THEN
           CALL UTMESS('F','TE0346','SY >= SU. IMPOSSIBLE.')
        ENDIF
      ENDIF
        IF (EP .GE. E) THEN
           CALL UTMESS('F','TE0346','EP >= E. IMPOSSIBLE.')
        ENDIF
        EP = E*EP/(E-EP)
C
C     NP,MEY,CAY,...,MPX
C
      CALL RCVALA(ICODMA,' ','VMIS_POUTRE',NBPAR,NOPAR,VALPAR,10,
     &              NOMRE3,VALRES,CODRET,'FM')
      XNP  = VALRES(1)
      XMEY = VALRES(2)
      XMPY = VALRES(3)
      XAY  = VALRES(4)
      XBY  = VALRES(5)
      XMEZ = VALRES(6)
      XMPZ = VALRES(7)
      XAZ  = VALRES(8)
      XBZ  = VALRES(9)
      XMPX = VALRES(10)
      
      IF (XMEY .GT. XMPY) THEN
         CALL UTMESS('F','VMIS_POU_','INCOHERENCE DANS LES '//
     &               'DONNEES MATERIAU : MEY > MPY IMPOSSIBLE.')
      ENDIF
      
      IF (XMEZ .GT. XMPZ) THEN
         CALL UTMESS('F','VMIS_POU_','INCOHERENCE DANS LES '//
     &               'DONNEES MATERIAU : MEZ > MPZ IMPOSSIBLE.')
      ENDIF
C
C     VARIABLES NECESSAIRES A LA LOI DE COMPORTEMENT PLASTIQUE
C     XNP,XMPY,XMEY,XAY,XBY,XMPZ,XMEZ,XMPX,XAZ,XBZ,
C     SU, SY , E , EP , PUISS, AA,XIY,XIZ,XJX,XNU
C
      LOI346(1    ) = NUMLOI
      LOI346(1+ 1 ) = XMPY
      LOI346(1+ 2 ) = XMEY
      LOI346(1+ 3 ) = XAY
      LOI346(1+ 4 ) = XBY
      LOI346(1+ 5 ) = XMPZ
      LOI346(1+ 6 ) = XMEZ
      LOI346(1+ 7 ) = XMPX
      LOI346(1+ 8 ) = XAZ
      LOI346(1+ 9 ) = XBZ
      LOI346(1+10 ) = SU
      LOI346(1+11 ) = SY
      LOI346(1+12 ) = E
      LOI346(1+13 ) = EP
      LOI346(1+14 ) = PUISS
C      LOI346(1+15 ) = AA
C      LOI346(1+16 ) = XIY
C      LOI346(1+17 ) = XIZ
C      LOI346(1+18 ) = XJX
      LOI346(1+19 ) = XNU
      LOI346(1+20 ) = XNP
      END
