      SUBROUTINE NTARCH ( NUMORD, RESULT, NOMCH, COMPOR, VTEMP,
     &                    VHYDR, INSTAP, CRITHE, PARA,
     &                    MODELE, MATE, CARELE, LISCHA )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 28/05/2004   AUTEUR LEBOUVIE F.LEBOUVIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
      IMPLICIT NONE
      INTEGER      NUMORD,IBID
      REAL*8       INSTAP, PARA(*)
      CHARACTER*24 RESULT, NOMCH, VTEMP, VHYDR, CRITHE, COMPOR
      CHARACTER*24 MODELE, MATE, CARELE
      CHARACTER*19 LISCHA, K19B
      CHARACTER*24 K24B
C
C ----------------------------------------------------------------------
C
C THERMIQUE : ARCHIVAGE DES TEMPERATURES.
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER      IRET,JCRI,JCRR,JCRK,JPARA,LPARA(4),IAD,NBT, K
      LOGICAL      HYDRAT
      CHARACTER*8  K8BID
      CHARACTER*16 NOMCOM
C
C ----------------------------------------------------------------------
C
C --- VERIFICATION DE LA DIMENSION DE RESULT
C
      CALL RSEXCH (RESULT,'TEMP',NUMORD,NOMCH,IRET)
      IF (IRET.EQ.110) THEN
        CALL RSAGSD (RESULT,0)
        CALL RSEXCH (RESULT,'TEMP',NUMORD,NOMCH,IRET)
      ENDIF
C
C --- ACTUALISATION DE LA VALEUR DU TEMPS ASSOCIEE A NUMORD
C
      CALL RSADPA (RESULT,'E',1,'INST',NUMORD,0,IAD,K8BID)
      ZR(IAD) = INSTAP
C
C --- LE DELTAT_T ET LE PARM_THETA
C
      CALL RSADPA (RESULT,'E',1,'PARM_THETA' ,NUMORD,0,IAD,K8BID)
      ZR(IAD) = PARA(1)
      CALL RSADPA (RESULT,'E',1,'DELTAT',NUMORD,0,IAD,K8BID)
      ZR(IAD) = PARA(2)
C
C --- LES CRITERES
C
      CALL JEEXIN ( CRITHE(1:19)//'.CRTR', IRET )
      IF ( IRET .NE. 0 ) THEN
         CALL JEVEUO(CRITHE(1:19)//'.CRTR','L',JCRR)
         CALL JEVEUO(CRITHE(1:19)//'.CRDE','L',JCRK)
         CALL JELIRA(CRITHE(1:19)//'.CRDE','LONMAX',NBT,K8BID)
         CALL RSADPA(RESULT,'E',1,ZK16(JCRK),NUMORD,0,JPARA,K8BID)
         ZI(JPARA) = NINT(ZR(JCRR))
         CALL RSADPA(RESULT,'E',1,ZK16(JCRK+1),NUMORD,0,JPARA,K8BID)
         ZI(JPARA) = NINT(ZR(JCRR+1))
         NBT = NBT - 2
         CALL RSADPA(RESULT,'E',NBT,ZK16(JCRK+2),NUMORD,0,LPARA,K8BID)
         DO 10 K = 1,NBT
           ZR(LPARA(K)) = ZR(JCRR+2+K-1)
   10    CONTINUE
      ENDIF
C
C --- ARCHIVAGE DE LA TEMPERATURE
C
      CALL RSEXCH (RESULT,'TEMP',NUMORD,NOMCH,IRET)
      IF (IRET .LE. 100) THEN
      CALL COPISD('CHAMP_GD','G',VTEMP(1:19),NOMCH(1:19))
      CALL RSNOCH (RESULT,'TEMP',NUMORD,' ')
      ENDIF
C
C
C      ARCHIVAGE DU MODELE, MATERIAU, CARA_ELEM ET DE LA SD CHARGE
C
       CALL RSSEPA(RESULT(1:8),NUMORD,MODELE(1:8),MATE(1:8),
     &             CARELE(1:8),LISCHA)
C
      CALL GETRES(K8BID,K8BID,NOMCOM)
      IF (NOMCOM .EQ. 'THER_NON_LINE') THEN
C
C --- ARCHIVAGE DU COMPORTEMENT
C
        CALL RSEXCH (RESULT,'COMPORTEMENT',NUMORD,NOMCH,IRET)
        IF (IRET .LE. 100) THEN
          CALL COPISD('CHAMP_GD','G',COMPOR(1:19),NOMCH(1:19))
          CALL RSNOCH (RESULT,'COMPORTEMENT',NUMORD,' ')
        ENDIF
C
C --- ARCHIVAGE DE L'HYDRATATION
C
        CALL NTHYDR ( HYDRAT )
        IF ( HYDRAT ) THEN
        CALL RSEXCH (RESULT,'HYDR_ELGA',NUMORD,NOMCH,IRET)
        IF (IRET .LE. 100) THEN
          CALL COPISD('CHAMP_GD','G',VHYDR(1:19),NOMCH(1:19))
          CALL RSNOCH (RESULT,'HYDR_ELGA',NUMORD,' ')
        ENDIF
        ENDIF
      ENDIF

C
C-----------------------------------------------------------------------
      END
