      SUBROUTINE PROJQU(MATYP,NBNO,NDIM,TYPEPR,
     &                  COORDA,COORDB,COORDC,COORDD,COORDP,
     &                  PROJ,MOYEN,LISSA,TANGDF,VLISSA,DIAGNO,TOLEIN,
     &                  TOLEOU,
     &                  NORM,TANG,
     &                  COORDM,COEF,OLDJEU,JEU,
     &                  DIAG,ARETE,NOEUD,DEBORD)

C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/10/2004   AUTEUR MABBAS M.ABBAS 
C TOLE CRP_21
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
      IMPLICIT NONE
C
      CHARACTER*4 MATYP
      INTEGER     NDIM
      INTEGER     NBNO
      CHARACTER*6 TYPEPR
      REAL*8      COORDA(3)
      REAL*8      COORDB(3)
      REAL*8      COORDC(3)
      REAL*8      COORDD(3)
      REAL*8      COORDP(3)
      INTEGER     PROJ
      INTEGER     TANGDF
      INTEGER     MOYEN
      INTEGER     LISSA
      REAL*8      VLISSA(9)
      INTEGER     DIAGNO
      REAL*8      TOLEIN
      REAL*8      TOLEOU
      REAL*8      NORM(3)
      REAL*8      TANG(6)
      REAL*8      COORDM(3)
      REAL*8      COEF(NBNO)
      REAL*8      OLDJEU
      REAL*8      JEU
      INTEGER     DIAG(2)
      INTEGER     ARETE(4)
      INTEGER     NOEUD(4)
      REAL*8      DEBORD 
C
C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : PROJMA
C ----------------------------------------------------------------------
C
C "PROJECTION" D'UN NOEUD ESCLAVE P SUR UN QUADRANGLE MAITRE.
C
C IN  MATYP  : TYPE DE MAILLE (QUAD4 , QUAD8 , QUAD9 )
C IN  NDIM   : DIMENSION DU PB
C IN  NBNO   : NOMBRE DE NOEUDS (4, 8 OU 9)
C IN  TYPEPR : TYPE DE PROJECTION SUR QUADRANGLE
C              TRIANG: SEPARATION EN QUATRE TRIANGLES ET JEU MINIMUM
C IN  COORDA : COORDONNEES DU SOMMET A DU QUADRANGLE
C IN  COORDB : COORDONNEES DU SOMMET B DU QUADRANGLE
C IN  COORDC : COORDONNEES DU SOMMET C DU QUADRANGLE
C IN  COORDD : COORDONNEES DU SOMMET D DU QUADRANGLE
C IN  COORDP : COORDONNEES DU NOEUD ESCLAVE P
C IN  PROJ   : PROJECTION LINEAIRE (1) OU QUADRATIQUE (2) SUR LA MAILLE
C              OU PAS DE NOUVELLE PROJECTION (0)
C IN  TANGDF : INDICATEUR DE PRESENCE D'UN VECT_Y DEFINI PAR 
C              L'UTILISATEUR
C               0 PAS DE VECT_Y
C               1 UN VECT_Y EST DEFINI
C IN  MOYEN  : NORMALES D'APPARIEMENT
C               0 MAIT 
C               1 MAIT_ESCL 
C IN  LISSA  : LISSAGE DES NORMALES 
C               0 PAS DE LISSAGE 
C               1 LISSAGE 
C IN  VLISSA : NORMALES LISSEES
C IN  DIAGNO : NIVEAU DE DIAGNOSTIC
C               0 PAS DE VERIFICATIONS 
C               1 VERIFICATIONS FINES
C IN  TOLEIN : TOLERANCE <IN> POUR LA PROJECTION GEOMETRIQUE
C               ( SUR ARETE OU NOEUD )
C IN  TOLEOU : TOLERANCE POUR DETECTION PROJECTION EN DEHORS 
C              MAILLE MAITRE
C               NB: LE PASSAGE DE CET ARGUMENT EST NECESSAIRE
C               LORSQUE L'ON DECOUPE LE QUAD EN QUATRE TRIANGLES
C               (DANS PROJQ1)
C I/O NORM   : NORMALE ENTRANTE A LA MAILLE MAITRE
C I/O TANG   : VECTEURS TANGENTS 
C OUT COORDM : COORDONNEES DE LA "PROJECTION" M
C OUT COEF   : VALEURS EN M DES FONCTIONS DE FORME ASSOCIEES
C              AUX NOEUDS MAITRES
C OUT OLDJEU : JEU AVANT CORRECTION DES PROJECTIONS TOMBANT HORS DE
C              LA MAILLE MAITRE
C OUT JEU    : JEU DANS LA DIRECTION (NORM) DE LA NORMALE ENTRANTE
C              A LA MAILLE MAITRE (PM.NORM)
C OUT DIAG   : DETECTION DE PROJECTION SUR PSEUDO_DIAGONALES
C                 (1: SUR L'ARETE, 0 NON)
C              DIAG(1) : ARETE AC
C              DIAG(2) : ARETE BD
C OUT ARETE  : DETECTION DE PROJECTION SUR ARETE
C                 (1: SUR L'ARETE, 0: NON)
C              ARETE(1) : SEGMENT AB
C              ARETE(2) : SEGMENT BC
C              ARETE(3) : SEGMENT CD
C              ARETE(3) : SEGMENT DA
C OUT NOEUD  : DETECTION DE PROJECTION SUR NOEUD 
C                 (1: SUR LE NOEUD, 0: NON)
C              NOEUD(1) : NOEUD A
C              NOEUD(2) : NOEUD B
C              NOEUD(3) : NOEUD C
C              NOEUD(4) : NOEUD D
C OUT DEBORD : PROJECTION HORS DE LA MAILLE
C              >0 : PROJECTION HORS DE LA MAILLE
C              <0 : PROJECTION SUR LA MAILLE
C
C ----------------------------------------------------------------------
C
      IF (TYPEPR.EQ.'TRIANG') THEN
        CALL PROJQ1(MATYP,NBNO,NDIM,
     &              COORDA,COORDB,COORDC,COORDD,COORDP,
     &              PROJ,MOYEN,LISSA,TANGDF,VLISSA,DIAGNO,TOLEIN,
     &              TOLEOU,
     &              NORM,TANG,
     &              COORDM,COEF,OLDJEU,JEU,
     &              DIAG,ARETE,NOEUD,DEBORD)
      ELSE
        CALL UTMESS ('F','PROJQU',
     &               'SEULE LA METHODE QUATRE TRIANGLES '
     &               //'EST DISPONIBLE POUR QUADRANGLE')
      ENDIF

      

      END
