      SUBROUTINE PROJSE(MATYP,NDIM,
     &                  COORDA,COORDB,COORDC,COORDP,
     &                  PROJ,MOYEN,LISSA,TANGDF,VLISSA,DIAGNO,TOLEIN,
     &                  NORM,TANG,
     &                  COORDM,COEF,OLDJEU,JEU,
     &                  NOEUD,DEBORD)

C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/10/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_21

      IMPLICIT NONE

      CHARACTER*4 MATYP
      INTEGER     NDIM
      REAL*8      COORDA(3)
      REAL*8      COORDB(3)
      REAL*8      COORDC(3)
      REAL*8      COORDP(3)
      INTEGER     PROJ
      INTEGER     TANGDF
      INTEGER     MOYEN
      INTEGER     LISSA
      REAL*8      VLISSA(9)
      INTEGER     DIAGNO
      REAL*8      TOLEIN
      REAL*8      NORM(3)
      REAL*8      TANG(6)
      REAL*8      COORDM(3)
      REAL*8      COEF(3)
      REAL*8      OLDJEU
      REAL*8      JEU
      INTEGER     NOEUD(2)
      REAL*8      DEBORD      
C
C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : PROJMA
C ----------------------------------------------------------------------
C
C "PROJECTION" D'UN NOEUD ESCLAVE SUR UN SEG2 OU UN SEG3.
C ON UTILISE LA NORMALE AU SEGMENT.
C
C IN  MATYP  : TYPE DE LA MAILLE ( SEG2 , SEG3 )
C IN  NDIM   : DIMENSION DU PB
C IN  COORDA : COORDONNEES DU SOMMET A DU SEGMENT
C IN  COORDB : COORDONNEES DU SOMMET B DU SEGMENT
C IN  COORDC : COORDONNEES DU MILIEU C DU SEGMENT
C IN  COORDP : COORDONNEES DU NOEUD ESCLAVE P
C IN  PROJ   : PROJECTION LINEAIRE (1) OU QUADRATIQUE (2) SUR LA MAILLE
C              OU PAS DE NOUVELLE PROJECTION (0)
C IN  TANGDF : INDICATEUR DE PRESENCE D'UN VECT_Y DEFINI PAR 
C              L'UTILISATEUR
C               0 PAS DE VECT_Y
C               1 UN VECT_Y EST DEFINI
C IN  MOYEN  : NORMALES D'APPARIEMENT
C               0 MAIT 
C               1 MAIT_ESCL 
C IN  LISSA  : LISSAGE DES NORMALES 
C               0 PAS DE LISSAGE 
C               1 LISSAGE 
C IN  VLISSA : NORMALES LISSEES
C IN  DIAGNO : NIVEAU DE DIAGNOSTIC
C               0 PAS DE VERIFICATION SPECIALE 
C               1 VERIFICATIONS FINES
C IN  TOLEIN : TOLERANCE <IN> POUR LA PROJECTION GEOMETRIQUE
C               ( SUR ARETE OU NOEUD )
C I/O NORM   : NORMALE ENTRANTE A LA MAILLE MAITRE
C I/O TANG   : VECTEUR TANGENT 
C OUT COORDM : COORDONNEES DE LA "PROJECTION" M
C OUT COEF   : VALEURS EN M DES FONCTIONS DE FORME ASSOCIEES AUX NOEUDS
C OUT OLDJEU : JEU PM DANS LA DIRECTION PM
C OUT JEU    : JEU DANS LA DIRECTION DE LA NORMALE CHOISIE (PM.NORM)
C OUT NOEUD  : DETECTION DE PROJECTION SUR NOEUD 
C                 (1: SUR LE NOEUD, 0: NON)
C              NOEUD(1) : NOEUD A
C              NOEUD(2) : NOEUD B
C OUT DEBORD : PROJECTION HORS DE LA MAILLE
C              >0 : PROJECTION HORS DE LA MAILLE
C              <0 : PROJECTION SUR LA MAILLE
C ----------------------------------------------------------------------

      REAL*8  LAMBDA,INORM(3)

C ----------------------------------------------------------------------

      IF (PROJ.EQ.0) THEN
        CALL UTMESS('F','PROJSE','IL FAUT REACTUALISER LA PROJECTION')
      END IF
C
C --- CALCUL DE LA NORMALE MOYENNEE SI NORMALE MAIT/ESCL
C
      IF (MOYEN.EQ.1) THEN
        CALL NORMSE(NDIM,COORDA,COORDB,TANG,
     &              NORM,INORM)
      ENDIF      

      DEBORD = - 1.D0

      IF ((MATYP.EQ.'SEG2') .OR. (PROJ.EQ.1)) THEN
        CALL PROJLI(NDIM,
     &              COORDA,COORDB,COORDP,
     &              MOYEN,TANGDF,
     &              NORM,TANG,
     &              COORDM,LAMBDA,DEBORD,
     &              OLDJEU,JEU)


      ELSE IF ((MATYP.EQ.'SEG3') .AND. (PROJ.EQ.2)) THEN
        CALL PROJSQ(NDIM,
     &              COORDA,COORDB,COORDC,COORDP,
     &              MOYEN,TANGDF,
     &              NORM,TANG,
     &              COORDM,LAMBDA,DEBORD,
     &              OLDJEU,JEU)
      END IF       
C
C --- CALCUL DES COEFFICIENTS DE LA RELATION LINEAIRE
C --- CORRECTION DES JEUX SI LISSAGE
C
      CALL JEUXSE(NDIM,LAMBDA,MATYP,LISSA,VLISSA,
     &            MOYEN,TANG,INORM,COORDM,COORDP,
     &            TANGDF,COEF,NORM,JEU)
C
C --- VERIFICATIONS DES PROJECTIONS SUR NOEUDS
C
      IF (DIAGNO.NE.0) THEN
        CALL PRDISE(LAMBDA,TOLEIN,NOEUD)
      ENDIF

      END
