      SUBROUTINE RECHPA(IZONE,REACTU,NEWGEO,DEFICO,RESOCO,IESCL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/10/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      INTEGER      IZONE
      INTEGER      REACTU
      CHARACTER*24 NEWGEO
      CHARACTER*24 DEFICO
      CHARACTER*24 RESOCO
      INTEGER      IESCL
C
C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : RECHCO
C ----------------------------------------------------------------------
C
C NON-APPARIEMENT
C
C
C IN  IZONE  : NUMERO DE LA ZONE DE CONTACT
C IN  REACTU : INDICATEUR DE REACTUALISATION POUR TOUTE LA ZONE
C              DES NORMALES ET DU JEU
C IN  NEWGEO : GEOMETRIE ACTUALISEE EN TENANT COMPTE DU CHAMP DE
C              DEPLACEMENTS COURANT
C IN  DEFICO : SD DE DEFINITION DU CONTACT (ISSUE D'AFFE_CHAR_MECA)
C VAR RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C VAR IESCL  : NUMERO DU DERNIER NOEUD ESCLAVE CONNU
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      ZMETH
      PARAMETER    (ZMETH=8)
      INTEGER      ZAPMEM
      PARAMETER    (ZAPMEM=4)
      INTEGER      NDIM,IFM,NIV
      INTEGER      ISURFE
      INTEGER      JDECE,JDECS,NSANS
      INTEGER      NUMNOE,NBNOE
      INTEGER      POSNOE
      INTEGER      KE,K,TANGDF
      CHARACTER*24 METHCO,NDIMCO,PZONE,PSURNO,CONTNO,SANSNO,PSANS
      INTEGER      JMETH,JDIM,JZONE,JSUNO,JNOCO,JSANS,JPSANS
      CHARACTER*24 PDDL,NORINI,DDLCO,NORMCO,TANGCO,APMEMO,APPARI,APPOIN
      INTEGER      JPDDL,JNRINI,JDDL,JNORMO,JTANGO,JAPMEM,JAPPAR,JAPPTR
      CHARACTER*24 APCOEF,APJEU,APDDL,CHAMCO,COEFCO
      INTEGER      JAPCOE,JAPJEU,JAPDDL,JCHAM,JCOEF
      INTEGER      JCOOR
      LOGICAL      MULNOR
      REAL*8       CMULT
C
C ----------------------------------------------------------------------
C
      CALL INFNIV(IFM,NIV)
      CALL JEMARQ ()
C
      IF (NIV.GE.2) THEN
         WRITE (IFM,1000) IZONE,' - PAS APPA.    '
      ENDIF
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      METHCO = DEFICO(1:16)//'.METHCO'
      NDIMCO = DEFICO(1:16)//'.NDIMCO'
      PZONE  = DEFICO(1:16)//'.PZONECO'
      PSURNO = DEFICO(1:16)//'.PSUNOCO'
      CHAMCO = DEFICO(1:16)//'.CHAMCO'
      CONTNO = DEFICO(1:16)//'.NOEUCO'
      SANSNO = DEFICO(1:16)//'.SSNOCO'
      PSANS  = DEFICO(1:16)//'.PSSNOCO'
      DDLCO  = DEFICO(1:16)//'.DDLCO'
      PDDL   = DEFICO(1:16)//'.PDDLCO'
      COEFCO = DEFICO(1:16)//'.COEFCO'
      NORINI = RESOCO(1:14)//'.NORINI'
      NORMCO = RESOCO(1:14)//'.NORMCO'
      TANGCO = RESOCO(1:14)//'.TANGCO'
      APMEMO = RESOCO(1:14)//'.APMEMO'
      APPARI = RESOCO(1:14)//'.APPARI'
      APPOIN = RESOCO(1:14)//'.APPOIN'
      APCOEF = RESOCO(1:14)//'.APCOEF'
      APJEU  = RESOCO(1:14)//'.APJEU'
      APDDL  = RESOCO(1:14)//'.APDDL'  
C ======================================================================
      CALL JEVEUO(METHCO,'L',JMETH)
      CALL JEVEUO(NDIMCO,'L',JDIM )
      CALL JEVEUO(PZONE, 'L',JZONE )
      CALL JEVEUO(PSURNO,'L',JSUNO )
      CALL JEVEUO(CHAMCO,'L',JCHAM )
      CALL JEVEUO(CONTNO,'L',JNOCO )
      CALL JEVEUO(SANSNO,'L',JSANS )
      CALL JEVEUO(PSANS, 'L',JPSANS)
      CALL JEVEUO(PDDL, 'L',JPDDL )
      CALL JEVEUO(DDLCO, 'L',JDDL )
      CALL JEVEUO(NORINI,'L',JNRINI)
      CALL JEVEUO(NORMCO,'E',JNORMO)
      CALL JEVEUO(TANGCO,'E',JTANGO)
      CALL JEVEUO(APMEMO,'E',JAPMEM)
      CALL JEVEUO(APPARI,'E',JAPPAR)
      CALL JEVEUO(APPOIN,'E',JAPPTR)
      CALL JEVEUO(APCOEF,'E',JAPCOE)
      CALL JEVEUO(APJEU, 'E',JAPJEU)
      CALL JEVEUO(APDDL, 'E',JAPDDL)
      CALL JEVEUO(COEFCO,'L',JCOEF)
      CALL JEVEUO(NEWGEO(1:19)//'.VALE','L',JCOOR)
C 
C --- INITIALISATION DE VARIABLES 
C
C
C --- COEFFICIENT MULTIPLICATEUR DE LA RELATION UNILATERALE
C
      CMULT  = ZR(JCOEF+IZONE-1)
C
C --- MULNOR : LOGIQUE QUI VAUT 1 LORSQU'ON MULTIPLIE LES COEFFICIENTS
C --- DE LA RELATION UNILATERALE PAR LES COMPOSANTES DES NORMALES
C --- (I.E. : ON EST DANS UNE ZONE OU LA RELATION UNILATERALE PORTE
C --- SUR LE DEPLACEMENT)
C
      MULNOR = (ABS(ZI(JCHAM+IZONE-1)).EQ.1)
C
C --- NORMALE DEFINIE PAR USER (VECT_Y)
C
      TANGDF = ZI(JMETH+ZMETH*(IZONE-1)+2)
C
C --- DIMENSION DU PROBLEME
C
      NDIM   = ZI(JDIM)

C 
C --- REPERAGE DANS LES 2 SURFACES DE LA ZONE NUMERO IZONE
C 

C --- NUMEROS DE LA SURFACE ESCLAVE
      ISURFE = ZI(JZONE+IZONE-1) + 1

C --- NOMBRE DE NOEUDS DE LA SURFACE ESCLAVE
      NBNOE  = ZI(JSUNO+ISURFE) - ZI(JSUNO+ISURFE-1)

C --- DECALAGE DANS CONTNO POUR TROUVER LES NOEUDS DE LA SURFACE ESCLAVE
      JDECE  = ZI(JSUNO+ISURFE-1)

C --- NOMBRE DE NOEUDS ESCLAVES DE LA ZONE A PRIORI
      ZI(JDIM+8+IZONE) = NBNOE

      DO 49 KE = 1,NBNOE

C --- INDICE DANS CONTNO, NUMERO ABSOLU DU NOEUD DE LA 1ERE SURFACE
C --- ET COORDONNEES ACTUELLES

          POSNOE   = JDECE + KE
          NUMNOE   = ZI(JNOCO+POSNOE-1)

C --- ON REGARDE SI LE NOEUD EST INTERDIT COMME ESCLAVE

          NSANS = ZI(JPSANS+IZONE) - ZI(JPSANS+IZONE-1)
          JDECS = ZI(JPSANS+IZONE-1)
          DO 9 K = 1,NSANS
            IF (NUMNOE.EQ.ZI(JSANS+JDECS+K-1)) THEN
              ZI(JDIM+8+IZONE) = ZI(JDIM+8+IZONE) - 1
              ZI(JAPMEM+ZAPMEM* (POSNOE-1)) = -1
              GO TO 49
            END IF
   9      CONTINUE

          IESCL = IESCL + 1

          CALL CFJEUI(NDIM,
     &                JAPCOE,JAPDDL,JAPJEU,JAPMEM,JAPPAR,
     &                JAPPTR,JDDL,JNORMO,JNRINI,JPDDL,JTANGO,
     &                TANGDF,
     &                MULNOR,CMULT,
     &                POSNOE,IESCL,REACTU)

   49 CONTINUE

C ----------------------------------------------------------------------

      CALL JEDEMA()
C
 1000 FORMAT (' <CONTACT> <> APPARIEMENT - ZONE: ',I6,A16)
      END
