      SUBROUTINE SDCONX(RHON,CRIT,FROTT,MU,RHOT,SEUIL0,STACO0,FISS) 


C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 25/01/2005   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

      IMPLICIT NONE

      REAL*8       RHON,MU,RHOT,SEUIL0
      INTEGER      CRIT(2)
      CHARACTER*8  FROTT,STACO0,FISS
C
C   CRATION DE LA STRUCTURE DE DONNE CONTACT X-FEM
C
C   IN
C       RHON   : COEF_REGU_CONT
C       CRIT   : ITER_GEOM_MAXI ET ITER_CONT_MAXI
C       FROTT  : 'SANS' OU 'COULOMB'
C       MU     : COEFFICIENT DE FROTTEMENT DE COULOMB
C       RHOT   : COEF_REGU_FROT
C       SEUIL0 : SEUIL_INIT
C       STACO0 : CONTACT INITIAL ("OUI" OU "NON")
C       FISS   : SD FISS_XFEM
C 
C   OUT
C      FISS  : SD FISS_XFEM AVEC DONNES SUR LE CONTACT

      INTEGER      JCMCF,JECPD,JMETH,JXFEM

C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      CHARACTER*32       JEXNUM , JEXNOM , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------

      CALL JEMARQ()

      CALL WKVECT(FISS//'.CONTACT.CARACF','G V R',7,JCMCF)
C     NB DE ZONES DE CONTACT
      ZR(JCMCF-1+1)=1.D0
C     SCHMA D'INTGRATION (=2 SI INTEGRATION = 'GAUSS')
      ZR(JCMCF-1+2)=2.D0
C     COEF_REGU_CONT
      ZR(JCMCF-1+3)=RHON      
C     COEF_REGU_FROT
      ZR(JCMCF-1+4)=RHOT
      IF (FROTT.EQ.'COULOMB') THEN
C       COEF DE COULOMB POUR LE FROTTEMENT
        ZR(JCMCF-1+5)=MU               
C       COEF DE MALEK (=1 SI FROTTEMENT='SANS' 
C                      =3 SI FROTTEMENT='COULOMB')
        ZR(JCMCF-1+6)=3.D0     
      ELSEIF (FROTT.EQ.'SANS') THEN
        ZR(JCMCF-1+4)=0.D0
        ZR(JCMCF-1+5)=0.D0  
        ZR(JCMCF-1+6)=1.D0
        SEUIL0=0.D0
      ENDIF
C     SEUIL_INIT
      ZR(JCMCF-1+7)=SEUIL0    

      CALL WKVECT(FISS//'.CONTACT.ECPDON','G V I',6,JECPD)
C     NB TOTAL DE ZONES DE CONTACT
      ZI(JECPD-1+1)=1
C     INDICATEUR D'AXIS (=1 SI MODL_AXIS='OUI' 
C                        =0 SI MODL_AXIS='NON')
      ZI(JECPD-1+2)=0
C     ITER_CONT_MAXI
      ZI(JECPD-1+3)=CRIT(1)    
C     ITER_FROT_MAXI
      ZI(JECPD-1+4)=CRIT(2) 
C     ITER_GEOM_MAXI
      ZI(JECPD-1+5)=1
C     STATUT DE CONTACT INITIAL
      IF (STACO0.EQ.'OUI') ZI(JECPD-1+6)=1
      IF (STACO0.EQ.'NON') ZI(JECPD-1+6)=0      
                 
      CALL WKVECT(FISS//'.CONTACT.METHCO','G V I',7,JMETH)
C     N DE LA MTHODE UTILISE (=6 SI MTHODE CONTINUE)
      ZI(JMETH-1+7)=6

      CALL WKVECT(FISS//'.CONTACT.XFEM','G V I',1,JXFEM)
C     INDICATEUR DE PRSENCE DE LA MTHODE CONTINUE AVEC X-FEM
      ZI(JXFEM-1+1)=1




      CALL JEDEMA()
      END
