      SUBROUTINE STATSR(IMATE,MECA,ADCOME,CONGEP,DIMCON,P1,P2,DT,SAT
     &                       ,G1,G2,G3)
C
C     CETTE ROUTINE CALCULE LA SURFACE D'ETAT DE DEGRE DE SATURATION 
C     POUR LA MODELISATION DE THM DE B. GATMIRI (CERMES)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 29/04/2004   AUTEUR JMBHH01 J.M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
      IMPLICIT NONE
C
      CHARACTER*16  MECA
      INTEGER  DIMCON,ADCOME,NSATB,I,NBPAR,NRESMA,IMATE
      PARAMETER    (NSATB=4)
      PARAMETER     ( NRESMA = 18)
      REAL*8   CONGEP(DIMCON),VALSAT(NSATB),VALPAR
      REAL*8   DT,P2,P1,SAT,SUC,SY
      REAL*8   SRAS,SRBS,SRCS,SRDS,CC,DD,G1,G2,G3

      CHARACTER*8  BGCR5(NSATB),NOMPAR
      CHARACTER*2     CODRET(NRESMA)

C
      DATA BGCR5 
     & /'A_SURF_SATU','B_SURF_SATU','C_SURF_SATU','D_SURF_SATU'/
C
         SUC=P2-P1
         IF(SUC.LE.0.D0) SUC=0.D0
C
         SY=0.D0
         DO 102 I=1,3
            SY=SY+CONGEP(ADCOME-1+I)
 102     CONTINUE
         SY=SY/3.D0
C
         IF (MECA.EQ.'SURF_ETAT_NSAT')THEN
C         LIRE LES COEFFICIENTS CALCUL LES LOIS
            NBPAR  = 0
            VALPAR = 0.D0
            NOMPAR = ' '
             CALL RCVALA(IMATE,' ','SURF_ETAT_NSAT',NBPAR,NOMPAR,VALPAR,
     &              NSATB,BGCR5,VALSAT,CODRET, 'FM' )

            SRAS    = VALSAT(1)
            SRBS    = VALSAT(2)        
            SRCS    = VALSAT(3)
            SRDS    = VALSAT(4)
C
C
C       CALCUL DE SURFACE D'ETAT DE SATURATION ET LEURS DERIVEES
C
         CC=EXP(-SRCS*SUC)
         DD=EXP(SRDS*DT)
         SAT=1.D0-(SRAS+SRBS*SY)*(1.D0-CC)*DD
         G1=-SRBS*(1.D0-CC)*DD
         G2=-SRCS*(SRAS+SRBS*SY)*CC*DD
         G3=-SRDS*(SRAS+SRBS*SY)*(1.D0-CC)*DD
         
        ENDIF
       END
