      SUBROUTINE  XMEL3D(NNOP,IPOIDS,IVF,DDLH,DDLC,IGEOM,TYPMOD,OPTION,
     &                   IMATE,COMPOR,LGPG,CRIT,T,PINTT,CNSET,HEAVT,
     &                   LONCH,HYDR,SECH,TREF,DEPL,NNOM,
     &                   SIG,VI,MATUU,VECTU,CODRET )

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/04/2005   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C TOLE CRP_21
C
       IMPLICIT NONE
C
       INTEGER      NNOP,IMATE,LGPG,CODRET,IPOIDS,IVF,IGEOM
       INTEGER      DDLH,DDLC,CNSET(4*32),HEAVT(36),LONCH(7)
       CHARACTER*8  TYPMOD(*)
       CHARACTER*16 OPTION, COMPOR(4)
       REAL*8       GEOM(3,NNOP),CRIT(3),PINTT(3*11),VI(*),T(NNOP)
       REAL*8       TREF,HYDR(NNOP),SECH(NNOP),DEPL(3+DDLH+DDLC,NNOP)
       REAL*8       MATUU(*),VECTU(3+DDLH+DDLC,NNOP),SIG(*)
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
C
      INTEGER  ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
C
C.......................................................................
C
C     BUT:  PRLIMINAIRES AU CALCUL DES OPTIONS RIGI_MECA_TANG, 
C           RAPH_MECA ET FULL_MECA  EN HYPER-ELASTICITE AVEC X-FEM
C.......................................................................
C IN  NNOP    : NOMBRE DE NOEUDS DE L'ELEMENT PARENT
C IN  IPOIDS  : POIDS DES POINTS DE GAUSS
C IN  IVF     : VALEUR  DES FONCTIONS DE FORME
C IN  DDLH    : NOMBRE DE DDL HEAVYSIDE (PAR NOEUD)
C IN  DDLC    : NOMBRE DE DDL DE CONTACT (PAR NOEUD)
C IN  IGEOM   : COORDONEES DES NOEUDS
C IN  TYPMOD  : TYPE DE MODELISATION
C IN  OPTION  : OPTION DE CALCUL
C IN  IMATE   : MATERIAU CODE
C IN  COMPOR  : COMPORTEMENT
C IN  LGPG  : "LONGUEUR" DES VARIABLES INTERNES POUR 1 POINT DE GAUSS
C              CETTE LONGUEUR EST UN MAJORANT DU NBRE REEL DE VAR. INT.
C IN  CRIT    : CRITERES DE CONVERGENCE LOCAUX
C IN  T       : TEMPERATURE AUX NOEUDS
C IN  PINTT   : COORDONNES DES POINTS D'INTERSECTION
C IN  CNSET   : CONNECTIVITE DES SOUS-ELEMENTS
C IN  HEAVT   : VALEURS DE L'HEAVISIDE SUR LES SS-ELTS
C IN  LONCH   : LONGUEURS DES CHAMPS UTILISES
C IN  HYDR    : HYDRATATION AUX POINTS DE GAUSS
C IN  SECH    : SECHAGE AUX NOEUDS
C IN  TREF    : TEMPERATURE DE REFERENCE
C IN  DEPL    : DEPLACEMENT A PARTIR DE LA CONF DE REF
C IN  NNOM    : NB DE 'NOEUDS MILIEU' PORTANT LES DDL DE CONTACT
C OUT SIG     : CONTRAINTES DE CAUCHY (RAPH_MECA ET FULL_MECA)
C OUT VI      : VARIABLES INTERNES    (RAPH_MECA ET FULL_MECA)
C OUT MATUU   : MATRICE DE RIGIDITE PROFIL (RIGI_MECA_TANG ET FULL_MECA)
C OUT VECTU   : FORCES NODALES (RAPH_MECA ET FULL_MECA)
C..............................................................
C----------------------------------------------------------------
      CHARACTER*8   ELREFP
      REAL*8        HE
      INTEGER       CONNEC(6,4),NINTER,NPTS,NSE,CNSE(6,4),NSEMAX,NPG
      INTEGER       I,IT,ISE,IN,INO,NIT,CPT,NCMP,IDEB,JCOORS,NNOM
      CHARACTER*24  COORSE,PINTER,AINTER,HEAV
      PARAMETER    (NSEMAX=6)
C     ------------------------------------------------------------

C            POUR L'INSTANT, SEULEMENT POUR DES HEXA4 et TETRA4

C     ------------------------------------------------------------

C     ATTENTION, DEPL ET VECTU SONT ICI DIMENSIONNS DE TELLE SORTE 
C     QU'ILS NE PRENNENT PAS EN COMPTE LES DDL SUR LES NOEUDS MILIEU

      CALL ELREF1(ELREFP)
C      write(6,*)'elrefp ',ELREFP

C     RCUPRATION DE LA SUBDIVISION L'LMENT PARENT EN NIT TETRAS 
      NIT=LONCH(1)

      CPT=0
C     BOUCLE SUR LES NIT TETRAS
      DO 100 IT=1,NIT

C       RCUPRATION DU DCOUPAGE EN NSE SOUS-LMENTS 
        NSE=LONCH(1+IT)

C       BOUCLE D'INTGRATION SUR LES NSE SOUS-LMENTS
        DO 110 ISE=1,NSE

          CPT=CPT+1

C         COORD DU SOUS-LT EN QUESTION
          COORSE='&&XMEL3D.COORSE'
          CALL WKVECT(COORSE,'V V R',3*4,JCOORS)

C         BOUCLE SUR LES 4 SOMMETS DU SOUS-TTRA
          DO 112 IN=1,4
            INO=CNSET(4*(CPT-1)+IN)
            IF (INO.LT.1000) THEN
              ZR(JCOORS-1+3*(IN-1)+1)=ZR(IGEOM-1+3*(INO-1)+1)
              ZR(JCOORS-1+3*(IN-1)+2)=ZR(IGEOM-1+3*(INO-1)+2)
              ZR(JCOORS-1+3*(IN-1)+3)=ZR(IGEOM-1+3*(INO-1)+3)
            ELSE
              ZR(JCOORS-1+3*(IN-1)+1)=PINTT(3*(INO-1000-1)+1)
              ZR(JCOORS-1+3*(IN-1)+2)=PINTT(3*(INO-1000-1)+2)
              ZR(JCOORS-1+3*(IN-1)+3)=PINTT(3*(INO-1000-1)+3)
            ENDIF
 112      CONTINUE

C         FONCTION HEAVYSIDE CSTE SUR LE SS-LT
          HE=HEAVT(NSEMAX*(IT-1)+ISE)

C         DEBUT DE LA ZONE MMOIRE DE SIG CORRESPONDATE
          NPG=15
          NCMP=6
          IDEB=(NSEMAX*NPG*(IT-1)+NPG*(ISE-1))*NCMP+1

          CALL XXEL3D(ELREFP,COORSE,IGEOM,HE,DDLH,DDLC,NNOP,NNOM,NPG,
     &                TYPMOD,OPTION,IMATE,COMPOR,LGPG,CRIT,T,HYDR,
     &                SECH,TREF,DEPL,SIG(IDEB),VI,MATUU,
     &                VECTU,CODRET )

          CALL JEDETR(COORSE)

 110    CONTINUE

 100  CONTINUE

      END
