      SUBROUTINE XMMCME(MODELE,DEPMOI,DEPDEL,DEFICO,MCONEL,
     &                  SCONEL)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 25/01/2005   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

      IMPLICIT NONE
      CHARACTER*8  MODELE,MCONEL,SCONEL
      CHARACTER*24 DEPMOI,DEPDEL,DEFICO
C ----------------------------------------------------------------------
C        CALCUL DES MATRICES ELEMENTAIRES ET DES SECONDS MEMBRES 
C             DE TYPE CONTACT FROTTANT DANS LE CADRE D'X-FEM

C IN LIGREL : NOM DE LIGREL (DES ELEMENTS DE CONTACT MALEK)
C IN  CEL1,CEL2  : 

C IN  DEPMOI : DPLACEMENT  L'QUILIBRE PRCDENT
C IN  DEPDEL : INCRMENT DE DPLACEMENT DEPUIS L'QUILIBRE PRCDENT
C IN/JXOUT MCONEL : MATR_ELEM : MATRICES ELEMENTAIRES
C IN/JXOUT SCONEL : VECT_ELEM : S M ELEMENTAIRES

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL,EXIGEO
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)


C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

      CHARACTER*8  LPAIN(13),LPAOUT,K8BID
      CHARACTER*19 LIGREL,CHGEOM,LCHIN(13),LCHOUT,LEVSET,STANO
      CHARACTER*19 PINTER,AINTER,CFACE,LONCHA,BASECO
      INTEGER      JNOMA,JFISS,JLIRES

      CALL JEMARQ()

      LIGREL = MODELE//'.MODELE'

C     ON DETRUIT MCONEL ET SCONEL S'ILS EXISTENT
      CALL DETRSD('MATR_ELEM',MCONEL)
      CALL DETRSD('VECT_ELEM',SCONEL)

C     RECUPERATION DE LA GEOMETRIE
      CALL JEVEUO(MODELE//'.MODELE    .NOMA','L',JNOMA)
      CHGEOM = ZK8(JNOMA)//'.COORDO'

C     RECUPERATION DE LA LEVEL SET NORMALE, DES GRADIENTS DES LEVEL SETS
C     DU STATUT DES NOEUDS ET DES DONNES TOPOLOGIQUES SUR LES FACETTES
      CALL JEVEUO(MODELE//'.FISS','L',JFISS)
      LEVSET=ZK8(JFISS)//'.LNNO'     
      STANO =ZK8(JFISS)//'.STNO'
      PINTER=ZK8(JFISS)//'.TOPOFAC.PINTER'
      AINTER=ZK8(JFISS)//'.TOPOFAC.AINTER'
      CFACE =ZK8(JFISS)//'.TOPOFAC.CFACE'
      LONCHA=ZK8(JFISS)//'.TOPOFAC.LONCHAM'
      BASECO=ZK8(JFISS)//'.TOPOFAC.BASECO'
C
C     CREATION DES LISTES DES CHAMPS IN ET OUT
      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM
      LPAIN(2) = 'PDEPL_M'
      LCHIN(2) = DEPMOI
      LPAIN(3) = 'PDEPL_P'
      LCHIN(3) = DEPDEL
      LPAIN(4) = 'PINDCOI'
      LCHIN(4) = DEFICO(1:16)//'.IN'
      LPAIN(5) = 'PDONCO'
      LCHIN(5) = DEFICO(1:16)//'.DO'
      LPAIN(6) = 'PLEVSET'
      LCHIN(6) = LEVSET
      LPAIN(7) = 'PSTANO'
      LCHIN(7) = STANO
      LPAIN(8) = 'PPINTER'
      LCHIN(8) = PINTER
      LPAIN(9) = 'PAINTER'
      LCHIN(9) = AINTER
      LPAIN(10) = 'PCFACE'
      LCHIN(10) = CFACE
      LPAIN(11) = 'PLONCHA'
      LCHIN(11) = LONCHA
      LPAIN(12) = 'PBASECO'
      LCHIN(12) = BASECO
      LPAIN(13) = 'PSEUIL'
      LCHIN(13) = DEFICO(1:16)//'.SE'
      

C     CALCUL DE MCONEL :
C     --------------------
      LPAOUT = 'PMATUUR'

      CALL MEMARE('V',MCONEL(1:8),MODELE,' ',' ','RIGI_MECA')
      CALL WKVECT(MCONEL(1:8)//'.LISTE_RESU','V V K24',2,JLIRES)

      LCHOUT = MCONEL(1:8)//'.ME001'
      CALL CALCUL('S','RIGI_CONT',LIGREL,13,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &            'V')
      ZK24(JLIRES-1+1) = LCHOUT

      LCHOUT = MCONEL(1:8)//'.ME002'
      CALL CALCUL('S','RIGI_FROT',LIGREL,13,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &            'V')
      ZK24(JLIRES-1+2) = LCHOUT

      CALL JEECRA(MCONEL(1:8)//'.LISTE_RESU','LONUTI',2,K8BID)


C      CALCUL DE SCONEL :
C      -----------------------
      LPAOUT = 'PVECTUR'

      CALL MEMARE('V',SCONEL,MODELE,' ',' ','CHAR_MECA')
      CALL WKVECT(SCONEL//'.LISTE_RESU','V V K24',2,JLIRES)

      LCHOUT = SCONEL//'.VE001'
      CALL CALCUL('S','CHAR_MECA_CONT',LIGREL,13,LCHIN,LPAIN,1,LCHOUT,
     &            LPAOUT,'V')
      ZK24(JLIRES-1+1) = LCHOUT

      LCHOUT = SCONEL//'.VE002'
      CALL CALCUL('S','CHAR_MECA_FROT',LIGREL,13,LCHIN,LPAIN,1,LCHOUT,
     &            LPAOUT,'V')
      ZK24(JLIRES-1+2) = LCHOUT

      CALL JEECRA(SCONEL//'.LISTE_RESU','LONUTI',2,K8BID)


      CALL JEDEMA()
      END
