      SUBROUTINE NOPAN(TYPEMA,PAN,NPAN)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 08/11/2004   AUTEUR DURAND C.DURAND 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C                                                                       
C                                                                       
C ======================================================================
C TOLE CRP_20
C
C ----------------------------------------------------------------------
C         NOEUDS DEFINISSANT LES PANS (2D = ARETES, 3D = FACES)
C ----------------------------------------------------------------------
C VARIABLES D'ENTREE 
C CHARACTER*8       TYPEMA     : TYPE DE MAILLE
C
C VARIABLES D'ENTREE/SORTIE
C INTEGER           PAN(*)     : NOEUDS  DEFINISSANT LES PANS
C                                ( NOMBRE NOEUDS PAN 1, N1, N2, ...
C                                  ..., NOMBRE NOEUDS PAN 2, ...)
C                                  EN 3D, NB NOEUDS < 0 : TRIANGLE
C                                         NB NOEUDS > 0 : QUADRANGLE
C INTEGER           NPAN       : NOMBRE DE PANS

      IMPLICIT NONE

C --- VARIABLES
      CHARACTER*8 TYPEMA
      INTEGER PAN(*),NPAN

      IF (TYPEMA(1:3).EQ.'SEG') THEN
        NPAN = 2
          PAN(1) = 1
            PAN(2) = 1
          PAN(3) = 1
            PAN(4) = 2 
      ELSEIF (TYPEMA(1:4).EQ.'TRIA') THEN
        NPAN = 3
        IF (TYPEMA(5:5).EQ.'3') THEN
          PAN(1) = 2
            PAN(2) = 1
            PAN(3) = 2
          PAN(4) = 2
            PAN(5) = 2
            PAN(6) = 3
          PAN(7) = 2
            PAN(8) = 3
            PAN(9) = 1
        ELSEIF (TYPEMA(5:5).EQ.'6') THEN
          PAN(1) = 3
            PAN(2) = 1
            PAN(3) = 2
            PAN(4) = 4
          PAN(5) = 3
            PAN(6) = 2
            PAN(7) = 3
            PAN(8) = 5
          PAN(9) = 3
            PAN(10) = 3
            PAN(11) = 1          
            PAN(12) = 6
        ENDIF
      ELSEIF (TYPEMA(1:4).EQ.'QUAD') THEN
        NPAN = 4
        IF (TYPEMA(5:5).EQ.'4') THEN
          PAN(1) = 2
            PAN(2) = 1
            PAN(3) = 2
          PAN(4) = 2
            PAN(5) = 2
            PAN(6) = 3
          PAN(7) = 2
            PAN(8) = 3
            PAN(9) = 4
          PAN(10) = 2
            PAN(11) = 4
            PAN(12) = 1          
        ELSEIF (TYPEMA(5:5).EQ.'6') THEN
          PAN(1) = 3
            PAN(2) = 1
            PAN(3) = 2
            PAN(4) = 5
          PAN(5) = 2
            PAN(6) = 2
            PAN(7) = 3
          PAN(8) = 3
            PAN(9) = 3
            PAN(10) = 4
            PAN(11) = 6
          PAN(12) = 2
            PAN(13) = 4
            PAN(14) = 1
        ELSEIF ((TYPEMA(5:5).EQ.'8').OR.(TYPEMA(5:5).EQ.'9')) THEN
          PAN(1) = 3
            PAN(2) = 1
            PAN(3) = 2
            PAN(4) = 5
          PAN(5) = 3
            PAN(6) = 2
            PAN(7) = 3
            PAN(8) = 6
          PAN(9) = 3
            PAN(10) = 3
            PAN(11) = 4
            PAN(12) = 7
          PAN(13) = 3
            PAN(14) = 4
            PAN(15) = 1
            PAN(16) = 8
        ENDIF        
      ELSEIF (TYPEMA(1:5).EQ.'TETRA') THEN
        NPAN = 4
        IF (TYPEMA(6:6).EQ.'4') THEN
          PAN(1) = -3
            PAN(2) = 1
            PAN(3) = 3
            PAN(4) = 2
          PAN(5) = -3
            PAN(6) = 1
            PAN(7) = 2
            PAN(8) = 4
          PAN(9) = -3
            PAN(10) = 1
            PAN(11) = 4
            PAN(12) = 3
          PAN(13) = -3
            PAN(14) = 2
            PAN(15) = 3
            PAN(16) = 4
        ELSEIF (TYPEMA(6:7).EQ.'10') THEN
          PAN(1) = -6
            PAN(2) = 1
            PAN(3) = 3
            PAN(4) = 2
            PAN(5) = 7
            PAN(6) = 6
            PAN(7) = 5
          PAN(8) = -6
            PAN(9) = 1
            PAN(10) = 2
            PAN(11) = 4
            PAN(12) = 5
            PAN(13) = 9
            PAN(14) = 8
          PAN(15) = -6
            PAN(16) = 1
            PAN(17) = 4
            PAN(18) = 3
            PAN(19) = 8
            PAN(20) = 10
            PAN(21) = 7
          PAN(22) = -6
            PAN(23) = 2
            PAN(24) = 3
            PAN(25) = 4       
            PAN(26) = 6
            PAN(27) = 10
            PAN(28) = 9         
        ENDIF
      ELSEIF (TYPEMA(1:5).EQ.'PENTA') THEN
        NPAN = 5
        IF (TYPEMA(6:6).EQ.'6') THEN
          PAN(1) = -3
            PAN(2) = 1
            PAN(3) = 3
            PAN(4) = 2
          PAN(5) = 4
            PAN(6) = 1
            PAN(7) = 2
            PAN(8) = 5
            PAN(9) = 4
          PAN(10) = 4
            PAN(11) = 2
            PAN(12) = 3
            PAN(13) = 6
            PAN(14) = 5
          PAN(15) = 4
            PAN(16) = 1
            PAN(17) = 4
            PAN(18) = 6
            PAN(19) = 3
          PAN(20) = -3
            PAN(21) = 4
            PAN(22) = 5
            PAN(23) = 6
        ELSEIF (TYPEMA(6:7).EQ.'12') THEN
          PAN(1) = -6
            PAN(2) = 1
            PAN(3) = 3
            PAN(4) = 2
            PAN(5) = 9
            PAN(6) = 8
            PAN(7) = 7
          PAN(8) = 6
            PAN(9) = 1
            PAN(10) = 2
            PAN(11) = 5
            PAN(12) = 4
            PAN(13) = 7
            PAN(14) = 10
          PAN(15) = 6
            PAN(16) = 2
            PAN(17) = 3
            PAN(18) = 6 
            PAN(19) = 5
            PAN(20) = 8
            PAN(21) = 11
          PAN(22) = 6
            PAN(23) = 3
            PAN(24) = 1
            PAN(25) = 4
            PAN(26) = 6
            PAN(27) = 9
            PAN(28) = 12
          PAN(29) = -6
            PAN(30) = 4
            PAN(31) = 5
            PAN(32) = 6
            PAN(33) = 10
            PAN(34) = 11
            PAN(35) = 12
        ELSEIF (TYPEMA(6:7).EQ.'14') THEN
          PAN(1) = -7
            PAN(2) = 1
            PAN(3) = 3
            PAN(4) = 2
            PAN(5) = 9
            PAN(6) = 8
            PAN(7) = 7
            PAN(8) = 13
          PAN(9) = 6
            PAN(10) = 1
            PAN(11) = 2
            PAN(12) = 5
            PAN(13) = 4
            PAN(14) = 7
            PAN(15) = 10
          PAN(16) = 6
            PAN(17) = 2
            PAN(18) = 3
            PAN(19) = 6 
            PAN(20) = 5
            PAN(21) = 8
            PAN(22) = 11
          PAN(23) = 6
            PAN(24) = 3
            PAN(25) = 1
            PAN(26) = 4
            PAN(27) = 6
            PAN(28) = 9
            PAN(29) = 12
          PAN(30) = -7
            PAN(31) = 4
            PAN(32) = 5
            PAN(33) = 6
            PAN(34) = 10
            PAN(35) = 11
            PAN(36) = 12
            PAN(37) = 14
        ELSEIF (TYPEMA(6:7).EQ.'15') THEN
          PAN(1) = -6
            PAN(2) = 1
            PAN(3) = 3
            PAN(4) = 2
            PAN(5) = 9
            PAN(6) = 8
            PAN(7) = 7
          PAN(8) = 8
            PAN(9) = 1
            PAN(10) = 2
            PAN(11) = 5
            PAN(12) = 4 
            PAN(13) = 7
            PAN(14) = 11
            PAN(15) = 13
            PAN(16) = 10
          PAN(17) = 8
            PAN(18) = 2
            PAN(19) = 3
            PAN(20) = 6
            PAN(21) = 5
            PAN(22) = 8
            PAN(23) = 12
            PAN(24) = 14
            PAN(25) = 11
          PAN(26) = 8
            PAN(27) = 1
            PAN(28) = 4
            PAN(29) = 6
            PAN(30) = 3         
            PAN(31) = 10
            PAN(32) = 15
            PAN(33) = 12
            PAN(34) = 9
          PAN(35) = -6
            PAN(36) = 4
            PAN(37) = 5
            PAN(38) = 6
            PAN(39) = 13
            PAN(40) = 14
            PAN(41) = 15
        ENDIF
      ELSEIF (TYPEMA(1:4).EQ.'HEXA') THEN
        NPAN = 6
        IF (TYPEMA(5:5).EQ.'8') THEN
          PAN(1) = 4
            PAN(2) = 1
            PAN(3) = 4
            PAN(4) = 3
            PAN(5) = 2
          PAN(6) = 4
            PAN(7) = 1
            PAN(8) = 2
            PAN(9) = 6
            PAN(10) = 5
          PAN(11) = 4
            PAN(12) = 2
            PAN(13) = 3
            PAN(14) = 7
            PAN(15) = 6
          PAN(16) = 4
            PAN(17) = 3
            PAN(18) = 4
            PAN(19) = 8
            PAN(20) = 7
          PAN(21) = 4
            PAN(22) = 4
            PAN(23) = 1
            PAN(24) = 5
            PAN(25) = 8
          PAN(26) = 4
            PAN(27) = 5
            PAN(28) = 6
            PAN(29) = 7
            PAN(30) = 8
        ELSEIF (TYPEMA(5:6).EQ.'16') THEN
          PAN(1) = 6
            PAN(2) = 1
            PAN(3) = 4
            PAN(4) = 3
            PAN(5) = 2
            PAN(6) = 10
            PAN(7) = 9
          PAN(8) = 6
            PAN(9) = 2
            PAN(10) = 6
            PAN(11) = 5
            PAN(12) = 1
            PAN(13) = 12
            PAN(14) = 11
          PAN(15) = 8
            PAN(16) = 2
            PAN(17) = 3
            PAN(18) = 7
            PAN(19) = 6
            PAN(20) = 9
            PAN(21) = 13
            PAN(22) = 15
            PAN(23) = 12
          PAN(24) = 6
            PAN(25) = 4
            PAN(26) = 8
            PAN(27) = 7
            PAN(28) = 3
            PAN(29) = 14
            PAN(30) = 13
          PAN(31) = 8
            PAN(32) = 4
            PAN(33) = 1
            PAN(34) = 5
            PAN(35) = 8
            PAN(36) = 10
            PAN(37) = 11
            PAN(38) = 16
            PAN(39) = 14
          PAN(40) = 6
            PAN(41) = 6
            PAN(42) = 7
            PAN(43) = 8
            PAN(44) = 5
            PAN(45) = 15
            PAN(46) = 16
        ELSEIF (TYPEMA(5:6).EQ.'18') THEN
          PAN(1) = 6
            PAN(2) = 1
            PAN(3) = 4
            PAN(4) = 3
            PAN(5) = 2
            PAN(6) = 10
            PAN(7) = 9
          PAN(8) = 6
            PAN(9) = 2
            PAN(10) = 6
            PAN(11) = 5
            PAN(12) = 1
            PAN(13) = 12
            PAN(14) = 11
          PAN(15) = 9
            PAN(16) = 2
            PAN(17) = 3
            PAN(18) = 7
            PAN(19) = 6
            PAN(20) = 9
            PAN(21) = 13
            PAN(22) = 15
            PAN(23) = 12
            PAN(24) = 17
          PAN(25) = 6
            PAN(26) = 4
            PAN(27) = 8
            PAN(28) = 7
            PAN(29) = 3
            PAN(30) = 14
            PAN(31) = 13
          PAN(32) = 9
            PAN(33) = 4
            PAN(34) = 1
            PAN(35) = 5
            PAN(36) = 8
            PAN(37) = 10
            PAN(38) = 11
            PAN(39) = 16
            PAN(40) = 14
            PAN(41) = 18
          PAN(42) = 6
            PAN(43) = 6
            PAN(44) = 7
            PAN(45) = 8
            PAN(46) = 5
            PAN(47) = 15
            PAN(48) = 16
        ELSEIF (TYPEMA(5:6).EQ.'20') THEN
          PAN(1) = 8
            PAN(2) = 1
            PAN(3) = 4
            PAN(4) = 3
            PAN(5) = 2
            PAN(6) = 12
            PAN(7) = 11
            PAN(8) = 10
            PAN(9) = 9
          PAN(10) = 8
            PAN(11) = 1
            PAN(12) = 2
            PAN(13) = 6
            PAN(14) = 5
            PAN(15) = 9
            PAN(16) = 14
            PAN(17) = 17
            PAN(18) = 13
          PAN(19) = 8
            PAN(20) = 2
            PAN(21) = 3
            PAN(22) = 7
            PAN(23) = 6
            PAN(24) = 10
            PAN(25) = 15
            PAN(26) = 18
            PAN(27) = 14
          PAN(28) = 8
            PAN(29) = 3
            PAN(30) = 4
            PAN(31) = 8
            PAN(32) = 7
            PAN(33) = 11
            PAN(34) = 16
            PAN(35) = 19
            PAN(36) = 15
          PAN(37) = 8
            PAN(38) = 4
            PAN(39) = 1
            PAN(40) = 5
            PAN(41) = 8
            PAN(42) = 12
            PAN(43) = 13
            PAN(44) = 20
            PAN(45) = 16
          PAN(46) = 8
            PAN(47) = 5
            PAN(48) = 6
            PAN(49) = 7
            PAN(50) = 8
            PAN(51) = 17
            PAN(52) = 18
            PAN(53) = 19
            PAN(54) = 20
        ELSEIF (TYPEMA(5:6).EQ.'27') THEN
          PAN(1) = 9
            PAN(2) = 1
            PAN(3) = 4
            PAN(4) = 3
            PAN(5) = 2
            PAN(6) = 12
            PAN(7) = 11
            PAN(8) = 10
            PAN(9) = 9
            PAN(10) = 21
          PAN(11) = 9
            PAN(12) = 1
            PAN(13) = 2
            PAN(14) = 6
            PAN(15) = 5
            PAN(16) = 9
            PAN(17) = 14
            PAN(18) = 17
            PAN(19) = 13
            PAN(20) = 22
          PAN(21) = 9
            PAN(22) = 2
            PAN(23) = 3
            PAN(24) = 7
            PAN(25) = 6
            PAN(26) = 10
            PAN(27) = 15
            PAN(28) = 18
            PAN(29) = 14
            PAN(30) = 23
          PAN(31) = 9
            PAN(32) = 3
            PAN(33) = 4
            PAN(34) = 8
            PAN(35) = 7
            PAN(36) = 11
            PAN(37) = 16
            PAN(38) = 19
            PAN(39) = 15
            PAN(40) = 24
          PAN(41) = 9
            PAN(42) = 4
            PAN(43) = 1
            PAN(44) = 5
            PAN(45) = 8
            PAN(46) = 12
            PAN(47) = 13
            PAN(48) = 20
            PAN(49) = 16
            PAN(50) = 25
          PAN(51) = 9
            PAN(52) = 5
            PAN(53) = 6
            PAN(54) = 7
            PAN(55) = 8
            PAN(56) = 17
            PAN(57) = 18
            PAN(58) = 19
            PAN(59) = 20
            PAN(60) = 26
        ENDIF 
      ELSE
        CALL UTMESS('F','NOPAN',TYPEMA//' INDISPONIBLE')
      ENDIF  

      END
