      FUNCTION CRINUM (MBACKM, DEPS, MP1, MP2, DTG)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER CRINUM,I,J,L
      REAL*8  FPLAS,      GPLAS,   A
      REAL*8  MBACKM(3),  DEPS(6), MP1(3), MP2(3), DTG(6,6),
     &        ELPRED(3),  F1ELAS,  F2ELAS, G1ELAS, G2ELAS
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 18/10/2004   AUTEUR LEBOUVIE F.LEBOUVIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C     BUT        : CALCUL DU TYPE DE CRITERE DE PLASTICITE
C
C IN  R          NBACKN : MOMENT DE RAPPEL CINEMATIQUE
C     R          DEPS   : ACCROISSEMENT DE MEMBRANE ET DE COURBURE
C     R          MP1    : MOMENT LIMITE ELASTIQUE EN FLEXION POSITIVE
C     R          MP2    : MOMENT LIMITE ELASTIQUE EN FLEXION NEGATIVE
C     R          DTG    : MATRICE ELASTIQUE
C
C OUT R  CRINUM  : TYPE DE CRITERE DE PLASTICITE
C-----------------------------------------------------------------------
C
C     PREDICTION ELASTIQUE
C
      DO 10 I=4,6
        L = I-3
        A = 0.D0
        DO 20 J=1,6
           A = A + DTG(I,J)*DEPS(J)
20      CONTINUE
        ELPRED(L) = MBACKM(L)+A
C
10    CONTINUE
C
      F1ELAS = FPLAS(ELPRED,MP1)
      F2ELAS = FPLAS(ELPRED,MP2)
      G1ELAS = GPLAS(ELPRED,MP1)
      G2ELAS = GPLAS(ELPRED,MP2)
C
      IF (F1ELAS.GT.0.D0) THEN
        IF (F2ELAS.GT.0.D0) THEN
C- CRITERES 1 et 2
          CRINUM = 12
        ELSE
C- CRITERE 1
          CRINUM = 1
        ENDIF
      ELSEIF (F2ELAS.GT.0.D0) THEN
C- CRITERE 1
        CRINUM = 2
      ELSEIF (G1ELAS.GT.0.D0) THEN
C- CRITERE 1
        CRINUM = 1
      ELSEIF (G2ELAS.GT.0.D0) THEN
C- CRITERE 1
        CRINUM = 2
      ELSE
C- CAS ELASTIQUE
        CRINUM = 0
      ENDIF
C
      END 
