      SUBROUTINE DCPNMF(MOM,DEPS,DC,DTG,NEXMOM,DCP)
      IMPLICIT NONE
      COMMON /TDIM/ N, ND
      REAL*8 MOM(3),    DEPS(6), DC(3,3), DTG(6,6), NEXMOM(3), DET
      REAL*8 INVDC(3,3),S,       TMP(3),  DCP(3),   MATMP(3,6)
      INTEGER N, ND
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 18/10/2004   AUTEUR LEBOUVIE F.LEBOUVIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C     BUT    :  CALCUL DE L'INCREMENT DE COURBURE PLASTIQUE
C               QUAND LE PROCHAIN POINT M-BACKM EST FIXE ET UN CRITERE
C               DE PLASTICITE EGAL A 2
C
C IN    R  MOM    : MOMENT - MOMENT DE RAPPEL
C       R  DC     : CONSTANTE DE PRAGER
C       R  DEPS   : INCREMENT DE DEFORMATION (MEMBRANE, COURBURE)
C       R  DTG    : MATRICE TANGENTE
C       R  NEXMOM : NOUVEAU MOMENT
C        
C OUT   R  DCP    : INCREMENT DE COURBURE PLASTIQUE
C-----------------------------------------------------------------------
C   
C     DETERMINANT
      DET=DC(1,1)*DC(2,2)-DC(1,2)*DC(2,1)
C
      CALL INITMA(3,3,INVDC)
C
C     DETERMINATION DE INVDC
      INVDC(1,1)=DC(2,2)/DET
      INVDC(2,2)=DC(1,1)/DET
      INVDC(2,1)=-DC(1,2)/DET
      INVDC(1,2)=-DC(2,1)/DET
      INVDC(3,3)=1.D0/DC(3,3)
C
C     EXTRACTION DU BLOC INFERIEUR 3x6 DE DTG
      CALL EXTMAT(DTG,6,3,6,'IG',MATMP)
C
      CALL PRMRVE(MATMP,3,6,DEPS,TMP)
C
      N = 3
      CALL LCSOVE(TMP,MOM,TMP)
      CALL LCDIVE(TMP,NEXMOM,TMP)
      CALL PMAVEC('ZERO',3,INVDC,TMP,DCP)
C
      END
