      SUBROUTINE EXTMAT(A,N,NL,NC,POS,B)
      IMPLICIT NONE
      INTEGER NL,NC,I,J,K,N
      REAL*8  A(N,N),B(NL,NC)
      CHARACTER*2 POS
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 18/10/2004   AUTEUR LEBOUVIE F.LEBOUVIER 
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C-----------------------------------------------------------------------
C    ROUTINE QUI PERMET D'EXTRAIRE UNE SOUS MATRICE D'UNE MATRICE CARREE
C
C     IN  A   : MATRICE CARRE DE DIMENSION NxN         (REAL)
C         N   : NOMBRE DE LIGNES DE LA MAT A           (INTEGER)
C         NL  : NOMBRE DE LIGNES A EXTRAIRE            (INTEGER)
C         NC  : NOMBRE DE COLONNES A EXTRAIRE          (INTEGER)
C         POS : POSITION DE LA SOUS-MATRICE            (CHARACTER)
C             -> 'SD' : SOUS-MATRICE SUPERIEURE DROITE
C             -> 'SG' : SOUS-MATRICE SUPERIEURE GAUCHE
C             -> 'ID' : SOUS-MATRICE INFERIEURE DROITE
C             -> 'IG' : SOUS-MATRICE INFERIEURE GAUCHE
C     OUT B   : SOUS-MATRICE DE DIMENSION NLxNC        (REAL)
C ----------------------------------------------------------------------
      IF(POS.EQ.'SD')THEN
         DO 10 I=1,NL
            DO 20 J=1,NC
               B(I,J)=A(I,J+N-NC)
 20         CONTINUE
 10      CONTINUE
      ELSEIF(POS.EQ.'SG')THEN
         DO 30 I=1,NL
            DO 40 J=1,NC
               B(I,J)=A(I,J)
 40         CONTINUE
 30      CONTINUE
      ELSEIF(POS.EQ.'ID')THEN
          DO 50 I=1,NL
            DO 60 J=1,NC
               B(I,J)=A(I+N-NL,J+N-NC)
 60         CONTINUE
 50      CONTINUE
      ELSEIF(POS.EQ.'IG')THEN
          DO 70 I=1,NL
            DO 80 J=1,NC
               B(I,J)=A(I+N-NL,J)
 80         CONTINUE
 70      CONTINUE
      ELSE
         CALL UTMESS('F','EXTMAT','ERREUR D''EXTRACTION')
      ENDIF
      END
