      SUBROUTINE GKMET3(NNOFF,CHFOND,IADRGK,IADGKS,IADGKI,ABSCUR,NUM)
      IMPLICIT NONE

      INTEGER         NNOFF,IADRGK,IADGKS,IADGKI,NUM
      CHARACTER*24    CHFOND,ABSCUR


C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 30/03/2004   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
C ......................................................................
C      METHODE THETA-LAGRANGE ET G-LAGRANGE POUR LE CALCUL DE G(S)
C      K1(S) K2(S) ET K3(S) DANS LE CADRE X-FEM
C
C ENTREE
C
C     MODELE   --> NOM DU MODELE
C     NNOFF    --> NOMBRE DE NOEUDS DU FOND DE FISSURE
C     NORMFF   --> VALEURS DE LA NORMALE SUR LE FOND DE FISSURE
C     FOND     --> NOMS DES NOEUDS DU FOND DE FISSURE
C     IADRGK    --> ADRESSE DE VALEURS DE GKTHI
C                 (G, K1, K2, K3 POUR LES CHAMPS THETAI)
C
C  SORTIE
C
C   IADGKS     --> ADRESSE DE VALEURS DE GKS 
C                   (VALEUR DE G(S), K1(S), K2(S), K3(S))
C   IADGKI     --> ADRESSE DE VALEURS DE GKTHI
C                  (G, K1, K2, K3 POUR LES CHAMPS THETAI)
C   ABSCUR     --> VALEURS DES ABSCISSES CURVILIGNES S
C      NUM     --> 3 (LAGRANGE-LAGRANGE)
C              --> 4 (NOEUD-NOEUD)
C
      INTEGER      IFON,IADABS,IVECT,IMATR
      INTEGER      I,IBID,KK,J
      REAL*8       S1,S2,DELTA,S3,SN2,SN1,SN
      REAL*8       GTHI(NNOFF),K1TH(NNOFF),K2TH(NNOFF),K3TH(NNOFF)
      REAL*8       GS(NNOFF),K1S(NNOFF),K2S(NNOFF),K3S(NNOFF)
      CHARACTER*24 LISSG,VECT,MATR

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX --------------------
C
      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24CM
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24CM(1),ZK32(1),ZK80(1)
C
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------

      CALL JEMARQ()

      CALL JEVEUO(CHFOND,'L',IFON)
      CALL JEVEUO(ABSCUR,'L',IADABS)
      DO 10 I=1,NNOFF
        ZR(IADABS-1+(I-1)+1)=ZR(IFON-1+4*(I-1)+4)
10    CONTINUE

      CALL GETVTX(' ','LISSAGE_G',0,1,1,LISSG,IBID)
C
      IF (LISSG .EQ. 'LAGRANGE_NO_NO') THEN
        VECT = '&&METHO3.VECT'
        CALL WKVECT(VECT,'V V R8',NNOFF,IVECT)
        NUM = 4
        DO 20 I = 1,NNOFF-1
          S1 = ZR(IADABS+I-1)
          S2 = ZR(IADABS+I+1-1)
          DELTA = (S2-S1) / 3.D0
          ZR(IVECT+I-1) = ZR(IVECT+I-1) + DELTA
          ZR(IVECT+I+1-1) = 2.D0 * DELTA
 20     CONTINUE
        CALL UTMESS('F','GKMET3','METHODE LAG NO-NO PAS FINIE')
C
      ELSEIF (LISSG .EQ. 'LAGRANGE') THEN
        MATR = '&&METHO3.MATRI'

        CALL WKVECT(MATR,'V V R8',NNOFF*NNOFF,IMATR)

        NUM = 3
        DO 40 I = 1,NNOFF-1
          S1 = ZR(IADABS+I-1)
          S2 = ZR(IADABS+I)
          DELTA = (S2-S1) / 6.D0
C
          KK = IMATR + (I-1)*NNOFF + I - 1
          ZR(KK) = ZR(KK) + 2.D0*DELTA
          ZR(IMATR+(I-1+1)*NNOFF+I-1) = 1.D0 * DELTA
C
          ZR(IMATR+(I-1)*NNOFF+I-1+1) = 1.D0 * DELTA
          ZR(IMATR+(I-1+1)*NNOFF+I-1+1) = 2.D0 * DELTA
 40     CONTINUE

        DO 50 I=1,NNOFF
          GTHI(I)=ZR(IADRGK-1+(I-1)*4+1)
          K1TH(I)=ZR(IADRGK-1+(I-1)*4+2)
          K2TH(I)=ZR(IADRGK-1+(I-1)*4+3)
          K3TH(I)=ZR(IADRGK-1+(I-1)*4+4)
 50     CONTINUE        

        S1 = ZR(IADABS-1+1)
        S2 = ZR(IADABS-1+2)
        S3 = ZR(IADABS-1+3)
        SN2 = ZR(IADABS-1+NNOFF-2)
        SN1 = ZR(IADABS-1+NNOFF-1)
        SN =  ZR(IADABS-1+NNOFF)

        GTHI(1)=GTHI(2)*(S2-S1)/(S3-S1)
        K1TH(1)=K1TH(2)*(S2-S1)/(S3-S1)
        K2TH(1)=K2TH(2)*(S2-S1)/(S3-S1)
        K3TH(1)=K3TH(2)*(S2-S1)/(S3-S1)
        GTHI(NNOFF)=GTHI(NNOFF-1)*(SN-SN1)/(SN-SN2)
        K1TH(NNOFF)=K1TH(NNOFF-1)*(SN-SN1)/(SN-SN2)
        K2TH(NNOFF)=K2TH(NNOFF-1)*(SN-SN1)/(SN-SN2)
        K3TH(NNOFF)=K3TH(NNOFF-1)*(SN-SN1)/(SN-SN2)

C       SYSTEME LINEAIRE:  MATR*GS = GTHI
        CALL GSYSTE(MATR,NNOFF,NNOFF,GTHI,GS)

C       SYSTEME LINEAIRE:  MATR*K1S = K1TH
        CALL GSYSTE(MATR,NNOFF,NNOFF,K1TH,K1S)

C       SYSTEME LINEAIRE:  MATR*K2S = K2TH
        CALL GSYSTE(MATR,NNOFF,NNOFF,K2TH,K2S)

C       SYSTEME LINEAIRE:  MATR*K3S = K3TH
        CALL GSYSTE(MATR,NNOFF,NNOFF,K3TH,K3S)

        DO 60 I=1,NNOFF
          ZR(IADGKS-1+(I-1)*4+1)=GS(I)
          ZR(IADGKS-1+(I-1)*4+2)=K1S(I)
          ZR(IADGKS-1+(I-1)*4+3)=K2S(I)
          ZR(IADGKS-1+(I-1)*4+4)=K3S(I)
 60     CONTINUE

      ENDIF

      DO 70 I=1,NNOFF*4
          ZR(IADGKI-1+I)=ZR(IADRGK-1+I)
 70     CONTINUE

      CALL JEDETR('&&METHO3.MATRI')
      CALL JEDETR('&&METHO3.VECT')

      CALL JEDEMA()
      END
