      FUNCTION GPLAS (MOM, PLASMO)
      IMPLICIT NONE
      REAL*8 GPLAS
      REAL*8 MOM(3), PLASMO(3), X, Y, COEF
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 18/10/2004   AUTEUR LEBOUVIE F.LEBOUVIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C     BUT    : CALCUL DE LA FONCTION G ASSOCIE A LA FONCTION SEUIL F   
C
C IN  R  MOM     : MOMENT - MOMENT DE RAPPEL (M-BACKM)
C     R  PLASMO  : MOMENTS LIMITES ELASTIQUES DANS LE REPERE ORTHOTROPE
C
C OUT R  GPLAS   : VALEUR DE LA FONCTION G ASSOCIE AU CRITERE DE 
C                  PLASTICITE F
C-----------------------------------------------------------------------
C
      X = MOM(1)-PLASMO(1)
      Y = MOM(2)-PLASMO(2)
      COEF = 1.001D0
      IF (PLASMO(1) .GT. 0.D0) THEN
            GPLAS =  MAX(COEF*X + Y, X/COEF + Y)
      ELSE
            GPLAS =  MAX(-COEF*X - Y,-X/COEF - Y)               
      ENDIF
      END 
