      SUBROUTINE PROJZ2(SIGMIN,SIGMAX,SIG0,NCMP,ALPHA2)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 10/11/1999   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C TOLE CRP_7
      IMPLICIT  REAL*8 (A-H,O-Z)
C ----------------------------------------------------------------------
C     BUT: PROJECTION D'UN POINT SUR DEUX SPHERES (METHODE ZAC)
C
C     IN   SIGMIN,SIGMAX  (CENTRE DES SPHERES)
C          SIG0           (RAYON DES SPHERES)
C          NCMP           (NOMBRE DE COMPOSANTES)
C     VAR  ALPHA2         (POINT PROJETE)
C ----------------------------------------------------------------------
      REAL*8    SIGMIN(*),SIGMAX(*),SIG0,ALPHA2(*)
      INTEGER   NCMP
      REAL*8    DELTA1(6),DELTA2(6),NORM1,NORM2,NORSIG
      EXTERNAL  NORSIG
C
      EPSI = 1.D-4
      R3S2 = SQRT(3.D0/2.D0)
C
 998  CONTINUE
C
      DO 112 I=1,NCMP
         DELTA1(I) = ALPHA2(I) - SIGMIN(I)
         DELTA2(I) = ALPHA2(I) - SIGMAX(I)
 112  CONTINUE
      NORM1 = R3S2*NORSIG(DELTA1,NCMP)
      NORM2 = R3S2*NORSIG(DELTA2,NCMP)
      IF (((NORM1-SIG0).LE.EPSI).AND.
     &    ((NORM2-SIG0).LE.EPSI)) GOTO 9999
C
      IF (NORM1.GE.NORM2) THEN
C
          DO 113 I=1,NCMP
             ALPHA2(I) = SIGMIN(I) + SIG0*DELTA1(I)/NORM1
 113      CONTINUE
C
       ELSE
C
          DO 114 I=1,NCMP
             ALPHA2(I) = SIGMAX(I) + SIG0*DELTA2(I)/NORM2
 114      CONTINUE
C
       END IF
       GOTO 998
C
9999   CONTINUE
C
      END
