      SUBROUTINE TE0532(OPTION,NOMTE)
      IMPLICIT   NONE
      CHARACTER*16 OPTION,NOMTE

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 25/01/2005   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C.......................................................................
C
C                CONTACT X-FEM MTHODE CONTINUE : 
C         CONVERGENCE DE LA BOUCLE SUR LES CONTRAINTES ACTIVES
C
C
C  OPTION : 'XCVBCA' (X-FEM CONVERGENCE BOUCLE CONTRAINTES ACTIVES )

C  ENTREES  ---> OPTION : OPTION DE CALCUL
C           ---> NOMTE  : NOM DU TYPE ELEMENT
C
C......................................................................
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX --------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR 
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX --------------------

      INTEGER      I,J,L,IJ,IFA,IPGF,INO,ISSPG,NI,NJ,NLI,NLJ,PLI,PLJ
      INTEGER      JINDCO,JDONCO,JLSN,IPOIDS,IVF,IDFDE,JGANO,IGEOM
      INTEGER      IDEPM,IDEPL,IMATT,JPTINT,JAINT,JCFACE,JLONCH
      INTEGER      IPOIDF,IVFF,IDFDEF,IADZI,IAZK24,IBID,JOUT1,JOUT2
      INTEGER      NDIM,DDLH,DDLC,DDLE,DDLS,NNO,NNOS,NNOM,NNOF
      INTEGER      NPG,NPGF,XOULA,INCOCA
      INTEGER      INDCO(60),NINTER,NFACE,CFACE(5,3)

      CHARACTER*8   ELREF,TYPMA
      REAL*8        HE,SIGN,VTMP(27*7),SOMME,FFI,REAC,JAC,FFP(27),PREC
      REAL*8        ND(3),DN,SAUT(3),LAMBDA
      PARAMETER    (PREC=1.D-16)
C......................................................................

      CALL JEMARQ()
C
      INCOCA=1
 
      CALL ELREF1(ELREF)
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)
C
C     DDL PAR NOEUD SOMMET : HEAVISIDE, ENRICHIS (FOND), CONTACT
      DDLH=3
      DDLE=0
      DDLC=3
C     NB DE 'NOEUDS MILIEU' SERVANT  PORTER DES DDL DE CONTACT
      NNOM=3*(NNO/2)

C     NOMBRE DE DDL  CHAQUE NOEUD SOMMET 
      DDLS=NDIM+DDLH+DDLE+DDLC
C
C     RECUPERATION DES ENTRES / SORTIE
      CALL JEVECH('PGEOMER','E',IGEOM)
C     DEPLACEMENT  L'QUILIBRE PRCDENT  (DEPMOI) : 'PDEPL_M'
      CALL JEVECH('PDEPL_M','L',IDEPM)
C     DEPLACEMENT COURANT (DEPPLU) : 'PDEPL_P'
      CALL JEVECH('PDEPL_P','L',IDEPL)
      CALL JEVECH('PINDCOI','L',JINDCO)
      CALL JEVECH('PLEVSET','L',JLSN)
      CALL JEVECH('PPINTER','L',JPTINT)
      CALL JEVECH('PAINTER','L',JAINT)
      CALL JEVECH('PCFACE','L',JCFACE)
      CALL JEVECH('PLONCHA','L',JLONCH)

      CALL JEVECH('PINCOCA','E',JOUT1)
      CALL JEVECH('PINDCOO','E',JOUT2)

C     RCUPRATIONS DES DONNES SUR LE CONTACT ET
C     SUR LA TOPOLOGIE DES FACETTES
      DO 10 I=1,60
        INDCO(I) = ZI(JINDCO-1+I)
 10   CONTINUE
C
      NINTER=ZI(JLONCH-1+1)
      NFACE=ZI(JLONCH-1+2)
      DO 15 I=1,NFACE
        DO 16 J=1,3
          CFACE(I,J)=ZI(JCFACE-1+3*(I-1)+J)
   16   CONTINUE
 15   CONTINUE
C
      IF (NINTER.LT.3)  GOTO 9999
C
C     REACTUALISATION DE LA GEOMETRIE AVEC DEPMOI 
      DO 20 I = 1,NNO       
        HE=SIGN(1.D0,ZR(JLSN-1+I))
        DO 30 J = 1,NDIM
          ZR(IGEOM-1+(I-1)*NDIM+J) = ZR(IGEOM-1+(I-1)*NDIM+J) +
     &    ZR(IDEPM-1+(I-1)*DDLS+J) + HE * ZR(IDEPM-1+(I-1)*DDLS+J+3)
 30     CONTINUE
 20   CONTINUE
C
      CALL TECAEL(IADZI,IAZK24)
      TYPMA=ZK24(IAZK24-1+3+ZI(IADZI-1+2)+3)

C      WRITE(6,*)' '
C      WRITE(6,697)
C 697  FORMAT(4X,'I_IN',7X,'DN',11X,'REAC',7X,'I_OUT')
C
C     BOUCLE SUR LES FACETTES
      DO 100 IFA=1,NFACE
C
C       LA FAMILLE 'XCON' A 12 PG INTEGRE ORDRE I+J=6
        CALL ELREF4('TR3','XCON',IBID,NNOF,IBID,NPGF,IPOIDF,IVFF,
     &                                                     IDFDEF,IBID)
        
C       BOUCLE SUR LES POINTS DE GAUSS DES FACETTES
        DO 110 IPGF=1,NPGF
C
C         INDICE DE CE POINT DE GAUSS DANS INDCO
          ISSPG=NPGF*(IFA-1)+IPGF
C
C         CALCUL DE JAC (PRODUIT DU JACOBIEN ET DU POIDS)        
C         ET DES FF DE L'LMENT PARENT AU POINT DE GAUSS
C         ET LA NORMALE ND ORIENTE DE ESCL -> MAIT
          CALL XJACFF(ELREF,JPTINT,IFA,CFACE,IPGF,NNO,IGEOM,JAC,FFP,ND)
C
C         CALCUL DE LA DISTANCE DN
          DN = 0.D0
          DO 140 J = 1,DDLH
            SAUT(J)=0.D0
            DO 141 I = 1,NNO
              SAUT(J) = SAUT(J) - 2 * FFP(I) * 
     &        (ZR(IDEPM-1+DDLS*(I-1)+J+3)+ZR(IDEPL-1+DDLS*(I-1)+J+3)) 
 141        CONTINUE
            DN = DN + SAUT(J)*ND(J)
 140      CONTINUE

C         CALCUL DE LA REACTION A PARTIR DES LAMBDA DE DEPPLU
          REAC = 0.D0
          DO 150 I = 1,NNOF
            FFI=ZR(IVFF-1+NNOF*(IPGF-1)+I)
            NI=XOULA(CFACE,IFA,I,JAINT,TYPMA)
            CALL XPLMAT(NDIM,DDLH,DDLE,DDLC,NNO,NNOM,NI,PLI)
            LAMBDA = ZR(IDEPL-1+PLI)
            REAC = REAC + FFI * LAMBDA
 150      CONTINUE
              
C         ON REGARDE LA DISTACE DN DES POINTS SUPPOSS NON CONTACTANT :
C         INTERPNPRATION EQUIVAUT  DN > 0 (ICI DN > 1E-16 )
          IF (INDCO(ISSPG).EQ.0) THEN

            IF (DN.GT.PREC) THEN
              ZI(JOUT2-1+ISSPG) = 1
              INCOCA = 0
            ELSE
              ZI(JOUT2-1+ISSPG) = INDCO(ISSPG)
            END IF           
C
C         ON REGARDE LA REACTION POUR LES POINTS SUPPOSS CONTACTANT : 
          ELSE IF (INDCO(ISSPG).EQ.1) THEN

            IF (REAC.GT.PREC) THEN
              ZI(JOUT2-1+ISSPG) = 0
              INCOCA = 0
            ELSE
              ZI(JOUT2-1+ISSPG) = INDCO(ISSPG)
            END IF
C
          ELSE
C           SI INDCO N'EST NI GAL  0 NI GAL  1
            CALL UTMESS('F','TE0532','PB DE STATUT DE CONTACT') 
          END IF
C
C         IMPRESSION 
C          WRITE(6,698),INDCO(ISSPG),DN,REAC,ZI(JOUT2-1+ISSPG)
C 698      FORMAT(5X,I1,4X,E11.5,4X,E11.5,4X,I1)       

 110    CONTINUE
 100  CONTINUE
C
 9999 CONTINUE

C     ENREGISTREMENT DES CHAMPS DE SORTIE
      ZI(JOUT1)=INCOCA

      CALL JEDEMA()
      END
