      SUBROUTINE XJACOB(NNO,DFF,IGEOM,INVJAC)
      IMPLICIT NONE
      INTEGER    NNO,IGEOM
      REAL*8     DFF(3,*),INVJAC(3,3)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 05/07/2004   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C ----------------------------------------------------------------------
C FONCTION REALISEE:  CALCUL DE L'INVERSE DE LA JACONIENNE EN XE
C                        
C    ENTREE:
C        NNO    :  NOMBRE DE NOEUDS DE L'ELEMENT
C        DFF    :  DRIVES DES FONCTION DES FORMES AU POINT XE
C        IGEOM  :  COORDONNES DES NOEUDS DE L'LMENT
C    SORTIE:
C        INVJAC : INVERSE DE LA JACONIENNE AU POINT XE
C.......................................................................
C
      INTEGER       I,J,K
      REAL*8        JACOBI(3,3)

C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
C------------FIN  COMMUNS NORMALISES  JEVEUX  --------------------------

      CALL JEMARQ()

C     JACOBIENNE EN XE
      CALL MATINI(3,3,0.D0,JACOBI)
      DO 100 I=1,3
        DO 110 J=1,3
          DO 120 K=1,NNO
            JACOBI(I,J) = JACOBI(I,J) + DFF(J,K) * ZR(IGEOM-1+3*(K-1)+I)
 120       CONTINUE
 110     CONTINUE
 100   CONTINUE

C     INVERSE DE LA JACOBIENNE
      CALL MATINV(3,JACOBI,INVJAC)  
           
      CALL JEDEMA()
      END
