      SUBROUTINE ARLDEG(TMA0,TMA1,TMA2,TYPEMA,NUMERO,NMAMA,NF,FAM)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 08/11/2004   AUTEUR DURAND C.DURAND 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C                                                                       
C                                                                       
C ======================================================================
C ----------------------------------------------------------------------
C SELECTION DE LA FAMILLE DE QUADRATURE POUR INTEGRER COUPLAGE ARLEQUIN
C ----------------------------------------------------------------------
C VARIABLES D'ENTREE 
C CHARACTER*8    TMA0      : TYPE DE LA MAILLE SUPPORT INTEGRATION  
C CHARACTER*8    TMA1      : TYPE D'UNE MAILLE DE DISCRETISATION  
C CHARACTER*8    TMA2      : TYPE DE L'AUTRE MAILLE DE DISCRETISATION
C
C VARIABLES D'ENTREE / SORTIE 
C CHARACTER*8    TYPEMA(NF) : TYPE DE LA MAILLE SUPPORT (TMS) POUR 
C                             CHAQUE FAMILLE (TMS FAM.1, TMS FAM.2, ...)
C INTEGER        NUMERO(NF) : NUMERO DE LA FORMULE D'INTEGRATION (NFI)
C                             (NFI FAM.1, NFI FAM.2, ...)
C INTEGER        NMAMA(NF)  : NOMBRE DE COUPLES DE MAILLE (NCM) ASSOCIE
C                             A CHAQ FAMILLE (NCM FAM.1, NCM FAM.2, ...)
C INTEGER        NF         : NOMBRE DE FAMILLES DE QUADRATURE
C
C VARIABLES DE SORTIE
C INTEGER        FAM        : NUMERO DE LA FAMILLE
C ----------------------------------------------------------------------

      IMPLICIT NONE

C --- VARIABLES
      CHARACTER*8 TMA0,TMA1,TMA2,TYPEMA(*)
      INTEGER     NUMERO(*),NMAMA(*),NF,FAM
      INTEGER     TYPEDG,FG,I,D0(4),D1(4),D2(4)

C --- DEGRE DU POLYNOME A INTEGRER

      TYPEDG = 0
      CALL FORMEN(TMA0,TYPEDG,D0)
      CALL FORMEN(TMA1,TYPEDG,D1)
      CALL FORMEN(TMA2,TYPEDG,D2)
      I = D1(1)+D2(1)+D0(3)

C --- CHOIX DE LA FORMULE D'INTEGRATION

      CALL NPGAUS(TMA0,I,FG)

C --- RECHERCHE SI LA FAMILLE (TMA1,FG) EXISTE DEJA

      DO 10 I = 1, NF
        IF ((TMA0.EQ.TYPEMA(I)).AND.(FG.EQ.NUMERO(I))) GOTO 20
 10   CONTINUE

C --- NOUVELLE FAMILLE

      NF = NF + 1
      TYPEMA(NF) = TMA0
      NUMERO(NF) = FG
      I = NF

 20   CONTINUE

      NMAMA(I) = NMAMA(I) + 1
      FAM = I

      END
