      SUBROUTINE CALICO(CHARZ,NOMAZ,LIGRMZ,NDIM,FONREE)
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 02/11/2004   AUTEUR MABBAS M.ABBAS 
C TOLE CRP_20
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT      NONE
      CHARACTER*(*) CHARZ
      CHARACTER*(*) NOMAZ
      CHARACTER*(*) LIGRMZ
      INTEGER       NDIM
      CHARACTER*4   FONREE
C      CHARACTER*(*) MOTFAZ 
C
C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : CHARME
C ----------------------------------------------------------------------
C
C TRAITEMENT DU MOT-FACTEUR 'CONTACT' DANS AFFE_CHAR_MECA.
C
C IN  CHARZ  : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  NOMAZ  : NOM DU MAILLAGE
C IN  LIGRMZ : NOM DU LIGREL DU MODELE
C IN  NDIM   : NOMBRE DE DIMENSIONS DU PROBLEME
C IN  FONREE : FONC OU REEL SUIVANT L'OPERATEUR
C
C LES RESULTATS SONT STOCKES DANS LA SD CHAR(1:8)//'.CONTACT'//
C '.METHCO'  : CARACTERISTIQUES DE LA METHODE                  (METHCO)
C '.CHAMCO'  : CHAMP AFFECTE PAR LA RELATION UNILATERALE       (CHAMCO)
C '.COEFCO'  : COEFFICIENT POUR CHAQUE ZONE                    (COEFCO)
C '.DIRCO'   : DIRECTION FIXE D'APPARIEMENT PAR ZONE           (DIRCO)
C '.PZONECO' : POINTEUR ASSOCIE AUX ZONES DE CONTACT           (PZONE)
C '.MAILCO'  : LISTE DES MAILLES DES DIFFERENTES SURFACES      (CONTMA)
C '.PSUMACO' : POINTEUR ASSOCIE                                (PSURMA)
C '.NOEUCO'  : LISTE DES NOEUDS DES DIFFERENTES SURFACES       (CONTNO)
C '.PSUNOCO' : POINTEUR ASSOCIE                                (PSURNO)
C '.SSNOCO'  : LISTE DES NOEUDS INTERDITS COMME ESCLAVES       (SANSNO)
C '.PSSNOCO' : POINTEUR ASSOCIE (ZONE PAR ZONE)                (PSANS)
C '.MANOCO'  : LISTE DES MAILLES CONTENANT UN NOEUD DE CONTACT (MANOCO)
C '.PMANOCO' : POINTEUR ASSOCIE                                (PMANO)
C '.NOMACO'  : LISTE DES NOEUDS DES MAILLES DE CONTACT         (NOMACO)
C '.PNOMACO' : POINTEUR ASSOCIE                                (PNOMA)
C '.MAMACO'  : INDICE DES MAILLES ADJACENTES A UNE MAILLE      (MAMACO)
C '.PMAMACO' : POINTEUR ASSOCIE                                (PMAMA)
C '.NDIMCO'  : LISTE D'ENTIERS UTILES (DIMENSION DES VECTEURS) (NDIMCO)
C '.JSUPCO'  : JEU FICTIF (A SOUSTRAIRE AU VRAI JEU)           (JEUSUP)
C '.JFO1CO'  : JEU FICTIF FONCTION (A SOUSTRAIRE AU VRAI JEU)  (JEUFO1)
C '.JFO2CO'  : JEU FICTIF FONCTION (A SOUSTRAIRE AU VRAI JEU)  (JEUFO2)
C '.NOZOCO'  : NUMERO DE LA ZONE POUR CHAQUE NOEUD DE CONTACT  (NOZOCO)
C '.SYMECO'  : REPERAGE DES ZONES DE CONTACT SYMETRIQUES       (SYMECO)
C ======================================================================
C VOIR LE DOCUMENT D4.06.14 POUR TOUS LES DETAILS. ---------------------
C ======================================================================
C IN  CHARZ  : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  MOTFAZ : MOT-CLE FACTEUR (VALANT 'CONTACT')
C IN  NOMAZ  : NOM DU MAILLAGE
C IN  NOMOZ  : NOM DU MODELE
C IN  NDIM   : NOMBRE DE DIMENSIONS DU PROBLEME
C ======================================================================
C ------------------------- VARIABLES LOCALES --------------------------
C ======================================================================
C NZOCO  : NOMBRE DE ZONES DE CONTACT (OCCURENCES DU MOT-CLE CONTACT)
C NSUCO  : NOMBRE TOTAL DE SURFACES DE CONTACT
C NMACO  : NOMBRE TOTAL DE MAILLES DES SURFACES
C NNOCO  : NOMBRE TOTAL DE NOEUDS DES SURFACES
C METHCO : TABLEAU DONNANT LES CARACTERISTIQUES DE LA METHODE
C          DE TRAITEMENT DU CONTACT UNILATERAL
C       METHCO (1) = NOMBRE DE ZONES DE CONTACT NZOCO
C       POUR LA ZONE N :
C       METHCO(1+10*(N-1)+1) = TYPE D'APPARIEMENT
C         - -1 SI 'NON'
C         -  0 SI 'NODAL' OU 'NODAL_SYME'
C         -  1 SI 'MAIT_ESCL' OU 'MAIT_ESCL_SYME'
C         -  2 SI 'TERRITOIRE'
C         -  3 SI 'HIERARCHIQUE'
C         -  4 SI NODAL ET DIRECTION FIXEE DANS LE FICHIER DE COMMANDES
C       METHCO(1+10*(N-1)+2) = DEFINITION D UNE DIRECTION TANGENTE
C                            (POUR LE FROTTEMENT)
C         - 0 SI NON DEFINIE
C         - 1 SI DEFINIE
C       METHCO(1+10*(N-1)+3) = ORDRE MAITRE-ESCLAVE
C         - 1 SI UTILISE     (APPARIEMENT SYMETRISE)
C         - 0 SI PAS UTILISE (APPARIEMENT NON SYMETRISE)
C       METHCO(1+10*(N-1)+4) = TYPE DE PROJECTION
C         - 1 SI LINEAIRE
C         - 2 SI QUADRATIQUE
C       METHCO(1+10*(N-1)+5) = TYPE DE REACTUALISATION
C         - +   1 SI PAR DOUBLE BOUCLE SYSTEMATIQUE
C         - +/- 2 SI PAR VOISINAGE
C         - +/- 3 SI PAR BOITE
C         - > 0 SI ON PASSE D'ABORD PAR LE NOEUD LE PLUS PROCHE
C         - < 0 SI ON CHERCHE DIRECTEMENT LA MAILLE LA PLUS PROCHE
C       METHCO(1+10*(N-1)+6) = ALGORITHME UTILISE
C         - -1    PENALISATION    CONTACT                    2D/3D
C         -  0    CONTRAINTE      CONTACT                    2D/3D
C         -  1    LAGRANGIEN      CONTACT                    2D/3D
C         -  2    LAGRANGIEN      CONTACT ET FROTTEMENT      2D
C         -  3    PENALISATION    CONTACT ET FROTTEMENT      2D/3D
C         -  4    LAGRANGIEN      CONTACT ET FROTTEMENT      3D
C         -  5    PENALISATION    SEULEMENT SUR FROTTEMENT   2D/3D
C         -  6    CONTINUE        CONTACT ET FROTTEMENT      2D/3D
C       METHCO(1+10*(N-1)+7) = FREQUENCE DE REACTUALISATION GEOMETRIQUE
C         -  0    AUCUNE
C         -  1    1 PAR PAS DE CHARGE
C         -  2    2 PAR PAS DE CHARGE
C       METHCO(1+10*(N-1)+8) = NORMALE UTILISEE
C         -  0    NORMALE MAITRE
C         -  1    MOYENNE NORMALE MAITRE+ESCLAVE
C       METHCO(1+10*(N-1)+9) = STOP SI MATRICE DE CONTACT SINGULIERE
C         -  0    OUI
C         -  1    NON
C       METHCO(1+10*(N-1)+10) =NOMBRE DE PAQUETS POUR RESOLUTION DU 
C              SYSTEME LINEAIRE 10 PAR DEFAUT
C TOLECO : CONTROLE DE LA PROJECTION HORS-ZONE (MAILLE OU NOEUD)
C       TOLECO(1+2*(N-1))  = VALEUR DU LAMBDA CRITIQUE AUTORISE
C                            POUR LES MAILLES
C         - <0    LA PROJECTION HORS DE LA MAILLE EST INTERDITE
C         - >0    LA PROJECTION HORS DE LA MAILLE EST AUTORISEE DE LA 
C                   VALEUR TOLE_PROJ_EXT
C       TOLECO(1+2*(N-1)+1)= VALEUR DU LAMBDA CRITIQUE AUTORISE
C                            SUR LES ENTITES GEOMETRIQUES
C                            INTERNES (NOEUDS, ARETES, DIAGONALES) 
C         - <0    LA PROJECTION SUR EST INTERDITE
C         - >0    LA PROJECTION SUR EST AUTORISEE A LA 
C                      TOLERANCE TOLE_PROJ_INT PRES
C
C SANSNQ : VAUT 1 SI ON NE FAIT PAS LES LIAISONS LINEAIRES POUR LES
C          NOEUDS QUADRATIQUES (VOIR CACOEQ)
C SYMECO : DONNEES SUR LES APPARIEMENTS SYMETRIQUES
C
C  CHAQUE ZONE DE CONTACT DECRITE COMME UNE APPARIEMENT SYMETRIQUE VA
C   CREER UNE ZONE DE CONTACT SUPPLEMENTAIRE A LA FIN DES ZONES
C       SYMECO (1) = NOMBRE DE ZONES DE CONTACT SYMETRIQUES
C       SYMECO(1+N): NUMERO DE LA ZONE DE REFERENCE POUR LA SYMETRIE
C
C CHAMCO : CHAMP IMPACTE PAR LA CONDITION UNILATERALE POUR CHAQUE ZONE
C          (DIM NZOCO)
C         - +/-1 : DEPLACEMENT
C         -   -2 : PRESSION (ELEMENTS THM UNIQUEMENT)
C         -   -3 : TEMPERATURE (ELEMENTS THM UNIQUEMENT)
C         -   -4 : PRESSION1 (ELEMENTS THM UNIQUEMENT)
C         -   -5 : PRESSION2 (ELEMENTS THM UNIQUEMENT)
C NORLI : UTILISATION DU LISSAGE DES NORMALES OU NON
C         -   0 : PAS DE LISSAGE
C         -   1 : LISSAGE
C COEFCO : COEFFICIENT MULTIPLICATEUR DE LA CONDITION UNILATERALE
C          POUR LA PRESSION OU LA TEMPERATURE (DIM NZOCO)
C DIRCO  : DANS LE CAS D'UN APPARIEMENT NODAL DANS UNE DIRECTION FIXE
C          (PRESENCE DU MOT-CLE FACTEUR DIRECTION), CONTIENT POUR
C          CHAQUE ZONE LES 3 COMPOSANTES DEFINISSANT LA DIRECTION
C          UTILISEE POUR APPARIEMENT ET ECRITURE DE LA RELATION DE
C          NON PENETRATION.
C PZONE  : POINTEUR DES ZONES DE CONTACT (DIM NZOCO+1)
C CONTMA : LISTE DES MAILLES DE CONTACT (DIM NMACO)
C PSURMA : POINTEUR ASSOCIE (DELIMITANT LES SURFACES) (DIM NSUCO+1)
C CONTNO : LISTE DES NOEUDS DE CONTACT (DIM NNOCO)
C PSURNO : POINTEUR ASSOCIE (DELIMITANT LES SURFACES) (DIM NSUCO+1)
C SANSNO : LISTE DES NOEUDS INTERDITS COMME ESCLAVES (MOTS-CLES
C          SANS_NOEUD ET SANS_GROUP_NO)
C PSANS  : POINTEUR ASSOCIE (DIM NZOCO+1)
C MANOCO : TABLEAU DONNANT POUR CHAQUE NOEUD DE CONTACT LA LISTE DES
C          MAILLES DE CONTACT DE LA MEME SURFACE LE CONTENANT
C PMANO  : POINTEUR DE CE TABLEAU (DIM NNOCO+1)
C NMANO  : DIMENSION DE MANOCO
C NOMACO : TABLEAU DONNANT POUR CHAQUE MAILLE DE CONTACT LA LISTE DES
C          NOEUDS DE CONTACT DE LA MEME SURFACE QU'ELLE CONTIENT
C PNOMA  : POINTEUR DE CE TABLEAU (DIM NMACO+1)
C NNOMA  : DIMENSION DE NOMACO
C MAMACO : TABLEAU DONNANT POUR CHAQUE MAILLE DE CONTACT LA LISTE DES
C          MAILLES DE CONTACT DE LA MEME SURFACE ADJACENTES
C          (INDICE DANS CONTMA, PAS LE NUMERO DE MAILLE ABSOLU)
C PMAMA  : POINTEUR DE CE TABLEAU (DIM NMACO+1)
C NMAMA  : DIMENSION DE MAMACO
C NDIMCO : (NDIM NZOCO NSUCO NMACO NNOCO NMANO NNOMA NMAMA NESMAX ...)
C          OU NDIM   = DIM DE L'ESPACE (2 OU 3)
C          ET NESMAX = NOMBRE MAXIMAL DE NOEUDS ESCLAVES
C JEUSUP : TABLEAU DONNANT ZONE PAR ZONE LE JEU FICTIF R8 (A SOUSTRAIRE
C          AU VRAI JEU : SOMME DES JEUX DONNES PAR L'UTILISATEUR SOUS
C          DIST_MAIT ET DIST_ESCL), ZONE PAR ZONE (DIM NZOCO).
C JEUFO1 : TABLEAU DE FONCTIONS DONNANT ZONE PAR ZONE LE JEU FICTIF (A
C          SOUSTRAIRE AU VRAI JEU) DONNE PAR L'UTILISATEUR SOUS LE MOT-
C          CLE DIST_MAIT DANS AFFE_CHAR_MECA_F POUR CHAQUE ZONE 
C          (DIM NZOCO)
C JEUFO2 : TABLEAU DE FONCTIONS DONNANT ZONE PAR ZONE LE JEU FICTIF (A
C          SOUSTRAIRE AU VRAI JEU) DONNE PAR L'UTILISATEUR SOUS LE MOT-
C          CLE DIST_ESCL DANS AFFE_CHAR_MECA_F POUR CHAQUE ZONE
C          (DIM NZOCO)
C NOZOCO : TABLEAU DONNANT LE NUMERO DE ZONE POUR CHAQUE NOEUD DE
C          CONTACT (DIM NNOCO)
C CARACF : DIVERSES INFORMATIONS POUR LES METHODES
C          "CONTINUE" (ECP),"LAGRANGIEN" (LAG) ET "PENALISATION" (PENA)
C   CARACF (1) = NOMBRE DE ZONES DE CONTACT NZOCO (ECP)
C   POUR LA ZONE N :
C   CARACF(1+6*(N-1)+1) = TYPE D'INTEGRATION (ECP)
C     -  1. SI INTEGRATION AU NOEUD
C     -  2. SI INTEGRATION AU POINT DE GAUSS
C   CARACF(1+6*(N-1)+2) = COEF. DE REGULARISATION DU CONTACT (ECP,PENA)
C   CARACF(1+6*(N-1)+3) = COEF. DE REGULARISATION DU FROTMT (ECP,PENA)
C   CARACF(1+6*(N-1)+4) = COEF. DE  FROTTEMENT DE COULOMB (ECP,LAG,PENA)
C   CARACF(1+6*(N-1)+5) = INDICATEUR DE PRESENCE DE FROTTEMENT (ECP)
C     -  1. SI PAS DE FROTTEMENT
C     -  3. SI PRESENCE DE FROTTEMENT
C   CARACF(1+6*(N-1)+6) = VALEUR DE COEF_MATR_FROT (LAG,PENA)
C ECPDON : INFORMATIONS PROPRES A LA METHODE CONTINUE (CONTACT ECP)
C   ECPDON (1) = INDICATEUR SI ON UTILISE CETTE METHODE
C     -  0 SI NON
C     -  1 SI OUI
C   POUR LA ZONE N :
C   ECPDON(1+6*(N-1)+1) = MODELE AXIS?
C     -  0 SI NON
C     -  1 SI OUI
C   ECPDON(1+6*(N-1)+2) = NB MAX D'ITERATION DE CONTACT
C   ECPDON(1+6*(N-1)+3) = NB MAX D'ITERATION DE FROTTEMENT
C   ECPDON(1+6*(N-1)+4) = NB MAX D'ITERATION DE FROTTEMENT
C   ECPDON(1+6*(N-1)+5) = NB MAX D'ITERATION DE SEUIL
C   ECPDON(1+6*(N-1)+6) = FORMULATION EN DEPL ou EN VITE
C     -  1 SI DEPL
C     -  2 SI VITE
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*8    K8BID,CHAR,NOMA,NOMO   
      CHARACTER*16   K16BID,NOMCMD,MOTFAC,TYPF
      INTEGER        IBID,IER,NOC
      CHARACTER*16   PHENOM,MODELI
      INTEGER        NSYME
      INTEGER        INDQUA
      INTEGER        NZOCO,NSUCO,NMACO,NNOCO,NNOQUA,NZOCP,NTRAV
      INTEGER        NMANO,NNOMA,NMAMA,ORDSTC

C ======================================================================
C --- INITIALISATION 
C ======================================================================
      CALL JEMARQ()
      
C ======================================================================
      CALL GETRES(K8BID,K16BID,NOMCMD)

      MOTFAC = 'CONTACT'
      NOMO = LIGRMZ(1:8)
      CHAR = CHARZ
      NOMA = NOMAZ

C ======================================================================
C --- RECUPERATION DU NOM DU PHENOMENE ET DE LA  MODELISATION          
C ======================================================================
      CALL DISMOI('F','PHENOMENE',NOMO,'MODELE',IBID,PHENOM,IER)
      CALL DISMOI('F','MODELISATION',NOMO,'MODELE',IBID,MODELI,IER)

C ======================================================================
C --- RECUPERATION DU NOMBRE DE ZONES DE CONTACT (NOMBRE D'OCCURENCES) 
C ======================================================================
      NZOCO = 0
      IF (MOTFAC.EQ.'CONTACT') THEN
        CALL GETFAC(MOTFAC,NZOCO)
      ELSE
        CALL UTMESS('F','CALICO_00',' MOT CLE FACTEUR INCONNU :'//
     &              MOTFAC)
      END IF

C --- PAS DE CONTACT
      IF (NZOCO.EQ.0) THEN 
        GOTO 999
      ENDIF

C ======================================================================
C --- DETERMINATION DU NOMBRE DE ZONES DE CONTACT SYMETRIQUES
C --- REMPLISSAGE DE LA SD ASSOCIEE
C ======================================================================

      NSYME = 0

      CALL SYMECO(CHAR,MOTFAC,NZOCO,NSYME)

C --> NSYME : NOMBRE TOTAL DE SURFACES SYMETRIQUES DE CONTACT
C --- NZOCO : NOMBRE TOTAL DE ZONES DE CONTACT (PRINCIPALES+SYMETRIQUES)
C --- NZOCP : NOMBRE ZONES PRINCIPALES DE CONTACT

      NZOCO = NZOCO + NSYME 
      NZOCP = NZOCO - NSYME


C ======================================================================
C --- SI LA METHODE EST 'PENALISATION' OU 'CONTINUE' -> INDQUA = 1
C --- CE DRAPEAU SERVIRA DANS L'APPEL DE NBNOEL ET PERMETTRA DE
C --- TRAITER LES NOEUDS MILIEUX DES MAILLES QUADRATIQUES         
C ======================================================================

      CALL QUADCO (CHAR,MOTFAC,NZOCP,INDQUA)     
      
C ======================================================================
C --- PREMIERE PASSE 
C --- DETERMINATION DU NOMBRE TOTAL DE SURFACES, DE MAILLES ET DE NOEUDS
C --- REMPLISSAGE DES POINTEURS PZONE, PSURMA, PSURNO ET PNOQUA
C ======================================================================

C --- CHOIX DE L'ORDRE DE STOCKAGE DANS LES VECTEURS
      CALL GETVTX (MOTFAC,'METHODE',1,1,1,TYPF,NOC)
      IF(TYPF(1:8).EQ.'CONTINUE') THEN 
        ORDSTC = 1
      ELSE
        ORDSTC = 0
      ENDIF

      CALL POINCO (CHAR,MOTFAC,NOMA,NZOCO,ORDSTC,INDQUA,
     +             NSUCO,NMACO,NNOCO,NNOQUA,NTRAV)

C --> NSUCO  : NOMBRE TOTAL DE SURFACES DE CONTACT
C --> NMACO  : NOMBRE TOTAL DE MAILLES DES SURFACES DE CONTACT
C --> NNOCO  : NOMBRE TOTAL DE NOEUDS DES SURFACES DE CONTACT
C --> NNOQUA : NOMBRE TOTAL DE NOEUDS QUADRATIQUES DES SURFACES DE 
C              CONTACT
C --> NTRAV  : NOMBRE MAXIMUM DE GROUPES ET DE MAILLES IMPLIQUES DANS 
C              LE CONTACT (TOUTES ZONES CONFONDUES)

C ======================================================================
C --- RECUPERATION DES CARACTERISTIQUES DU CONTACT 
C ======================================================================

      CALL CARACO(CHAR,MOTFAC,NOMA,NOMO,NDIM,NZOCO,NNOQUA)

C ======================================================================
C --- REMPLISSAGE DES TABLEAUX METHCO, JEUSUP, CONTMA ET CONTNO 
C ======================================================================

      CALL LISTCO(CHAR,MOTFAC,NOMA,NTRAV,NZOCO,ORDSTC,
     +            NMACO,NNOCO,NNOQUA)
 
C ======================================================================
C --- ELIMINATION DES REDONDANCES DE NOEUDS ET DE MAILLES AU SEIN 
C --- D'UNE MEME SURFACE. MODIFICATION DES POINTEURS.
C --- STOCKAGE DES NOEUDS DECLARES SOUS 'SANS_NOEUD' ET 'SANS_GROUP_NO'.
C ======================================================================

      CALL ELIMCO(CHAR,NOMA,NZOCO,NSUCO,NMACO,NNOCO,NNOQUA)
      
C ======================================================================
C --- CONSTRUCTION DES CONNECTIVITES INVERSES                      
C ======================================================================

      CALL TABLCO(CHAR,NOMA,NZOCO,NSUCO,NMACO,NNOCO,
     &            NMANO,NNOMA,NMAMA)  

C --> NMANO  : DIMENSION DU TABLEAU INVERSE NOEUDS->MAILLES
C --> NNOMA  : DIMENSION DU TABLEAU DIRECT MAILLES->NOEUDS
C --> NMAMA  : DIMENSION DU TABLEAU DONNANT POUR CHAQUE MAILLE 
C              DE CONTACT LA LISTE
C              DES MAILLES DE CONTACT DE LA MEME SURFACE ADJACENTES
C              (ON STOCKE LA POSITION DANS CONTMA, PAS LE NUMERO ABSOLU)

C ======================================================================
C --- LONGUEURS DES DIFFERENTS VECTEURS 
C --- NOMBRE DE NOEUDS ESCLAVES MAXIMUM POUR CHAQUE ZONE 
C --- CALCUL DU NOMBRE MAXIMAL DE NOEUDS ESCLAVES DANS CHAQUE ZONE 
C --- DIMENSIONNEMENT DES TABLEAUX CONTENANT LES INFORMATIONS 
C --- POUR METHODES "PENALISATION" ET "LAGRANGIEN" 
C ======================================================================

      CALL DIMECO(CHAR,NOMA,NDIM,NZOCO,NSUCO,NMACO,NNOCO,
     &                  NMANO,NNOMA,NMAMA) 

C ======================================================================
C --- RELATIONS LINEAIRES POUR MAILLES QUADRATIQUES SURFACIQUES 
C ---  RELATION LINEAIRE ENTRE NOEUD MILIEU ET NOEUDS SOMMETS
C ---  ELIMINATION DES NOEUDS MILIEUX DU CONTACT DANS EXNOEL
C --- CECI EST FAIT:
C ---   POUR LES QUAD8 ET TRIA6 -> SYSTEMATIQUEMENT
C ---   POUR LES QUAD9 ET TRIA7 -> SEULEMENT POUR LES COQUE_3D
C --- POUR TOUTES LES AUTRES MAILLES QUADRATIQUES EN CONTACT,
C --- LES NOEUDS MILIEUX SONT DANS
C ======================================================================
      IF (FONREE.NE.'COMP') THEN
         CALL CACOEQ(FONREE,CHAR,NOMA)
      ENDIF
C ======================================================================
C --- IMPRESSIONS SUR LES ZONES/SURFACES/MAILLES/NOEUDS DE CONTACT 
C ======================================================================

      CALL SURFCO(CHAR,NOMA)


 999  CONTINUE
C ======================================================================
      CALL JEDEMA()
C
      END
