      SUBROUTINE LISTCO (CHAR,MOTFAC,NOMA,NTRAV,NZOCO,ORDSTC,
     &                   NMACO,NNOCO,NNOQUA)
     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 07/10/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
      IMPLICIT     NONE
      CHARACTER*8  CHAR
      CHARACTER*16 MOTFAC
      CHARACTER*8  NOMA
      INTEGER      NTRAV
      INTEGER      NZOCO   
      INTEGER      ORDSTC   
      INTEGER      NMACO
      INTEGER      NNOCO
      INTEGER      NNOQUA
C
C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : CALICO
C ----------------------------------------------------------------------
C
C STOCKAGE DES MAILLES ET NOEUDS DE CONTACT DES DIFFERENTES SURFACES.
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  MOTFAC : MOT-CLE FACTEUR (VALANT 'CONTACT')
C IN  NOMA   : NOM DU MAILLAGE
C IN  NTRAV  : NOMBRE MAXIMUM DE GROUPES ET DE MAILLES IMPLIQUES DANS 
C              LE CONTACT (TOUTES ZONES CONFONDUES)
C IN  NZOCO  : NOMBRE DE ZONES DE CONTACT
C IN  ORDSTC : ORDRE DE STOCKAGE DES ZONES MAITRES ET ESCLAVES
C              0: MAITRES PUIS ESCLAVES
C              1: ESCLAVES PUIS MAITRES
C IN  NMACO  : NOMBRE TOTAL DE MAILLES DES SURFACES DE CONTACT
C IN  NNOCO  : NOMBRE TOTAL DE NOEUDS DES SURFACES DE CONTACT
C IN  NNOQUA : NOMBRE TOTAL DE NOEUDS QUADRATIQUES DES SURFACES DE 
C              CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C

      CHARACTER*24 PZONE,PSURMA,PSURNO,PNOQUA
      INTEGER      JZONE,JSUMA,JSUNO,JNOQUA
      CHARACTER*24 CONTMA,CONTNO,CONOQU
      INTEGER      JMACO,JNOCO,JNOQU
      INTEGER      JTRAV
      INTEGER      NZOCP,NSYME
      INTEGER      IOC,IREAD,IWRITE,ISY
      CHARACTER*24 SYMECO
      INTEGER      JSYME      
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()

C --- NOMS JEVEUX
      SYMECO  = CHAR(1:8)//'.CONTACT.SYMECO'
      CALL JEVEUO(SYMECO,'L',JSYME)
      NSYME = ZI(JSYME)


      PZONE  = CHAR(1:8)//'.CONTACT.PZONECO'
      PSURMA = CHAR(1:8)//'.CONTACT.PSUMACO'
      PSURNO = CHAR(1:8)//'.CONTACT.PSUNOCO'
      PNOQUA = CHAR(1:8)//'.CONTACT.PNOEUQU'
      CALL JEVEUO(PZONE,'L',JZONE)
      CALL JEVEUO(PSURMA,'L',JSUMA)
      CALL JEVEUO(PSURNO,'L',JSUNO)
      CALL JEVEUO(PNOQUA,'L',JNOQUA)

      CONTMA = CHAR(1:8)//'.CONTACT.MAILCO'
      CONTNO = CHAR(1:8)//'.CONTACT.NOEUCO'
      CONOQU = CHAR(1:8)//'.CONTACT.NOEUQU'     
      CALL WKVECT(CONTMA,'G V I',NMACO,JMACO)
      CALL WKVECT(CONTNO,'G V I',NNOCO,JNOCO)
      IF (NNOQUA.NE.0) THEN
        CALL WKVECT(CONOQU,'G V I',3*NNOQUA,JNOQU)
      END IF

C --- AFFECTATION DU TABLEAU DE TRAVAIL ET INITIALISATION
      CALL WKVECT ('&&LISTCO.TRAV','V V K8',NTRAV,JTRAV)
                             
C --- ON NE BOUCLE QUE SUR LES ZONES PRINCIPALES: 
      NZOCP = NZOCO - NSYME

      IWRITE = 0
       
      DO 11 IOC = 1,NZOCP
         IREAD  = IOC
         IWRITE = IOC
         CALL LIEXCO (CHAR,MOTFAC,NOMA,IREAD,IWRITE,JTRAV,ORDSTC,
     +                   JZONE,JSUMA,JSUNO,JNOQUA,
     +                   JMACO,JNOCO,JNOQU)
   11 CONTINUE  

C --- ON BOUCLE SUR LES ZONES PRINCIPALES MAIS ON AGIT SUR LES 
C      ZONES SYMETRIQUES
      IF (NSYME.GT.0) THEN  

         IF (ORDSTC.EQ.1) ORDSTC = 0
         IF (ORDSTC.EQ.0) ORDSTC = 1

         DO 6 IOC = 1,NZOCP
            IREAD = IOC
            DO 7 ISY = 1,NSYME       
               IF (ZI(JSYME+ISY) .EQ.IOC) THEN
                IWRITE = IWRITE+1
                CALL LIEXCO (CHAR,MOTFAC,NOMA,IREAD,IWRITE,JTRAV,ORDSTC,
     +                 JZONE,JSUMA,JSUNO,JNOQUA,
     +                 JMACO,JNOCO,JNOQU)
               ENDIF
  7         CONTINUE             
  6      CONTINUE      
         IF (ORDSTC.EQ.1) ORDSTC = 0
         IF (ORDSTC.EQ.0) ORDSTC = 1   
      ENDIF

      CALL JEDETR ('&&LISTCO.TRAV')

C ----------------------------------------------------------------------
C
      CALL JEDEMA()
      END
