      SUBROUTINE IRCMPR ( NOFIMD,
     >                    NCMPRF, NCMPVE, NTLCMP,
     >                    NBVATO, NBENEC, LIENEC, ADSD, ADSL,
     >                    SUPNOE, TYPMAI,
     >                    NMATYP, NOPFTY, NTPROA,
     >                    NVAL, NVALTY, NBPGTY, NBSPTY )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 22/07/2003   AUTEUR LAVERNE J.LAVERNE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C RESPONSABLE GNICOLAS G.NICOLAS
C_______________________________________________________________________
C     ECRITURE D'UN CHAMP -  FORMAT MED - CREATION DU PROFIL
C        -  -       -               -                 --
C_______________________________________________________________________
C     ENTREES :
C       NOFIMD : NOM DU FICHIER MED
C       NCMPRF : NOMBRE DE COMPOSANTES DU CHAMP DE REFERENCE
C       NCMPVE : NOMBRE DE COMPOSANTES VALIDES EN ECRITURE
C       NTLCMP : SD DES NUMEROS DES COMPOSANTES VALIDES
C       NBVATO : NOMBRE DE VALEURS TOTALES
C       NBENEC : NOMBRE D'ENTITES A ECRIRE (O, SI TOUTES)
C       LIENEC : LISTE DES ENTITES A ECRIRE SI EXTRAIT
C       ADSK, D, ... : ADRESSES DES TABLEAUX DES CHAMPS SIMPLIFIES
C       SUPNOE : VRAI OU FAUX SELON QUE L'ON A UN CHAMP AUX NOEUDS
C       TYPMAI : SD TYPE ASTER POUR CHAQUE MAILLE
C     SORTIES :
C       NOPFTY : NOM DES PROFILS AU SENS MED
C       NTPROA : SD DU PROFIL ASTER. C'EST LA LISTE DES NUMEROS ASTER
C                DES NOEUDS OU DES ELEMENTS POUR LESQUELS LE CHAMP
C                EST DEFINI
C       SI NOEUD :
C       NVAL   : NOMBRE DE VALEURS EFFECTIVES
C       SI ELEMENTS :
C       NMATYP : NOMBRE DE MAILLES POUR CHAQUE TYPE DE SUPPORT
C       NVALTY : NOMBRE DE VALEURS UTILES POUR CHAQUE TYPE DE SUPPORT
C       NBPGTY : NOMBRE DE POINTS DE GAUSS POUR CHAQUE TYPE DE SUPPORT
C       NBSPTY : NOMBRE DE SOUS-POINTS POUR CHAQUE TYPE DE SUPPORT
C_______________________________________________________________________
C
      IMPLICIT NONE
C
C 0.1. ==> ARGUMENTS
C
      INTEGER NVAL, NVALTY(*),NBPGTY(*), NBSPTY(*)
      INTEGER NMATYP(*)
      INTEGER NBVATO, NCMPRF, NCMPVE
      INTEGER NBENEC
      INTEGER LIENEC(*)
      INTEGER ADSD, ADSL
C
      CHARACTER*(*) NOFIMD
      CHARACTER*(*) NTLCMP, NTPROA, TYPMAI
      CHARACTER*32 NOPFTY(0:*)
C
      LOGICAL SUPNOE
C
C 0.2. ==> COMMUNS
C --------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER      ZI
      COMMON /IVARJE/ZI(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX --------------------------
C
C 0.3. ==> VARIABLES LOCALES
C
      CHARACTER*6 NOMPRO
      PARAMETER ( NOMPRO = 'IRCMPR' )
C
      INTEGER NTYMAX
      PARAMETER (NTYMAX=48)
C
      CHARACTER*32 EDNOPF
C                         12345678901234567890123456789012
      PARAMETER ( EDNOPF='                                ' )
C
      INTEGER IFM, NIVINF
      INTEGER IAUX
      INTEGER ADTYPM
C
C     RECUPERATION DU NIVEAU D'IMPRESSION
C     -----------------------------------
C
      CALL INFNIV ( IFM, NIVINF )
C
      IF ( NIVINF.GT.1 ) THEN
        WRITE (IFM,1001) 'DEBUT DE '//NOMPRO
      ENDIF
 1001 FORMAT(/,10('='),A,10('='),/)
C
C====
C 1. PREALABLES
C    CELA SERT A INTIALISER LES NOMBRES DE VALEURS POUR LE TYPE NON
C    SELECTIONNE
C====
C
      NVAL = 0
      NOPFTY(0) = EDNOPF
      DO 11 , IAUX = 1 , NTYMAX
        NVALTY(IAUX) = 0
        NBPGTY(IAUX) = -1
        NBSPTY(IAUX) = -1
        NMATYP(IAUX) = 0
        NOPFTY(IAUX) = EDNOPF
   11 CONTINUE
C
C====
C 2. APPELS DES PROGRAMMES SPECIFIQUES
C====
C
      IF ( SUPNOE ) THEN
C
C 2.1. ==> LES NOEUDS
C
        CALL IRCMPN ( NOFIMD,
     >                NCMPRF, NCMPVE, NTLCMP,
     >                NBVATO, NBENEC, LIENEC, ADSL,
     >                NTPROA, NOPFTY, NVAL )
C
      ELSE
C
C 2.2. ==> LES ELEMENTS
C
        CALL JEVEUO ( TYPMAI, 'L', ADTYPM )
C
        CALL IRCMPE ( NOFIMD,
     >                NCMPVE, NTLCMP,
     >                NBVATO, NBENEC, LIENEC, ADSD, ADSL,
     >                ZI(ADTYPM), NMATYP,
     >                NTPROA, NOPFTY, NVALTY, NBPGTY, NBSPTY )
C
      ENDIF
C
      IF ( NIVINF.GT.1 ) THEN
        WRITE (IFM,1001) 'FIN DE '//NOMPRO
      ENDIF
C
      END
