      SUBROUTINE QUAVRO (TETA,   QUAT)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 18/07/2001   AUTEUR ADBHHPM P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C TOLE CRP_6
C
C FONCTION: CALCULE LE VECTEUR-ROTATION TETA CORRESPONDANT AU QUATERNION
C           QUAT.
C
C     IN  : QUAT      : QUATERNION
C
C     OUT : TETA      : VECTEUR-ROTATION
C ------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 QUAT(4),TETA(3),RESTE
C
      ZERO  = 0.D0
      EPSIL = R8PREM( )**2
      DEUX  = 2.D0
      PI = 3.14159265D0
C
      CALL PSCAL (3,QUAT,QUAT,PROSCA)
      ANORX = SQRT(PROSCA)
      IF(ANORX.GT.1.D0) ANORX = 1.D0
      IF (ANORX.LT.EPSIL) THEN
         DO 1 I=1,3
         TETA(I) = ZERO
1        CONTINUE
         GOTO 9999
      ENDIF
      RESTE = ASIN(ANORX)
C
      IF(QUAT(4).LT.ZERO) RESTE = PI - RESTE
C
      COEF = DEUX*RESTE/ANORX
C
      DO 10 I=1,3
         TETA(I) = COEF * QUAT(I)
10     CONTINUE
 9999 CONTINUE
      END
