      SUBROUTINE ZASTER(IEL, MODELE, NVAR, NDEF, NUNIT, INSTAM, INSTAP,
     &       TM,TP,TREF,EPSM,DEPS,SIGM,VIM,NOPT,ANGMAS,SIGP,VIP,
     &       DSIDEP,CODRET)
      IMPLICIT NONE
C AJOUT FERMETUR
C--------------------------------------------------------------
C BUT : ROUTINE D'INTERFACE ENTRE CODE_ASTER ET LA BIBLIOTHEQUE
C       ZMAT D'INTEGRATION DE LOIS DE COMPORTEMENTS.
C
C IN :
C  IEL     (I) : NUMERO DE L'ELEMENT
C  MODELE  (I) : TYPE DE MODELE (1:3D, 2:AXIS, 3:D_PLAN, 4)
C  NVAR    (I) : NOMBRE DE VARIABLES INTERNES
C  NDEF    (I) : GRDES DEFORMATIONS (2:SIMO_MIEHE, 1:PETIT)
C  NUNIT   (I) : NUMERO DE L'UNITE LOGIQUE QUI CONTIENT LES DONNEES
C                POUR LE COMPORTEMENT ZMAT
C  INSTAM (R8) : INSTANT DU CALCUL PRECEDENT
C  INSTAP (R8) : INSTANT DU CALCUL
C  TM     (R8) : TEMPERATURE A L'INSTANT PRECEDENT
C  TP     (R8) : INSTANT DU CALCUL
C  TREF   (R8) : TEMPERATURE REFERENCE POUR LES CONTRAINTES THERMIQUES
C  EPSM  (R8*) : DEFORMATIONS A L'INSTANT DU CALCUL PRECEDENT
C  DEPS  (R8*) : INCREMENT DE DEFORMATION TOTALE :
C                   DEPS(T) = DEPS(MECANIQUE(T)) + DEPS(DILATATION(T))
C  SIGM  (R8*) : CONTRAINTES A L'INSTANT DU CALCUL PRECEDENT
C  VIM   (R8*) : VARIABLES INTERNES A L'INSTANT DU CALCUL PRECEDENT
C  NOPT    (I) : OPTION (1:RIGI_MECA_TANG, 2:FULL_MECA , 3:RAPH_MECA)
C  ANGMAS  : LES TROIS ANGLES DU MOT_CLEF MASSIF (AFFE_CARA_ELEM)
C
C IN/OUT :
C  VIP   (R8*) : VARIABLES INTERNES
C                IN  : ESTIMATION (ITERATION PRECEDENTE OU LAG. AUGM.)
C                OUT : EN T+
C
C OUT :
C  SIGP   (R8*) : CONTRAINTES A L'INSTANT DU CALCUL
C  DSIDEP (R8*) : MATRICE CARREE
C---------------------------------------------------------------
      INTEGER            IEL, MODELE, NVAR, NDEF, NUNIT, NOPT, CODRET 
      REAL*8             INSTAM, INSTAP, TM, TP, TREF
      REAL*8             EPSM(*), DEPS(*), DSIDEP(*)
      REAL*8             SIGM(*), VIM(*), SIGP(*), VIP(*)
      REAL*8             ANGMAS(3)

      CALL UTMESS('F','ZASTER','LA BIBLIOTHEQUE "ZMAT" EST INDISPONIBLE'
     &            //' SUR CETTE MACHINE.')

      END
