# -*- coding: iso-8859-1 -*-
# ==============================================================================
# COPYRIGHT (C) 1991 - 2003  EDF R&D                  WWW.CODE-ASTER.ORG
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
# IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
# THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
# (AT YOUR OPTION) ANY LATER VERSION.
#
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
# WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.
#
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
# ==============================================================================

# $Id: mprint.py,v 1.1 2005/06/27 14:06:08 mcourtoi Exp $
# $Name:  $

import sys
import re
from types import *
EnumTypes=(ListType, TupleType)

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
class MPRINT:
   """This class encapsulates standard print statement.
   """
#-------------------------------------------------------------------------------
   def __init__(self, filename=None, mode='a'):
      """filename : name of log file ; mode = 'w'/'a'
      """
      self.mode   = mode
      self.stderr = sys.stderr
      if filename is None:
         filename  = 'stdout'
         self.logf = sys.stdout
      else:
         self.logf = open(filename, mode)
      self.file   = filename
      sys.stderr  = self.logf

#-------------------------------------------------------------------------------
   def __del__(self):
      """Close file properly on deletion.
      """
      sys.stderr = self.stderr
      self.logf.close()

#-------------------------------------------------------------------------------
   def _print(self, *args, **kargs):
      """print replacement.
      Optionnal argument :
       term  : line terminator (default to '\n').
      """
      term=kargs.get('term','\n')
      files=[sys.stdout]
      files.append(self.logf)
      for f in files:
         if type(f) is FileType:
            str=' '.join(['%s'%a for a in args])
            f.write(str.replace('\n ','\n')+term)
         else:
            print 'Unexpected object %s : %s' % (type(f), repr(f))

